
/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: DSPManager.java 3867 2003-04-25 11:26:40Z dbuytaert $
*/

package com.acunia.wonka.rudolph;


public class DSPManager {

  public static final boolean USE_DSP_MANAGER = false;

  private static DSPManager manager = new DSPManager();

  public static synchronized void setMute(boolean on){
    manager.manageMute(on);
  }

  private int requestCount;
  private boolean muted;

  private DSPManager(){}

  private synchronized void manageMute(boolean on){
    if(on){
      requestCount++;
      while(muted){
        try {
          this.wait();
        }
        catch(InterruptedException ie){}
      }
      if(requestCount > 1){
        try {
          Process p = Runtime.getRuntime().exec("/sbin/gpio -p /dev/gpio2 -s 1");
          p.waitFor();
        }
        catch(Exception ie){}
      }
      this.muted = true;
    }
    else {
      this.muted = false;
      requestCount--;
      if(requestCount > 0){
        //wake up the next in line.
        this.notify();
      }
      else {
        //no one left waiting ...
        try {
          Process p = Runtime.getRuntime().exec("/sbin/gpio -p /dev/gpio2 -c 1");
          p.waitFor();
        }
        catch(Exception ie){}
      }
    }
  }


}

