/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: ImageCache.java 4254 2005-10-28 08:12:16Z chris $
*/

package com.acunia.wonka.rudolph;

import java.lang.ref.*;

public class ImageCache {
  
  private wonka.vm.IntHashtable hashtable = new wonka.vm.IntHashtable();
  
  private ReferenceQueue queue = new ReferenceQueue();

  private void checkQueue() {
    SoftReference sf = (SoftReference)queue.poll();
    if(sf != null) {
//      System.out.println(" WHOA: It got collected");
    }
  }

  public Object get(int key) {
    checkQueue();
    SoftReference result = (SoftReference)hashtable.get(key);
    return (result == null ? null : result.get());
  }

  public Object put(int key, Object newvalue) {
    checkQueue();
    SoftReference result = (SoftReference)hashtable.put(key, new SoftReference(newvalue, queue));
    return (result == null ? null : result.get());
  }

  public Object remove(int key) {
    SoftReference result = (SoftReference)hashtable.remove(key);
    return (result == null ? null : result.get());
  }

}

