
/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: Painter.java 3867 2003-04-25 11:26:40Z dbuytaert $
*/

package com.acunia.wonka.rudolph;

public final class Painter implements Runnable {

  private static Painter thePainter;

  private int priority = Thread.MAX_PRIORITY;
  private boolean keepOnGoing = false;
  private Thread thread = null;

  private Painter() {
  }

  public static synchronized Painter getInstance() {
    if (thePainter == null) thePainter = new Painter();
    return thePainter;
  }

  public native void run(); 

  public void start() {
    if(!keepOnGoing) {
      keepOnGoing = true;
      thread = new Thread(this, "Picasso");
      thread.setPriority(priority);
      thread.setDaemon(false);
      thread.start();
    }
  }

  public void stop() {
    keepOnGoing = false;
    thread = null;
  }

}

