###########################################################################
# Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      #
#                                                                         #
# This software is copyrighted by and is the sole property of Acunia N.V. #
# and its licensors, if any. All rights, title, ownership, or other       #
# interests in the software remain the property of Acunia N.V. and its    #
# licensors, if any.                                                      #
#                                                                         #
# This software may only be used in accordance with the corresponding     #
# license agreement. Any unauthorized use, duplication, transmission,     #
#  distribution or disclosure of this software is expressly forbidden.    #
#                                                                         #
# This Copyright notice may not be removed or modified without prior      #
# written consent of Acunia N.V.                                          #
#                                                                         #
# Acunia N.V. reserves the right to modify this software without notice.  #
#                                                                         #
#   Acunia N.V.                                                           #
#   Philips-site 5, box 3       info@acunia.com                           #
#   3001 Leuven                 http://www.acunia.com                     #
#   Belgium - EUROPE                                                      #
###########################################################################

.file "call-stack.s"

.text
.align 4
.global cs_skip_remainder

#
# cs_skip_remainder(unsigned int address)
#
#   Skip the remainder of the JIT-ed method by setting the current 
#   return address to the specified address.  Make sure that:
#
#    1. the given address points to the start of the JIT-ed method's
#       epilogue such that it will take care of restoring all callee 
#       saved registers (if any).
#
#    2. the register that usually holds the return value is cleared or a
#       temporary value (non-reference) might end up in the stack slot
#       of a reference (see "native_xxx_reference()" in "dispatcher.c").
# 

cs_skip_remainder:
  ldr r11, [r11, #-12]           @ retrieve the caller's frame pointer
  ldr r11, [r11, #-12]           @ retrieve the caller's frame pointer
  mov r1, r0                     @ move the specified return address to r1
  eor r0, r0, r0                 @ clear the return value
  mov pc, r1                     @ return

