#ifndef _J_CODE_GENERATOR_H
#define _J_CODE_GENERATOR_H

/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: code-generator.h 4026 2003-07-10 09:27:02Z dbuytaert $ 
*/


void cg_spill(j_node instruction, j_node variable);
  /* The front end calls this function to emit spill code for the specified node. */

void cg_init(void);
  /* The front end calls this function to initialize the backend. */

void cg_prologue(void);
  /* The front end calls this function to emit the prologue of a code block. */
  
void cg_epilogue(void);
  /* The font end calls this function to emit the epilogue of a code block. */

void cg_node2register(j_node node, int r);
  /* Move the specified node into the given register. */

/*
** Generated machine code is written to main memory through the data 
** cache.  When using a write-back cache strategy, data may or may not
** be kept in the cache and main memory might or might not be 
** up-to-date.  So whenever we want to execute generated machine code, 
** or that is to say, whenever we want data to become instructions, 
** both data and instruction cache need flushing to avoid cache 
** coherency problems.  The backend will call 'cg_clear_cache()' when
** it expects data and instruction cache to be cleared.
*/
void cg_clear_cache(char * begin, char * end);
  /* Clear data and instruction cache. */ 
  
j_word * cg_disassemble(j_word * address);
  /* Disassemble the instruction at the specified address and dump it to the screen. */

#endif
