#ifndef _J_IR_H
#define _J_IR_H

/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: ir.h 3863 2003-04-25 09:23:25Z dbuytaert $ 
*/

#include "method.h"
#include "node.h"

#define j_link_next        -1
#define j_link_none        -2
#define j_insert_before     0
#define j_insert_after      1

typedef enum {
  j_no_boundary = 0,
  j_implicit = 1,
  j_explicit = 2
} j_boundary;

void ir_add_node(j_node node, int tedge, int fedge);
  /* Add a node to the control flow graph with the specified 'true' and 'false' edges. */

j_node ir_get_node_next(int pc);
  /* Get the node at the specified program counter or the next one. */

j_node ir_get_node_prev(int pc);
  /* Get the node at the specified program counter or the previous one. */

j_node ir_get_branch(j_node node);
  /* Get the outgoing node that branches. */

int ir_is_jump(j_node node);
  /* Check whether the given node is a conditional or unconditional jump. */
 
int ir_is_join(j_node node);
  /* Check whether the given node is a join point. */

int ir_is_exit(j_node node);
  /* Check whether the given node is an exit point. */

j_boundary ir_is_basic_block_entry(j_node node);
  /* Check whether the given node is a basic block entry. */
 
j_boundary ir_is_basic_block_exit(j_node node);
  /* Check whether the given node is a basic block exit. */
 
int ir_is_split(j_node node);
  /* Check whether the given node is a split point. */

void ir(void);
  /* Construct the control flow graph. */

#endif /* _J_IR_H */
