#ifndef _J_SPOT_H
#define _J_SPOT_H

/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: j-spot.h 3863 2003-04-25 09:23:25Z dbuytaert $ 
*/

#include <assert.h>
#include <stdio.h>
#include "wonka.h"

/*
** Type definitions
*/

typedef unsigned int j_word;
typedef struct j_Assembler * j_assembler;
typedef struct j_Method * j_method;
typedef struct j_Buffer * j_buffer;
typedef struct j_Block * j_block;
typedef struct j_Patch * j_patch;
typedef struct j_State * j_state;
typedef struct j_Node * j_node;

/* 
**`flarp' is yet another metasyntactic variable like foo, mummble, woempa.
** Among those who use it, it is associated with a legend that any program
** not containing the word `flarp' somewhere will not work.  The legend is
** discreetly silent on the reliability of programs which _do_ contain the
** magic word:
*/

#ifdef DEBUG
  #define j_flarp(color, format, a...)   \
    fprintf(stderr, "\e[1;3%dm", color); \
    woempa(9, format, ##a);              \
    fprintf(stderr, "\e[m")
#else 
  #define j_flarp(color, format, a...)
#endif
    
/*
** The color codes that can be used by flarp:
*/

#define red      0x01
#define green    0x02
#define yellow   0x03
#define blue     0x04
#define purple   0x05
#define magenta  0x06
#define white    0x07

void joempa(char * format, ...);
  /* Send debug output to stderr. */

void jfail(char * format, ...);
  /* Report a compilation failure. */
  
void jabort(char * format, ...);
  /* Report an internal compiler error (ICE). */
  
void jspot_init(void);
  /* Initialize J-spot. */

void jspot_help(void);
  /* Print J-spot's help message. */

void jspot_parse_arguments(void);
  /* Parse the J-spot specific command line arguments. */

int jspot_check_nrange(char * range, int call);
  /* Check a numerical range.*/

int jspot_check_arange(char * range, w_string string);
  /* Check a alpha-numerical range. */

j_method jm;

#endif 
