#ifndef _J_REGISTER_ALLOCATOR_H
#define _J_REGISTER_ALLOCATOR_H

/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: register-allocator.h 4030 2003-07-10 13:53:01Z dbuytaert $ 
*/

int ra_is_free(int reg);

int ra_in_register(j_node node);

int ra_on_stack(j_node node);

void ra_spill(j_node instruction, j_node variable);

void ra_assign(j_node instruction, j_node variable, int reg);

void ra_allocate(j_node instruction, j_node variable);

void ra_consume(j_node node);

int ra_stack_slot(j_node instruction, j_node variable);

void ra_basic_block_entry(j_node node);

void ra_basic_block_exit(j_node node);

void ra_clear_all(void);

void ra_split_all(void);

void ra_dump_registers(void);

#endif
