/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class ArrayTest  {
 
  int array[] = new int[10];

  /*
  ** The "int_" functions will never be compiled.
  */

  public int int_object(int x) {
    Integer array[] = new Integer[10];
    array[x] = new Integer(x);
    return array[x].intValue();
  }

  public int int_integer(int x) {
    int array[] = new int[10];
    array[x] = x;
    return array[x];
  }
  
  public short int_short(int x) {
    short array[] = new short[10];
    array[x] = (short)x;
    return array[x];
  }

  public boolean int_boolean(int x) {
    boolean array[] = new boolean[10];
    array[x] = true;
    return array[x];
  }

  public byte int_byte(int x) {
    byte array[] = new byte[10];
    array[x] = (byte)x;
    return array[x];
  }

  public char int_character(int x) {
    char array[] = new char[10];
    array[x] = (char)x;
    return array[x];
  }

  public float int_float(int x) {
    float array[] = new float[10];
    array[x] = (float)x;
    return array[x];
  }

  public int int_aload(int array[], int i) {
    return array[i];
  }

  public int int_aload_exception(int array[], int i) {
    try {
      return int_aload(array, i);
    }
    catch (NullPointerException e) {
      return -1;
    }
    catch (ArrayIndexOutOfBoundsException e) {
      return -2;
    }
  }

  public int int_arraylength_object(Object array[]) {
    return array.length;
  }

  public int int_arraylength_integer(int array[]) {
    return array.length;
  }

  public int int_arraylength_short(short array[]) {
    return array.length;
  }

  public int int_arraylength_boolean(boolean array[]) {
    return array.length;
  }

  public int int_arraylength_byte(byte array[]) {
    return array.length;
  }

  public int int_arraylength_character(char array[]) {
    return array.length;
  }

  public int int_arraylength_float(float array[]) {
    return array.length;
  }

  public int int_arraylength_exception(int array[]) {
    try {
      return int_arraylength_integer(array);
    }
    catch (NullPointerException e) {
      return -1;
    }
  }
 
  public int int_1dim_1(int x, int y) {
    int array[] = this.array;

    for (int k = 0; k < 10; k++) {
      array[x] = y;
    }

    return array[x];
  }

  public int int_2dim_1(int x, int y) {
    int array[][] = new int[10][10];
    array[x][y] = 42;
    return array[x][y];
  }
 
  public int int_2dim_2(int x, int y) {
    int array[][] = new int[10][10];

    for (int k = 0; k < 10; k++) {
      array[k][k] = k;
    }

    return array[x][y];
  }

  public int int_2dim_3(int x, int y) {
    int array[][] = new int[10][10];
 
    for (int k = 0; k < 10; k++) {
      for (int l = 0; l < 10; l++) {
        array[k][l] = k + l;
      }
    }

    return array[x][y];
  }
  
  public int int_3dim_1(int x, int y, int z) {
    int array[][][] = new int[10][10][10];
 
    for (int k = 0; k < 10; k++) {
      for (int l = 0; l < 10; l++) {
        for (int m = 0; m < 10; m++) {
          array[k][l][m] = k + l + m;
        }
      }
    }

    return array[x][y][z];
  }

  /*
  ** The "com_" functions will always be compiled.
  */

  public int com_object(int x) {
    Integer array[] = new Integer[10];
    array[x] = new Integer(x);
    return array[x].intValue();
  }

  public int com_integer(int x) {
    int array[] = new int[10];
    array[x] = x;
    return array[x];
  }

  public short com_short(int x) {
    short array[] = new short[10];
    array[x] = (short)x;
    return array[x];
  }

  public boolean com_boolean(int x) {
    boolean array[] = new boolean[10];
    array[x] = true;
    return array[x];
  }
  
  public byte com_byte(int x) {
    byte array[] = new byte[10];
    array[x] = (byte)x;
    return array[x];
  }

  public char com_character(int x) {
    char array[] = new char[10];
    array[x] = (char)x;
    return array[x];
  }

  public float com_float(int x) {
    float array[] = new float[10];
    array[x] = (float)x; 
    return array[x];
  }

  public int com_aload(int array[], int i) {
    return array[i];
  }

  public int com_aload_exception(int array[], int i) {
    try {
      return com_aload(array, i);
    }
    catch (NullPointerException e) {
      return -1;
    }
    catch (ArrayIndexOutOfBoundsException e) {
      return -2;
    }
  }

  public int com_arraylength_object(Object array[]) {
    return array.length;
  }

  public int com_arraylength_integer(int array[]) {
    return array.length;
  }

  public int com_arraylength_short(short array[]) {
    return array.length;
  }

  public int com_arraylength_boolean(boolean array[]) {
    return array.length;
  }

  public int com_arraylength_byte(byte array[]) {
    return array.length;
  }

  public int com_arraylength_character(char array[]) {
    return array.length;
  }

  public int com_arraylength_float(float array[]) {
    return array.length;
  }

  public int com_arraylength_exception(int array[]) {
    try {
      return com_arraylength_integer(array);
    }
    catch (NullPointerException e) {
      return -1;
    }
  }

  public int com_1dim_1(int x, int y) {
    int array[] = this.array;

    for (int k = 0; k < 10; k++) {
      array[x] = y;
    }

    return array[x];
  }
 
  public int com_2dim_1(int x, int y) {
    int array[][] = new int[10][10];
    array[x][y] = 42;
    return array[x][y];
  }
 
  public int com_2dim_2(int x, int y) {
    int array[][] = new int[10][10];

    for (int k = 0; k < 10; k++) {
      array[k][k] = k;
    }

    return array[x][y];
  }

  public int com_2dim_3(int x, int y) {
    int array[][] = new int[10][10];
 
    for (int k = 0; k < 10; k++) {
      for (int l = 0; l < 10; l++) {
        array[k][l] = k + l;
      }
    }

    return array[x][y];
  }
  
  public int com_3dim_1(int x, int y, int z) {
    int array[][][] = new int[10][10][10];
 
    for (int k = 0; k < 10; k++) {
      for (int l = 0; l < 10; l++) {
        for (int m = 0; m < 10; m++) {
          array[k][l][m] = k + l + m;
        }
      }
    }

    return array[x][y][z];
  }

  public void run(JTest jt) {

    /*
    ** Test one-dimensional array operations that make use of 'newarray',
    ** 'xaload', 'xastore' and 'arraylength'.
    */

    for (int i = 0; i < 5; i++) {
      int array[] = new int[i];

      jt.check(int_object(i), com_object(i), "ArrayTest.com_object("+ i +")");
      jt.check(int_integer(i), com_integer(i), "ArrayTest.com_integer("+ i +")");
      jt.check(int_short(i), com_short(i), "ArrayTest.com_short("+ i +")");
      jt.check(int_boolean(i), com_boolean(i), "ArrayTest.com_boolean("+ i +")");
      jt.check(int_byte(i), com_byte(i), "ArrayTest.com_byte("+ i +")");
      jt.check(int_character(i), com_character(i), "ArrayTest.com_character("+ i +")");
      jt.check(int_float(i), com_float(i), "ArrayTest.com_float("+ i +")");
    }

    Object oa[] = { new Integer(0), new Integer(1), new Integer(2), new Integer(3) };
    int ia[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 };
    short sa[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 };
    boolean za[] = { true, false, true, false, true, false, true, false };
    byte ba[] = { 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15 };
    char ca[] = { 'a', 'b', 'c', 'd', 'e', 'f', 'h', 'i', 'j', 'k', 'l' };
    float fa[] = { 1.2f, 2.3f, 3.4f, 4.5f, 5.6f, 6.7f, 7.8f, 8.9f };

    for (int i = 0; i < 5; i++) {
      jt.check(int_arraylength_object(oa), com_arraylength_object(oa), "ArrayTest.com_arraylength_boolean("+ oa +")");
      jt.check(int_arraylength_integer(ia), com_arraylength_integer(ia), "ArrayTest.com_arraylength_integer("+ ia +")");
      jt.check(int_arraylength_short(sa), com_arraylength_short(sa), "ArrayTest.com_arraylength_short("+ sa +")");
      jt.check(int_arraylength_boolean(za), com_arraylength_boolean(za), "ArrayTest.com_arraylength_boolean("+ za +")");
      jt.check(int_arraylength_byte(ba), com_arraylength_byte(ba), "ArrayTest.com_arraylength_byte("+ ba +")");
      jt.check(int_arraylength_character(ca), com_arraylength_character(ca), "ArrayTest.com_arraylength_character("+ ca +")");
      jt.check(int_arraylength_float(fa), com_arraylength_float(fa), "ArrayTest.com_arraylength_float("+ fa +")");
    }

    /*
    ** The multi-dimensional array operations that make use of
    ** 'multianew', 'xaload', 'xastore'.
    */

    int d1[] = { 2, 2, 0, 0, 4, 5, 1, 9, 9, 9, 3, 7 };

    // One-dimensional arrays:
    for (int i = 0; i < 12; i = i + 2) {
      jt.check(int_1dim_1(d1[i + 0], d1[i + 1]), com_1dim_1(d1[i + 0], d1[i + 1]), "ArrayTest.com_1dim_1("+ d1[i + 0] +", "+ d1[i + 1] +")");
    }

    // Two-dimensional arrays:
    for (int i = 0; i < 12; i = i + 2) {
      jt.check(int_2dim_1(d1[i + 0], d1[i + 1]), com_2dim_1(d1[i + 0], d1[i + 1]), "ArrayTest.com_2dim_1("+ d1[i + 0] +", "+ d1[i + 1] +")");
      jt.check(int_2dim_2(d1[i + 0], d1[i + 1]), com_2dim_2(d1[i + 0], d1[i + 1]), "ArrayTest.com_2dim_2("+ d1[i + 0] +", "+ d1[i + 1] +")");
      jt.check(int_2dim_3(d1[i + 0], d1[i + 1]), com_2dim_3(d1[i + 0], d1[i + 1]), "ArrayTest.com_2dim_3("+ d1[i + 0] +", "+ d1[i + 1] +")");
    }
    
    // Three-dimensional arrays:
    for (int i = 0; i < 12; i = i + 3) {
      jt.check(int_3dim_1(d1[i + 0], d1[i + 1], d1[i + 2]), com_3dim_1(d1[i + 0], d1[i + 1], d1[i + 2]), "ArrayTest.com_3dim_1("+ d1[i + 0] +", "+ d1[i + 1] +", "+ d1[i + 2] +")");
    }

    /*
    ** Exceptions. 
    */

    int d2[][] = { { 1, 2, 3, 4, 5, 6 }, { 1, 2, 3, 4 }, null, null, { 1, 2 }, { 1, 2, 3, 4, 5, 6, 7, 8 }, null, { 1, 2, 3, 4, 5, 6, 7, 8, 9}, { 1, 2 }, null };

    for (int i = 0; i < 10; i++) {
      jt.check(int_arraylength_exception(d2[i]), com_arraylength_exception(d2[i]), "ArrayTest.com_arraylength_exception("+ d2[i] +")");
      jt.check(int_aload_exception(d2[i], i), com_aload_exception(d2[i], i), "ArrayTest.com_aload_exception("+ d2[i] +", "+ i +")");
    }
  }
}
