/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class ComparisonTest  {

  int foo = 4;
  int bar = 2;
 
  /*
  ** The "int_" functions will never be compiled.
  */

  public boolean int_if_icmplt(int x, int y) {
    return (x < y);
  }

  public boolean int_if_icmpgt(int x, int y) {
    return (x > y);
  }

  public boolean int_if_icmple(int x, int y) {
    return (x <= y);
  }

  public boolean int_if_icmpge(int x, int y) {
    return (x >= y);
  }

  public boolean int_if_icmpeq(int x, int y) {
    return (x == y);
  }

  public boolean int_if_icmpne(int x, int y) {
    return (x != y);
  }

  public boolean int_fcmp_l(float x, float y) {
    return (x < y);
  }

  public boolean int_fcmp_le(float x, float y) {
    return (x <= y);
  }
   
  public boolean int_fcmp_g(float x, float y) {
    return (x > y);
  }
    
  public boolean int_fcmp_ge(float x, float y) {
    return (x >= y);
  }
    
  public boolean int_fcmp_ne(float x, float y) {
    return (x != y);
  }

  public boolean int_fcmp_e(float x, float y) {
    return (x == y);
  } 

  public boolean int_iflt(int x) {
    return (x < 0);
  }

  public boolean int_ifgt(int x) {
    return (x > 0);
  }

  public boolean int_ifle(int x) {
    return (x <= 0);
  }

  public boolean int_ifge(int x) {
    return (x >= 0);
  }

  public boolean int_ifeq(int x) {
    return (x == 0);
  }

  public boolean int_ifne(int x) {
    return (x != 0);
  }

  public boolean int_ifnull(Object o) {
    return (o == null);
  }

  public boolean int_ifnonnull(Object o) {
    return (o != null);
  }

  public boolean int_if_acmpeq(Object x, Object y) {
    return (x == y);
  } 
 
  public boolean int_if_acmpne(Object x, Object y) {
    return (x != y);
  }

  public boolean int_expression_1(int x) {
    return ((x > 1) && (x < 3));
  }

  public boolean int_expression_2(int x) {
    return ((x < 1) || (x > 3));
  } 
 
  public boolean int_expression_3(int x) {
    return ((x & 1) == (x & 2));
  }

  public boolean int_expression_4(int x) {
    return ((x & 1) == 1 || (x & 2) == 1);
  }

  public boolean int_expression_5(int x) {
    return ((x | 1) == 1 || (x | 2) == 2);
  }

  public boolean int_expression_6(int x) {
    return (((x & 1) | (x & 2)) == 3);
  } 
  
  public boolean int_expression_7(int x) {
    return (3 == ((x & 1) | (x & 2)));
  } 

  public boolean int_expression_8(int x) {
    return (((x & 1) & (x & 3)) == 3);
  } 
  
  public boolean int_expression_9(int x) {
    return (3 == ((x & 1) & (x & 3)));
  } 

  public boolean int_expression_10(int x) {
   return (x < 2 & (x != 1 | x == 3));
  }

  public int int_comparison_1(int x) {

    /*
    ** An if-else block.
    */

    int state = 0;

    if (x < 0) {
      state = state + x;
    }
    else {
      state = state - x;
    }
    
    return state;
  } 

  public int int_comparison_2(int x) {
    
    /*
    ** An if-elseif-else block.
    */

    int state = 0;

    if (x < -2) {
      state = 1;
    }
    else if (x < 0) {
      state = 2;
    }
    else if (x == 0) {
      state = 3;
    }
    else if (x < 3) {
      state = 4;
    }
    else {
      state = 5;
    }

    return state;
  }

  public int int_comparison_3(int x) {

    int state = 0;

    if (x < 0) {
      state = state + 1;
    }

    return state;
  }

  public int int_comparison_4(int x) {

    int state = 0;

    if (x < 0) {
      // do nothing
    }
    else {
      state = state + 1;
    }

    return state;
  }


  public int int_comparison_5(int x) {

    /*
    ** Multiple adjecent if blocks.
    */

    int state = 0;

    if (x < 0) {
      state = state + 1;
    }

    if (x < 3) {
      state = state + 1;
    }

    return state;
  }

  public int int_comparison_6(int x) {

    /*
    ** Multiple adjecent if blocks.
    */

    int state = 0;

    if (x < -2) {
      state = state + 1;
    }

    if (x < 0) {
      state = state + 1;
    }

    if (x == 0) {
      state = state + 1;
    }

    if (x < 3) {
      state = state + 1;
    }

    if (x < 5) {
      state = state + 1;
    }

    return state;
  }

  public int int_comparison_7(int x) {

    /*
    ** Multiple adjecent if-else blocks.
    */

    int state = 0;

    if (x < -2) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (x < 0) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (x == 0) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (x < 3) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (x < 5) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    return state;
  }

  public int int_comparison_8(int x) {

    /*
    ** Expressions in the if clause.
    */

    int state = 0;

    if (x > 0 && x < 5) {
      state = state + 1;
    }

    if (x > 2 && x < 3) {
      state = state + 1;
    }

    if (x < 0 || x > 5) {
      state = state + 1;
    }

    if (x < 2 || x > 3) {
      state = state + 1;
    }

    if ((x & 1) == 1 && (x & 2) == 1) {
      state = state + 1;
    }
  
    if ((x | 1) == 1 || (x | 2) == 2) {
      state = state + 1;
    }
   
    return state;
  }

  public int int_comparison_9(int x) {

    /*
    ** Nested if clauses.
    */

    int state = 0;
    
    if (x < 2) {

      if (x < 0) {

        if (x < - 2) {
          state += 1;
        }

        state += 1;
      }
      
      state += 1;
    }
    
    return state;
  }

  public int int_comparison_10(int x) {

    /*
    ** Nested if clauses.
    */

    int state = 0;
    
    if (x < 2) {

      state += 1;
      
      if (x < 0) {
        state += 1;
      }

      if (x < -2) {
        state += 1;
      }
    }
    
    return state;
  }

  public int int_tableswitch_1(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 5;
        break;
      case 2:
        state = 4;
        break;
      case 3:
        state = 3;
        break;
      case 4:
        state = 2;
        break;
      default:
        state = 1;
    }

    return state;
  }

  public int int_tableswitch_2(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 4;
        break;
      case 2:
        state = 3;
        break;
      case 3:
        state = 2;
        break;
      default:
        state = 1;
    }

    switch (state) {
      case 4:
        state = 8;
        break;
      case 5:
        state = 7;
        break;
      case 6:
        state = 6;
        break;
      default:
        state = 5;
    }

    return state;
  }

  public int int_tableswitch_3(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 7;
        break;
      case 2:
        state = 6;
        break;
      case 3:
        state = 5;
        break;
      default:

        switch (x) {
          case 4:
            state = 4;
            break;
          case 5:
            state = 3;
            break;
          case 6:
            state = 2;
            break;
          default:
            state = 1;
        }
    }

    return state;
  }

  public int int_lookupswitch_1(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        state = 6;
        break;
      case 1:
        state = 5;
        break;
      case 2:
        state = 4;
        break;
      case 3:
        state = 3;
        break;
      case 4:
        state = 2;
        break;
      default:
        state = 1;
    }

    return state;
  }

  public int int_lookupswitch_2(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        break;
      case 1:
        state = 4;
        break;
      case 2:
        state = 3;
        break;
      case 3:
        state = 2;
        break;
      default:
        state = 1;
    }

    switch (state) {
      case 100000:
        break;
      case 4:
        state = 8;
        break;
      case 5:
        state = 7;
        break;
      case 6:
        state = 6;
        break;
      default:
        state = 5;
    }

    return state;
  }

  public int int_lookupswitch_3(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        break;
      case 1:
        state = 7;
        break;
      case 2:
        state = 6;
        break;
      case 3:
        state = 5;
        break;
      default:

        switch (x) {
          case 100000:
            break;
          case 4:
            state = 4;
            break;
          case 5:
            state = 3;
            break;
          case 6:
            state = 2;
            break;
          default:
            state = 1;
        }
    }

    return state;
  }

  /*
  ** The "com_" functions will always be compiled.
  */

  public boolean com_if_icmplt(int x, int y) {
    return (x < y);
  }

  public boolean com_if_icmpgt(int x, int y) {
    return (x > y);
  }

  public boolean com_if_icmple(int x, int y) {
    return (x <= y);
  }

  public boolean com_if_icmpge(int x, int y) {
    return (x >= y);
  }

  public boolean com_if_icmpeq(int x, int y) {
    return (x == y);
  }

  public boolean com_if_icmpne(int x, int y) {
    return (x != y);
  }

    public boolean com_fcmp_l(float x, float y) {
	return (x < y);
    }

    public boolean com_fcmp_le(float x, float y) {
	return (x <= y);
    }
   
    public boolean com_fcmp_g(float x, float y) {
	return (x > y);
    }
    
    public boolean com_fcmp_ge(float x, float y) {
	return (x >= y);
    }
    
    public boolean com_fcmp_ne(float x, float y) {
	return (x != y);
    }

    public boolean com_fcmp_e(float x, float y) {
	return (x == y);
    } 

  public boolean com_iflt(int x) {
    return (x < 0);
  }

  public boolean com_ifgt(int x) {
    return (x > 0);
  }

  public boolean com_ifle(int x) {
    return (x <= 0);
  }

  public boolean com_ifge(int x) {
    return (x >= 0);
  }

  public boolean com_ifeq(int x) {
    return (x == 0);
  }

  public boolean com_ifne(int x) {
    return (x != 0);
  }

  public boolean com_ifnull(Object o) {
    return (o == null);
  }

  public boolean com_ifnonnull(Object o) {
    return (o != null);
  }

  public boolean com_if_acmpeq(Object x, Object y) {
    return (x == y);
  }

  public boolean com_if_acmpne(Object x, Object y) {
    return (x != y);
  }

  public boolean com_expression_1(int x) {
    return ((x > 1) && (x < 3));
  }

  public boolean com_expression_2(int x) {
    return ((x < 1) || (x > 3));
  } 
 
  public boolean com_expression_3(int x) {
    return ((x & 1) == (x & 2));
  }

  public boolean com_expression_4(int x) {
    return ((x & 1) == 1 || (x & 2) == 1);
  }

  public boolean com_expression_5(int x) {
    return ((x | 1) == 1 || (x | 2) == 2);
  }

  public boolean com_expression_6(int x) {
    return (((x & 1) | (x & 2)) == 3);
  } 
  
  public boolean com_expression_7(int x) {
    return (3 == ((x & 1) | (x & 2)));
  } 

  public boolean com_expression_8(int x) {
    return (((x & 1) & (x & 3)) == 3);
  } 
  
  public boolean com_expression_9(int x) {
    return (3 == ((x & 1) & (x & 3)));
  } 
 
  public boolean com_expression_10(int x) {
   return (x < 2 & (x != 1 | x == 3));
  }

  public int com_comparison_1(int x) {

    /*
    ** An if-else block.
    */

    int state = 0;

    if (x < 0) {
      state = state + x;
    }
    else {
      state = state - x;
    }

    return state;
  } 

  public int com_comparison_2(int x) {

    /*
    ** An if-elseif-else block.
    */

    int state = 0;

    if (x < -2) {
      state = 1;
    }
    else if (x < 0) {
      state = 2;
    }
    else if (x == 0) {
      state = 3;
    }
    else if (x < 3) {
      state = 4;
    }
    else {
      state = 5;
    }

    return state;
  }

  public int com_comparison_3(int x) {

    int state = 0;

    if (x < 0) {
      state = state + 1;
    }

    return state;
  }

  public int com_comparison_4(int x) {

    int state = 0;

    if (x < 0) {
      // do nothing
    }
    else {
      state = state + 1;
    }

    return state;
  }

  public int com_comparison_5(int x) {

    /*
    ** Multiple adjecent if blocks.
    */

    int state = 0;

    if (x < 0) {
      state = state + 1;
    }

    if (x < 3) {
      state = state + 1;
    }

    return state;
  }

  public int com_comparison_6(int x) {

    /*
    ** Multiple adjecent if blocks.
    */

    int state = 0;

    if (x < -2) {
      state = state + 1;
    }

    if (x < 0) {
      state = state + 1;
    }

    if (x == 0) {
      state = state + 1;
    }

    if (x < 3) {
      state = state + 1;
    }

    if (x < 5) {
      state = state + 1;
    }

    return state;
  }

  public int com_comparison_7(int x) {

    /*
    ** Multiple adjecent if-else blocks.
    */

    int state = 0;

    if (x < -2) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (x < 0) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (x == 0) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (x < 3) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    if (x < 5) {
      state = state + 1;
    }
    else {
      state = state - 1;
    }

    return state;
  }

  public int com_comparison_8(int x) {

    /*
    ** Expressions in the if clause.
    */

    int state = 0;

    if (x > 0 && x < 5) {
      state = state + 1;
    }

    if (x > 2 && x < 3) {
      state = state + 1;
    }

    if (x < 0 || x > 5) {
      state = state + 1;
    }

    if (x < 2 || x > 3) {
      state = state + 1;
    }

    if ((x & 1) == 1 && (x & 2) == 1) {
      state = state + 1;
    }
  
    if ((x | 1) == 1 || (x | 2) == 2) {
      state = state + 1;
    }
   
    return state;
  }

  public int com_comparison_9(int x) {

    /*
    ** Nested if clauses.
    */

    int state = 0;
    
    if (x < 2) {

      if (x < 0) {

        if (x < -2) {
          state += 1;
        }

        state += 1;
      }
      
      state += 1;
    }
    
    return state;
  }

  public int com_comparison_10(int x) {

    /*
    ** Nested if clauses.
    */

    int state = 0;
    
    if (x < 2) {

      state += 1;
      
      if (x < 0) {
        state += 1;
      }

      if (x < -2) {
        state += 1;
      }
    }
    
    return state;
  }

  public int com_tableswitch_1(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 5;
        break;
      case 2:
        state = 4;
        break;
      case 3:
        state = 3;
        break;
      case 4:
        state = 2;
        break;
      default:
        state = 1;
    }

    return state;
  }

  public int com_tableswitch_2(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 4;
        break;
      case 2:
        state = 3;
        break;
      case 3:
        state = 2;
        break;
      default:
        state = 1;
    }

    switch (state) {
      case 4:
        state = 8;
        break;
      case 5:
        state = 7;
        break;
      case 6:
        state = 6;
        break;
      default:
        state = 5;
    }

    return state;
  }

  public int com_tableswitch_3(int x) {
    int state = 0;

    switch (x) {
      case 1:
        state = 7;
        break;
      case 2:
        state = 6;
        break;
      case 3:
        state = 5;
        break;
      default:

        switch (x) {
          case 4:
            state = 4;
            break;
          case 5:
            state = 3;
            break;
          case 6:
            state = 2;
            break;
          default:
            state = 1;
        }
    }

    return state;
  }

  public int com_lookupswitch_1(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        break;
      case 1:
        state = 5;
        break;
      case 2:
        state = 4;
        break;
      case 3:
        state = 3;
        break;
      case 4:
        state = 2;
        break;
      default:
        state = 1;
    }

    return state;
  }

  public int com_lookupswitch_2(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        break;
      case 1:
        state = 4;
        break;
      case 2:
        state = 3;
        break;
      case 3:
        state = 2;
        break;
      default:
        state = 1;
    }

    switch (state) {
      case 100000:
        break;
      case 4:
        state = 8;
        break;
      case 5:
        state = 7;
        break;
      case 6:
        state = 6;
        break;
      default:
        state = 5;
    }

    return state;
  }

  public int com_lookupswitch_3(int x) {
    int state = 0;

    switch (x) {
      case 100000:
        break;
      case 1:
        state = 7;
        break;
      case 2:
        state = 6;
        break;
      case 3:
        state = 5;
        break;
      default:

        switch (x) {
          case 100000:
            break;
          case 4:
            state = 4;
            break;
          case 5:
            state = 3;
            break;
          case 6:
            state = 2;
            break;
          default:
            state = 1;
        }
    }

    return state;
  }

  public void run(JTest jt) {

    /*
    ** To test the comparison operations both using positive and negative
    ** numbers, we let 'i' and 'j' itererate from a negative to a positive 
    ** value.
    */

    /*
    ** Compare two integer arguments.
    */

    for (int i = -3; i < 3; i++) {
      for (int j = -3; j < 3; j++) {
        jt.check(int_if_icmplt(i, j), com_if_icmplt(i, j), "ComparisonTest.com_if_icmplt("+ i +", "+ j +")");
        jt.check(int_if_icmpgt(i, j), com_if_icmpgt(i, j), "ComparisonTest.com_if_icmpgt("+ i +", "+ j +")");
        jt.check(int_if_icmple(i, j), com_if_icmple(i, j), "ComparisonTest.com_if_icmple("+ i +", "+ j +")");
        jt.check(int_if_icmpge(i, j), com_if_icmpge(i, j), "ComparisonTest.com_if_icmpge("+ i +", "+ j +")");
        jt.check(int_if_icmpeq(i, j), com_if_icmpeq(i, j), "ComparisonTest.com_if_icmpeq("+ i +", "+ j +")");
        jt.check(int_if_icmpne(i, j), com_if_icmpne(i, j), "ComparisonTest.com_if_icmpne("+ i +", "+ j +")");
      }
    }

    /*
    ** Compare two float arguments
    */

    float f[] = { Float.MIN_VALUE, Float.MAX_VALUE, Float.NEGATIVE_INFINITY, Float.POSITIVE_INFINITY, Float.NaN, 0.00f, -1.11f, 2.22f, -3.33f, 4.44f, -5.55f, 6.66f, -7.77f, 8.88f, -9.99f };
    for (int i = 0; i < 15; i++) {
      for (int j = 0; j < 15; j++) {
        jt.check(int_fcmp_l(f[i], f[j]), com_fcmp_l(f[i], f[j]), "ComparisonTest.com_fcmp_l("+ f[i] +", "+ f[j] +")");
        jt.check(int_fcmp_le(f[i], f[j]), com_fcmp_le(f[i], f[j]), "ComparisonTest.com_fcmp_le("+ f[i] +", "+ f[j] +")");
        jt.check(int_fcmp_g(f[i], f[j]), com_fcmp_g(f[i], f[j]), "ComparisonTest.com_fcmp_g("+ f[i] +", "+ f[j] +")");
        jt.check(int_fcmp_ge(f[i], f[j]), com_fcmp_ge(f[i], f[j]), "ComparisonTest.com_fcmp_ge("+ f[i] +", "+ f[j] +")");
        jt.check(int_fcmp_ne(f[i], f[j]), com_fcmp_ne(f[i], f[j]), "ComparisonTest.com_fcmp_ne("+ f[i] +", "+ f[j] +")");
        jt.check(int_fcmp_e(f[i], f[j]), com_fcmp_e(f[i], f[j]), "ComparisonTest.com_fcmp_e("+ f[i] +", "+ f[j] +")");
      }
    }

    /*
    ** Compare one integer argument with zero.
    */

    for (int i = -3; i < 3; i++) {
      jt.check(int_iflt(i), com_iflt(i), "ComparisonTest.com_iflt("+ i +")");
      jt.check(int_ifgt(i), com_ifgt(i), "ComparisonTest.com_ifgt("+ i +")");
      jt.check(int_ifle(i), com_ifle(i), "ComparisonTest.com_ifle("+ i +")");
      jt.check(int_ifge(i), com_ifge(i), "ComparisonTest.com_ifge("+ i +")");
      jt.check(int_ifeq(i), com_ifeq(i), "ComparisonTest.com_ifeq("+ i +")");
      jt.check(int_ifne(i), com_ifne(i), "ComparisonTest.com_ifne("+ i +")");
    }

    /*
    ** Compare object references.
    */

    for (int i = 0; i < 3; i++) {
      jt.check(int_ifnull(null), com_ifnull(null), "ComparisonTest.com_ifnull(null)");
      jt.check(int_ifnull(this), com_ifnull(this), "ComparisonTest.com_ifnull(this)");
      jt.check(int_ifnonnull(null), com_ifnonnull(null), "ComparisonTest.com_ifnonnull(null)");
      jt.check(int_ifnonnull(this), com_ifnonnull(this), "ComparisonTest.com_ifnonnull(this)");
      jt.check(int_if_acmpeq(this, null), com_if_acmpeq(this, null), "ComparisonTest.com_if_acmpeq(this, null)");
      jt.check(int_if_acmpeq(null, this), com_if_acmpeq(null, this), "ComparisonTest.com_if_acmpeq(null, this)");
      jt.check(int_if_acmpeq(this, this), com_if_acmpeq(this, this), "ComparisonTest.com_if_acmpeq(this, this)");
      jt.check(int_if_acmpeq(null, null), com_if_acmpeq(null, null), "ComparisonTest.com_if_acmpeq(null, null)");
      jt.check(int_if_acmpne(this, null), com_if_acmpne(this, null), "ComparisonTest.com_if_acmpne(this, null)");
      jt.check(int_if_acmpne(null, this), com_if_acmpne(null, this), "ComparisonTest.com_if_acmpne(null, this)");
      jt.check(int_if_acmpne(this, this), com_if_acmpne(this, this), "ComparisonTest.com_if_acmpne(this, this)");
      jt.check(int_if_acmpne(null, null), com_if_acmpne(null, null), "ComparisonTest.com_if_acmpne(null, null)");
    }

    /*
    ** Test some special/extreme cases.
    */

    int k = Integer.MIN_VALUE;
    int l = Integer.MAX_VALUE;

    for (int i = 0; i < 3; i++) {
      jt.check(int_if_icmplt(k, l), com_if_icmplt(k, l), "ComparisonTest.com_if_icmplt("+ k +", "+ l +")");
      jt.check(int_if_icmpgt(k, l), com_if_icmpgt(k, l), "ComparisonTest.com_if_icmpgt("+ k +", "+ l +")");
      jt.check(int_if_icmple(k, l), com_if_icmple(k, l), "ComparisonTest.com_if_icmple("+ k +", "+ l +")");
      jt.check(int_if_icmpge(k, l), com_if_icmpge(k, l), "ComparisonTest.com_if_icmpge("+ k +", "+ l +")");
      jt.check(int_if_icmpeq(k, l), com_if_icmpeq(k, l), "ComparisonTest.com_if_icmpeq("+ k +", "+ l +")");
      jt.check(int_if_icmpne(k, l), com_if_icmpne(k, l), "ComparisonTest.com_if_icmpne("+ k +", "+ l +")");
    }

    /*
    ** Test "if" statements with expressions.
    */

    for (int i = -5; i < 5; i++) {
      jt.check(int_expression_1(i), com_expression_1(i), "ComparisonTest.com_expression_1("+ i +")");
      jt.check(int_expression_2(i), com_expression_2(i), "ComparisonTest.com_expression_2("+ i +")");
      jt.check(int_expression_3(i), com_expression_3(i), "ComparisonTest.com_expression_3("+ i +")");
      jt.check(int_expression_4(i), com_expression_4(i), "ComparisonTest.com_expression_4("+ i +")");
      jt.check(int_expression_5(i), com_expression_5(i), "ComparisonTest.com_expression_5("+ i +")");
      jt.check(int_expression_6(i), com_expression_6(i), "ComparisonTest.com_expression_6("+ i +")");
      jt.check(int_expression_7(i), com_expression_7(i), "ComparisonTest.com_expression_7("+ i +")");
      jt.check(int_expression_8(i), com_expression_8(i), "ComparisonTest.com_expression_8("+ i +")");
      jt.check(int_expression_9(i), com_expression_9(i), "ComparisonTest.com_expression_9("+ i +")");
      jt.check(int_expression_10(i), com_expression_10(i), "ComparisonTest.com_expression_10("+ i +")");
    }

    /*
    ** Test "if - else if - else" statements with expressions.
    */

    for (int i = -5; i < 5; i++) {
      jt.check(int_comparison_1(i), com_comparison_1(i), "ComparisonTest.com_comparison_1("+ i +")");
      jt.check(int_comparison_2(i), com_comparison_2(i), "ComparisonTest.com_comparison_2("+ i +")");
      jt.check(int_comparison_3(i), com_comparison_3(i), "ComparisonTest.com_comparison_3("+ i +")");
      jt.check(int_comparison_4(i), com_comparison_4(i), "ComparisonTest.com_comparison_4("+ i +")");
      jt.check(int_comparison_5(i), com_comparison_5(i), "ComparisonTest.com_comparison_5("+ i +")");
      jt.check(int_comparison_6(i), com_comparison_6(i), "ComparisonTest.com_comparison_6("+ i +")");
      jt.check(int_comparison_7(i), com_comparison_7(i), "ComparisonTest.com_comparison_7("+ i +")");
      jt.check(int_comparison_8(i), com_comparison_8(i), "ComparisonTest.com_comparison_8("+ i +")");
      jt.check(int_comparison_9(i), com_comparison_9(i), "ComparisonTest.com_comparison_9("+ i +")");
      jt.check(int_comparison_10(i), com_comparison_10(i), "ComparisonTest.com_comparison_10("+ i +")");
    }

    /*
    ** Test jump tables, the "tableswitch" bytecode in specific.
    */

    for (int i = 0; i < 10; i++) {
      jt.check(int_tableswitch_1(i), com_tableswitch_1(i), "ComparisonTest.com_tableswitch_1("+ i +")");
      jt.check(int_tableswitch_2(i), com_tableswitch_2(i), "ComparisonTest.com_tableswitch_2("+ i +")");
      jt.check(int_tableswitch_3(i), com_tableswitch_3(i), "ComparisonTest.com_tableswitch_3("+ i +")");
    }

    /*
    ** Test jump tables, the "lookupswitch" bytecode in specific.
    */

    for (int i = 0; i < 10; i++) {
      jt.check(int_lookupswitch_1(i), com_lookupswitch_1(i), "ComparisonTest.com_loopkupswitch_1("+ i +")");
      jt.check(int_lookupswitch_2(i), com_lookupswitch_2(i), "ComparisonTest.com_loopkupswitch_2("+ i +")");
      jt.check(int_lookupswitch_3(i), com_lookupswitch_3(i), "ComparisonTest.com_loopkupswitch_3("+ i +")");
    }
  }
}
