/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class ConversionTest  {

  /*
  ** The "int_" functions will never be compiled.
  */

  int int_f2i(float x) {
    return (int)x;
  }
  
  byte int_i2b(int x) {
    return (byte)x;
  }
 
  char int_i2c(int x) {
    return (char)x;
  }
 
  float int_i2f(int x) {
    return (float)x;
  }

  short int_i2s(int x) {
    return (short)x;
  }
  
  /*
  ** The "com_" functions will always be compiled.
  */

  int com_f2i(float x) {
    return (int)x;
  }
  
  byte com_i2b(int x) {
    return (byte)x;
  }
  
  char com_i2c(int x) {
    return (char)x;
  }
  
  float com_i2f(int x) {
    return (float)x;
  }
  
  short com_i2s(int x) {
    return (short)x;
  }
  
  public void run(JTest jt) {
    float f[] = { 1.0f, 0.0f, -0.0f, 5.5555f, -5.5555f, 4567.89f, -4567.89f, 123456789f, -123456789f, (float)Byte.MIN_VALUE, (float)Byte.MAX_VALUE, (float)Character.MIN_VALUE, (float)Character.MAX_VALUE, (float)Short.MIN_VALUE, (float)Short.MAX_VALUE, (float)Integer.MIN_VALUE, (float)Integer.MAX_VALUE, (float)Long.MIN_VALUE, (float)Long.MAX_VALUE, Float.MIN_VALUE, Float.MAX_VALUE, Float.NaN, Float.POSITIVE_INFINITY, Float.NEGATIVE_INFINITY, (float)Double.MIN_VALUE, (float)Double.MAX_VALUE };
    
    int i[] = { 1, 0, -0, 123456789, -123456789, (int)Byte.MIN_VALUE, (int)Byte.MAX_VALUE, (int)Character.MIN_VALUE, (int)Character.MAX_VALUE, (int)Short.MIN_VALUE, (int)Short.MAX_VALUE, Integer.MIN_VALUE, Integer.MAX_VALUE, (int)Long.MIN_VALUE, (int)Long.MAX_VALUE, (int)Float.MIN_VALUE, (int)Float.MAX_VALUE, (int)Float.NaN, (int)Float.POSITIVE_INFINITY, (int)Float.NEGATIVE_INFINITY, (int)Double.MIN_VALUE, (int)Double.MAX_VALUE };
    
    for (int j = 0; j < f.length; j++) {
      jt.check(int_f2i(f[j]), com_f2i(f[j]), "ConverstionTest.com_f2i("+ f[j] +")");
    }    

    for (int j = 0; j < i.length; j++) {
      jt.check(int_i2b(i[j]), com_i2b(i[j]), "ConverstionTest.com_i2b("+ i[j] +")");
      jt.check(int_i2c(i[j]), com_i2c(i[j]), "ConverstionTest.com_i2c("+ i[j] +")");
      jt.check(int_i2f(i[j]), com_i2f(i[j]), "ConverstionTest.com_i2f("+ i[j] +")");
      jt.check(int_i2s(i[j]), com_i2s(i[j]), "ConverstionTest.com_i2s("+ i[j] +")");

      // TODO: tests for long and double.
    }    
  }
}
