/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class ExpressionTest  {

  /*
  ** The "int_" functions will never be compiled.
  */

  public int int_expression_1(int a, int b, int c, int d) {
    return a - b + c - d;
  }
  
  public int int_expression_2(int a, int b, int c, int d) {
    return a + b - c + d;
  }
  
  public int int_expression_3(int a, int b, int c, int d) {
    return (a + b) - (c + d);
  }

  public int int_expression_4(int a, int b, int c, int d) {
    return (a - b) - (c - d);
  }
  
  public int int_expression_5(int a, int b, int c, int d) {
    return (a - (b - c)) - d;
  }
  
  public int int_expression_6(int a, int b, int c, int d) {
    return a - ((b - c) - d);
  }
  
  public int int_expression_7(int a, int b, int c, int d) {
    int k = a - b;
    int l = c - d;
    return k + l;
  }

  public int int_expression_8(int a, int b, int c, int d) {
    int k = a + b + c;
    int l = b - c - d;
    return k + l;
  }

  public int int_expression_9(int a, int b, int c, int d) {
    int k = (a - b) + c;
    int l = b - (c + d);
    int m = (b - c) + d;
    return k + l + m;
  }

  public int int_expression_10(int a, int b, int c, int d) {
    // use constants to exercise constant propagation and the available BURG rules
    int k = (9 - a) + 12;
    int l = b - (12 + c);
    int m = (d - 12) + 9;
    return k + l + m;
  }

  public int int_expression_11(int a, int b, int c, int d) {
    // use constants to exercise constant propagation and the available BURG rules
    int k = (9 - a) + 128;
    int l = b - (128 + c);
    int m = (d - 128) + 9;
    return k + l + m;
  }

  public int int_expression_12(int a, int b, int c, int d) {
    // use constants to exercise constant propagation and the available BURG rules
    int k = (9 - a) + 255;
    int l = b - (255 + c);
    int m = (b - 255) + 9;
    return k + l + m;
  }

  /*
  ** The "com_" functions will always be compiled.
  */

  public int com_expression_1(int a, int b, int c, int d) {
    return a - b + c - d;
  }
  
  public int com_expression_2(int a, int b, int c, int d) {
    return a + b - c + d;
  }
  
  public int com_expression_3(int a, int b, int c, int d) {
    return (a + b) - (c + d);
  }

  public int com_expression_4(int a, int b, int c, int d) {
    return (a - b) - (c - d);
  }
  
  public int com_expression_5(int a, int b, int c, int d) {
    return (a - (b - c)) - d;
  }
  
  public int com_expression_6(int a, int b, int c, int d) {
    return a - ((b - c) - d);
  }
  
  public int com_expression_7(int a, int b, int c, int d) {
    int k = a - b;
    int l = c - d;
    return k + l;
  }

  public int com_expression_8(int a, int b, int c, int d) {
    int k = a + b + c;
    int l = b - c - d;
    return k + l;
  }

  public int com_expression_9(int a, int b, int c, int d) {
    int k = (a - b) + c;
    int l = b - (c + d);
    int m = (b - c) + d;
    return k + l + m;
  }

  public int com_expression_10(int a, int b, int c, int d) {
    // use constants to exercise constant propagation and the available BURG rules
    int k = (9 - a) + 12;
    int l = b - (12 + c);
    int m = (d - 12) + 9;
    return k + l + m;
  }

  public int com_expression_11(int a, int b, int c, int d) {
    // use constants to exercise constant propagation and the available BURG rules
    int k = (9 - a) + 128;
    int l = b - (128 + c);
    int m = (d - 128) + 9;
    return k + l + m;
  }

  public int com_expression_12(int a, int b, int c, int d) {
    // use constants to exercise constant propagation and the available BURG rules
    int k = (9 - a) + 255;
    int l = b - (255 + c);
    int m = (b - 255) + 9;
    return k + l + m;
  }

  public void run(JTest jt) {

    int d[] = { -2, 4, 3, -4, 6, -1, 0, 5, -7, 9, 1, 7, -5, 4, -8, -3, 4, 6, -1, 2 };

    for (int i = 0; i < 20; i = i + 4) {
      jt.check(int_expression_1(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_1(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_1("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");

      jt.check(int_expression_2(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_2(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_2("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");
     jt.check(int_expression_3(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_3(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_3("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");
      jt.check(int_expression_4(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_4(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_4("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");
      jt.check(int_expression_5(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_5(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_5("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");
      jt.check(int_expression_6(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_6(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_6("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");
      jt.check(int_expression_7(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_7(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_7("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");
      jt.check(int_expression_8(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_8(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_8("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");
      jt.check(int_expression_9(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_9(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_9("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");
      jt.check(int_expression_10(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_10(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_10("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");
      jt.check(int_expression_11(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_11(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_11("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");
      jt.check(int_expression_12(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), com_expression_12(d[i + 0], d[i + 1], d[i + 2], d[i + 3]), "ExpressionTest.com_expression_12("+ d[i + 0] +", "+ d[i + 1] +", "+ d[i + 2] +", "+ d[i + 3] +")");
    }
  }
}
