/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class JTest  {

  public int tests = 0;

  public void check(int a, int b, String test) {
    System.out.println("[JTEST] "+ test +": "+ a + ", "+ b);

    if (a != b) {
      System.exit(-1);
    }

    tests++;
  }

  public void check(float a, float b, String test) {
    System.out.println("[JTEST] "+ test +": "+ a + ", "+ b);

    if (a == Float.NaN) {
      System.out.println("a is NaN");
    }

    if (!((a != a && b != b) || (a == b))) {  
        // Note: "Float.NaN != Float.NaN" so we had to use a special NaN-trick in the if-clause.
      System.exit(-1);
    }

    tests++;
  }

  public void check(long a, long b, String test) {
    System.out.println("[JTEST] "+ test +": "+ a + ", "+ b);

    if (a != b) {
      System.exit(-1);
    }

    tests++;
  }

  public void check(double a, double b, String test) {
    System.out.println("[JTEST] "+ test +": "+ a + ", "+ b);

    if (!((a != a && b != b) || (a == b))) {  
        // Note: "Double.NaN != Double.NaN" so we had to use a special NaN-trick in the if-clause.
      System.exit(-1);
    }

    tests++;
  }

  public void check(boolean a, boolean b, String test) {
    System.out.println("[JTEST] "+ test +": "+ a + ", "+ b);

    if (a != b) {
      System.exit(-1);
    }

    tests++;
  }

  public void check(Object a, Object b, String test) {
    System.out.println("[JTEST] "+ test +": "+ a + ", "+ b);

    if (a != null) {
      if (a.equals(b) == false) {
        System.exit(-1);
      }
    }
    else {
      if (b != null) {
        System.exit(-1);
      }
    }

    tests++;
  }

  public static void main(String[] args) {
    JTest jt = new JTest();
    
    StackTest st = new StackTest();
    st.run(jt);

    ParameterTest pat = new ParameterTest();
    pat.run(jt);
    
    ReturnTest rt = new ReturnTest();
    rt.run(jt);

    ArithmeticOperationsTest aot = new ArithmeticOperationsTest();
    aot.run(jt);

    ComparisonTest cmt = new ComparisonTest();
    cmt.run(jt);

    ConversionTest cvt = new ConversionTest();
    cvt.run(jt);
    
    LoopTest lt = new LoopTest();
    lt.run(jt);

    ObjectTest obt = new ObjectTest();
    obt.run(jt);

    LogicOperationsTest lot = new LogicOperationsTest();
    lot.run(jt);

    ExpressionTest expt = new ExpressionTest();
    expt.run(jt);

    MethodTest mt = new MethodTest();
    mt.run(jt);

    ArrayTest at = new ArrayTest();
    at.run(jt);

    OptimizationTest opt = new OptimizationTest();
    opt.run(jt);

    ProblemTest prt = new ProblemTest();
    prt.run(jt);
   
    ExceptionTest exct = new ExceptionTest();
    exct.run(jt);
    
    System.out.println("--> passed "+ jt.tests +" tests");
  }
}
