/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class LoopTest {
 
  /*
  ** Single loops; both "for" and "while" loops iterating forward and 
  ** backward.
  */
 
  public int com_loop_1(int x) {
    int i;
  
    for (i = 0; i <= x; i++) {         // loop forward
      // empty loop
    }

    return i;
  }

  public int com_loop_2(int x) {
    int i;
  
    for (i = x; i >= 0; i--) {         // loop backward
      // empty loop
    }

    return i;
  }

  public int com_loop_3(int x) {
    int i = 0;
 
    while (i <= x) {                   // loop forward
      i = i + 1;
    }

    return i;
  }
  
  public int com_loop_4(int x) {
    int i = x;
 
    while (i >= 0) {                   // loop backward
      i = i - 1;
    }

    return i;
  }

  /*
  ** Nested loops.
  */

  public int com_loop_5(int x, int y, int z) {
    int i = 0;
    int j = 0;
    int k = 0;

    for (; i < x; i++) {
      for (; j < y; j++) {
        for (; k < z; k++) {
          // empty loop
        }
      }
    }

    return i + j + k;
  }

  public int com_loop_6(int x, int y, int z) {
    int iterations = 0;

    for (int i = 0; i < x; i++) {
      for (int j = 0; j < y; j++) {
        for (int k = 0; k < z; k++) {
          iterations++;
        }
      }
    }

    return iterations;
  }

  public void run(JTest jt) {
    jt.check(com_loop_1(10), com_loop_1(10), "LoopTest.com_loop_1()");
    jt.check(com_loop_2(10), com_loop_2(10), "LoopTest.com_loop_2()");
    jt.check(com_loop_3(10), com_loop_3(10), "LoopTest.com_loop_3()");
    jt.check(com_loop_4(10), com_loop_4(10), "LoopTest.com_loop_4()");
    jt.check(com_loop_5(3, 4, 5), com_loop_5(3, 4, 5), "LoopTest.com_loop_5()");
    jt.check(com_loop_6(3, 4, 5), com_loop_6(3, 4, 5), "LoopTest.com_loop_6()");
  } 
}
