/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

import java.util.Vector;

public class MicroBenchmark {

  public int foo;
  static int bar;

  public int foo(int x, int y) {
    return x + y;
  }

  public int test1(int size) {
    int x = 0;
    for (int i = 0; i < size; i++) {
      x = x + size - i;
    }
    return x;
  } 

  public int test2(int size) {
    int x = 0;
    for (int i = 0; i < size; i++) {
      x = x + foo(i, i);
    }
    return x;
  } 

  public int test3(int size) {
    int i = 0;
    for (i = 0; i < size; i++) {
      foo(i, i);  // 0
      foo(i, i);  // 1
      foo(i, i);  // 2
      foo(i, i);  // 3
      foo(i, i);  // 4
      foo(i, i);  // 5
      foo(i, i);  // 6
      foo(i, i);  // 7
      foo(i, i);  // 8
      foo(i, i);  // 9
    }
    return i;
  } 

  public int test4(int size) {
    int array[] = new int[5];
    for (int i = 0; i < size; i++) {
      array[0] += i;
      array[1] += array[0];
    }
    return array[1];
  } 

  public int test5(int size) {
    Vector v = new Vector();
    for (int i = 0; i < size; i++) {
      v.add(new Integer(i));
    }
    return size;
  } 

  public int test6(int size) {
    for (int i = 0; i < size; i++) {
      foo += i;
      bar -= i;
    }
    return foo + bar;
  } 

  public static void main(String args[]) {
    
    MicroBenchmark mb = new MicroBenchmark();
    long time1;
    long time2;
    long time3;
    long time4;

    /*
    ** Test 1
    */
  
    System.out.println("Test 1: loop with arithmetic operation");

    time1 = System.currentTimeMillis();
    mb.test1(9000000); 
    time2 = System.currentTimeMillis();
    System.out.println("  interpreter..: "+ (time2 - time1) +" ms elapsed");
    
    time3 = System.currentTimeMillis();
    mb.test1(9000000); 
    time4 = System.currentTimeMillis();
    System.out.println("  compiler.....: "+ (time4 - time3) + " ms elapsed (speed up factor = "+ ((float)(time2 - time1) / (float)(time4 - time3)) +")");

    /*
    ** Test 2
    */

    System.out.println("Test 2: loop with one method call");

    time1 = System.currentTimeMillis();
    mb.test2(5000000); 
    time2 = System.currentTimeMillis();
    System.out.println("  interpreter..: "+ (time2 - time1) +" ms elapsed");

    time3 = System.currentTimeMillis();
    mb.test2(5000000); 
    time4 = System.currentTimeMillis();
    System.out.println("  compiler.....: "+ (time4 - time3) + " ms elapsed (speed up factor = "+ ((float)(time2 - time1) / (float)(time4 - time3)) +")");

    /*
    ** Test 3
    */

    System.out.println("Test 3: loop with ten method calls");

    time1 = System.currentTimeMillis();
    mb.test3(3000000); 
    time2 = System.currentTimeMillis();
    System.out.println("  interpreter..: "+ (time2 - time1) +" ms elapsed");

    time3 = System.currentTimeMillis();
    mb.test3(3000000); 
    time4 = System.currentTimeMillis();
    System.out.println("  compiler.....: "+ (time4 - time3) + " ms elapsed (speed up factor = "+ ((float)(time2 - time1) / (float)(time4 - time3)) +")");

    /*
    ** Test 4
    */

    System.out.println("Test 4: loop with array operations");

    time1 = System.currentTimeMillis();
    mb.test4(9000000); 
    time2 = System.currentTimeMillis();
    System.out.println("  interpreter..: "+ (time2 - time1) +" ms elapsed");

    time3 = System.currentTimeMillis();
    mb.test4(9000000);
    time4 = System.currentTimeMillis();
    System.out.println("  compiler.....: "+ (time4 - time3) + " ms elapsed (speed up factor = "+ ((float)(time2 - time1) / (float)(time4 - time3)) +")");

    /*
    ** Test 5
    */

    System.out.println("Test 5: loop with references");

    time1 = System.currentTimeMillis();
    mb.test5(80000); 
    time2 = System.currentTimeMillis();
    System.out.println("  interpreter..: "+ (time2 - time1) +" ms elapsed");

    time3 = System.currentTimeMillis();
    mb.test5(80000);
    time4 = System.currentTimeMillis();
    System.out.println("  compiler.....: "+ (time4 - time3) + " ms elapsed (speed up factor = "+ ((float)(time2 - time1) / (float)(time4 - time3)) +")");

    /*
    ** Test 6
    */

    System.out.println("Test 6: loop with object operations");

    time1 = System.currentTimeMillis();
    mb.test6(3000000); 
    time2 = System.currentTimeMillis();
    System.out.println("  interpreter..: "+ (time2 - time1) +" ms elapsed");

    time3 = System.currentTimeMillis();
    mb.test6(3000000);
    time4 = System.currentTimeMillis();
    System.out.println("  compiler.....: "+ (time4 - time3) + " ms elapsed (speed up factor = "+ ((float)(time2 - time1) / (float)(time4 - time3)) +")");
  }
}
