/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: OptimizationTest.java 3863 2003-04-25 09:23:25Z dbuytaert $
*/

package com.acunia.wonka.test.jspot;

public class OptimizationTest {

  /*
  ** The "int_" functions will never be compiled.
  */

  public int int_constant_propagation_1(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a + b;
    d = c + d;

    return x + d;
  } 

  public int int_constant_propagation_2(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a - b;
    d = c - d;

    return x - d;
  } 

  public int int_constant_propagation_3(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a * b;
    d = c * d;

    return x * d;
  } 

  public int int_constant_propagation_4(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a | b;
    d = c & d;

    return x + d;
  } 

  public int int_constant_propagation_5(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a ^ b;
    d = c | d;

    return x + d;
  } 

  public int int_constant_propagation_6(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a << b;
    d = c << d;

    return x + d;
  } 

  public int int_constant_propagation_7(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a >> b;
    d = c >> d;

    return x + d;
  } 
  public int int_constant_propagation_8(int x) {
    int a = 5;
    int b = - a;
    return x + b;
  }

  public boolean int_constant_propagation_9(int x) {
    boolean a = false;
    boolean b = !a;   // iseq(constant)
    return (a | b);
  }

  public boolean int_constant_propagation_10(int x) {
    boolean a = true;
    boolean b = !a;   // isne(constant)
    return (a | b);
  }

  /*
  ** The "com_" functions will always be compiled.
  */

  public int com_constant_propagation_1(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a + b;
    d = c + d;

    return x + d;
  } 

  public int com_constant_propagation_2(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a - b;
    d = c - d;

    return x - d;
  }

  public int com_constant_propagation_3(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a * b;
    d = c * d;

    return x * d;
  } 

  public int com_constant_propagation_4(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a | b;
    d = c & d;

    return x + d;
  } 

  public int com_constant_propagation_5(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a ^ b;
    d = c | d;

    return x + d;
  } 

  public int com_constant_propagation_6(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a << b;
    d = c << d;

    return x + d;
  } 

  public int com_constant_propagation_7(int x) {
    int a = 1;
    int b = 2;
    int d = 3; 
    int c = 4;  // dead code

    c = a >> b;
    d = c >> d;

    return x + d;
  } 

  public int com_constant_propagation_8(int x) {
    int a = 5;
    int b = - a;
    return x + b;
  }

  public boolean com_constant_propagation_9(int x) {
    boolean a = false;
    boolean b = !a;   // iseq(constant)
    return (a | b);
  }

  public boolean com_constant_propagation_10(int x) {
    boolean a = true;
    boolean b = !a;   // isne(constant)
    return (a | b);
  }

  public void run(JTest jt) {
    for (int i = -5; i < 5; i++) {
      jt.check(int_constant_propagation_1(i), com_constant_propagation_1(i), "OptimizationTest.com_constant_propagation_1("+ i +")");
      jt.check(int_constant_propagation_2(i), com_constant_propagation_2(i), "OptimizationTest.com_constant_propagation_2("+ i +")");
      jt.check(int_constant_propagation_3(i), com_constant_propagation_3(i), "OptimizationTest.com_constant_propagation_3("+ i +")");
      jt.check(int_constant_propagation_4(i), com_constant_propagation_4(i), "OptimizationTest.com_constant_propagation_4("+ i +")");
      jt.check(int_constant_propagation_5(i), com_constant_propagation_5(i), "OptimizationTest.com_constant_propagation_5("+ i +")");
      jt.check(int_constant_propagation_5(i), com_constant_propagation_5(i), "OptimizationTest.com_constant_propagation_6("+ i +")");
      jt.check(int_constant_propagation_6(i), com_constant_propagation_6(i), "OptimizationTest.com_constant_propagation_7("+ i +")");
      jt.check(int_constant_propagation_7(i), com_constant_propagation_7(i), "OptimizationTest.com_constant_propagation_8("+ i +")");
      jt.check(int_constant_propagation_9(i), com_constant_propagation_9(i), "OptimizationTest.com_constant_propagation_9("+ i +")");
      jt.check(int_constant_propagation_10(i), com_constant_propagation_10(i), "OptimizationTest.com_constant_propagation_10("+ i +")");
    }
  }
}
