/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class ParameterTest {
 
  /*
  ** The "int_" functions will never be compiled.
  */

  public int int_control_flow_1(int x) {
   
    /*
    ** Parameter assignments tend to complicate construction of the IR.
    ** Control flow (ie. the existence of basic blocks) complicate this
    ** even more.
    */
 
    x = x + 1;
      
    return x;
  }

  public int int_control_flow_2(int x) {
    
    /*
    ** Parameter assignments tend to complicate construction of the IR.
    ** Control flow (ie. the existence of basic blocks) complicate this
    ** even more.
    */
    
    if (x < 2) {
      x = x + 1;
    }
      
    return x;
  }

  public int int_control_flow_3(int x) {
    
    /*
    ** Parameter assignments tend to complicate construction of the IR.
    ** Control flow (ie. the existence of basic blocks) complicate this
    ** even more.
    */
    
    if (x < 2) {
      x = x + 1;
    }
    else {
      x = x - 1;
    }
   
    return x;
  }

  public int int_control_flow_4(int x) {
    
    /*
    ** Parameter assignments tend to complicate construction of the IR.
    ** Control flow (ie. the existence of basic blocks) complicate this
    ** even more.
    */
    
    if (x < 2) {
      x = x + 1;
    }

    if (x < 3) {
      x = x + 1;
    }
    
    return x;
  }
 
  public int int_control_flow_5(int i) {

    /*
    ** Make sure parameters get spilled when necessary (eg. on ARM).
    ** Also tests contant propgatation.
    */

    int a = 0;
    int b = 1;
    int c = 2;
    int d = 3;

    return a + b + c + i + d;
  }

  public int int_control_flow_6(int i) {

    /*
    ** Make sure parameters get spilled when necessary (eg. on ARM).
    ** Also tests contant propgatation.
    */

    int a = 0;
    int b = 1;
    int c = 2;
    int d = 3;

    return a + i + b + c + d;
  }

  public int int_control_flow_7(int i) {

    /*
    ** Make sure parameters get spilled when necessary (eg. on ARM).
    ** Also tests contant propgatation.
    */

    int a = 0;
    int b = 1;
    int c = 2;
    int d = 3;

    return a - b + i + c - d;
  }

  public int int_control_flow_8(int i) {

    /*
    ** Make sure parameters get spilled when necessary (eg. on ARM).
    ** Also tests contant propgatation.
    */

    int a = 0;
    int b = 1;
    int c = 2;
    int d = 3;
    int e = 4;
    int f = 5;

    return a - b + c + i + d + e - f;
  }


  /*
  ** The "com_" functions will always be compiled.
  */

  public int com_instance_1(int a) {
    return a;
  }

  public int com_instance_2(int a, int b) {
    return b;
  }

  public int com_instance_3(int a, int b, int c) {
    return c;
  }

  public int com_instance_4(int a, int b, int c, int d) {
    return d;
  }

  public int com_instance_5(int a, int b, int c, int d, int e) {
    return e;
  }

  public int com_instance_6(int a, int b, int c, int d, int e, int f) {
    return f;
  }

  public int com_instance_7(int a, int b, int c, int d, int e, int f, int g) {
    return g;
  }

  public int com_instance_8(int a, int b, int c, int d, int e, int f, int g, int h) {
    return h;
  }

  public int com_instance_9(int a, int b, int c, int d, int e, int f, int g, int h, int i) {
    return i;
  }

  static public int com_static_1(int a) {
    return a;
  }

  static public int com_static_2(int a, int b) {
    return b;
  }

  static public int com_static_3(int a, int b, int c) {
    return c;
  }

  static public int com_static_4(int a, int b, int c, int d) {
    return d;
  }

  static public int com_static_5(int a, int b, int c, int d, int e) {
    return e;
  }

  static public int com_static_6(int a, int b, int c, int d, int e, int f) {
    return f;
  }

  static public int com_static_7(int a, int b, int c, int d, int e, int f, int g) {
    return g;
  }

  static public int com_static_8(int a, int b, int c, int d, int e, int f, int g, int h) {
    return h;
  }

  static public int com_static_9(int a, int b, int c, int d, int e, int f, int g, int h, int i) {
    return i;
  }

  public int com_control_flow_1(int x) {
   
    /*
    ** Parameter assignments tend to complicate construction of the IR.
    ** Control flow (ie. the existence of basic blocks) complicate this
    ** even more.
    */
 
    x = x + 1;
      
    return x;
  }

  public int com_control_flow_2(int x) {
    
    /*
    ** Parameter assignments tend to complicate construction of the IR.
    ** Control flow (ie. the existence of basic blocks) complicate this
    ** even more.
    */
    
    if (x < 2) {
      x = x + 1;
    }
      
    return x;
  }

  public int com_control_flow_3(int x) {
    
    /*
    ** Parameter assignments tend to complicate construction of the IR.
    ** Control flow (ie. the existence of basic blocks) complicate this
    ** even more.
    */
    
    if (x < 2) {
      x = x + 1;
    }
    else {
      x = x - 1;
    }
   
    return x;
  }

  public int com_control_flow_4(int x) {
    
    /*
    ** Parameter assignments tend to complicate construction of the IR.
    ** Control flow (ie. the existence of basic blocks) complicate this
    ** even more.
    */
    
    if (x < 2) {
      x = x + 1;
    }

    if (x < 3) {
      x = x + 1;
    }
    
    return x;
  }
 
 public int com_control_flow_5(int i) {

    /*
    ** Make sure parameters get spilled when necessary (eg. on ARM).
    ** Also tests contant propgatation.
    */

    int a = 0;
    int b = 1;
    int c = 2;
    int d = 3;

    return a + b + c + i + d;
  }

  public int com_control_flow_6(int i) {

    /*
    ** Make sure parameters get spilled when necessary (eg. on ARM).
    ** Also tests contant propgatation.
    */

    int a = 0;
    int b = 1;
    int c = 2;
    int d = 3;

    return a + i + b + c + d;
  }

  public int com_control_flow_7(int i) {

    /*
    ** Make sure parameters get spilled when necessary (eg. on ARM).
    ** Also tests contant propgatation.
    */

    int a = 0;
    int b = 1;
    int c = 2;
    int d = 3;

    return a - b + i + c - d;
  }

  public int com_control_flow_8(int i) {

    /*
    ** Make sure parameters get spilled when necessary (eg. on ARM).
    ** Also tests contant propgatation.
    */

    int a = 0;
    int b = 1;
    int c = 2;
    int d = 3;
    int e = 4;
    int f = 5;

    return a - b + c + i + d + e - f;
  }

  public void run(JTest jt) {

    /*
    ** Test parameter handling for instance methods. 
    */

    jt.check(com_instance_1(1), com_instance_1(1), "ParameterTest.com_instance_1(1)");
    jt.check(com_instance_2(1, 2), com_instance_2(1, 2), "ParameterTest.com_instance_2(1, 2)");
    jt.check(com_instance_3(1, 2, 3), com_instance_3(1, 2, 3), "ParameterTest.com_instance_3(1, 2, 3)");
    jt.check(com_instance_4(1, 2, 3, 4), com_instance_4(1, 2, 3, 4), "ParameterTest.com_instance_4(1, 2, 3, 4)");
    jt.check(com_instance_5(1, 2, 3, 4, 5), com_instance_5(1, 2, 3, 4, 5), "ParameterTest.com_instance_5(1, 2, 3, 4, 5)");
    jt.check(com_instance_6(1, 2, 3, 4, 5, 6), com_instance_6(1, 2, 3, 4, 5, 6), "ParameterTest.com_instance_6(1, 2, 3, 4, 5, 6)");
    jt.check(com_instance_7(1, 2, 3, 4, 5, 6, 7), com_instance_7(1, 2, 3, 4, 5, 6, 7), "ParameterTest.com_instance_7(1, 2, 3, 4, 5, 6, 7)");
    jt.check(com_instance_8(1, 2, 3, 4, 5, 6, 7, 8), com_instance_8(1, 2, 3, 4, 5, 6, 7, 8), "ParameterTest.com_instance_8(1, 2, 3, 4, 5, 6, 7, 8)");
    jt.check(com_instance_9(1, 2, 3, 4, 5, 6, 7, 8, 9), com_instance_9(1, 2, 3, 4, 5, 6, 7, 8, 9), "ParameterTest.com_instance_9(1, 2, 3, 4, 5, 6, 7, 8, 9)");

    /*
    ** Test parameter handling for static methods. 
    */

    jt.check(com_static_1(1), com_static_1(1), "ParameterTest.com_static_1(1)");
    jt.check(com_static_2(1, 2), com_static_2(1, 2), "ParameterTest.com_static_2(1, 2)");
    jt.check(com_static_3(1, 2, 3), com_static_3(1, 2, 3), "ParameterTest.com_static_3(1, 2, 3)");
    jt.check(com_static_4(1, 2, 3, 4), com_static_4(1, 2, 3, 4), "ParameterTest.com_static_4(1, 2, 3, 4)");
    jt.check(com_static_5(1, 2, 3, 4, 5), com_static_5(1, 2, 3, 4, 5), "ParameterTest.com_static_5(1, 2, 3, 4, 5)");
    jt.check(com_static_6(1, 2, 3, 4, 5, 6), com_static_6(1, 2, 3, 4, 5, 6), "ParameterTest.com_static_6(1, 2, 3, 4, 5, 6)");
    jt.check(com_static_7(1, 2, 3, 4, 5, 6, 7), com_static_7(1, 2, 3, 4, 5, 6, 7), "ParameterTest.com_static_7(1, 2, 3, 4, 5, 6, 7)");
    jt.check(com_static_8(1, 2, 3, 4, 5, 6, 7, 8), com_static_8(1, 2, 3, 4, 5, 6, 7, 8), "ParameterTest.com_static_8(1, 2, 3, 4, 5, 6, 7, 8)");
    jt.check(com_static_9(1, 2, 3, 4, 5, 6, 7, 8, 9), com_static_9(1, 2, 3, 4, 5, 6, 7, 8, 9), "ParameterTest.com_static_9(1, 2, 3, 4, 5, 6, 7, 8, 9)");

    /*
    ** Test parameter handling with complex control flow.
    */

    for (int i = 0; i < 5; i++) {
      jt.check(int_control_flow_1(i), com_control_flow_1(i), "ParameterTest.com_control_flow_1("+ i +")");
      jt.check(int_control_flow_2(i), com_control_flow_2(i), "ParameterTest.com_control_flow_2("+ i +")");
      jt.check(int_control_flow_3(i), com_control_flow_3(i), "ParameterTest.com_control_flow_3("+ i +")");
      jt.check(int_control_flow_4(i), com_control_flow_4(i), "ParameterTest.com_control_flow_4("+ i +")");
      jt.check(int_control_flow_5(i), com_control_flow_5(i), "ParameterTest.com_control_flow_5("+ i +")");
      jt.check(int_control_flow_6(i), com_control_flow_6(i), "ParameterTest.com_control_flow_6("+ i +")");
      jt.check(int_control_flow_7(i), com_control_flow_7(i), "ParameterTest.com_control_flow_7("+ i +")");
      jt.check(int_control_flow_8(i), com_control_flow_8(i), "ParameterTest.com_control_flow_8("+ i +")");
    }
  }
}

