/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

import java.util.BitSet;

public class ProblemTest  {

  private String string = "olleke-bolleke";
  private int ia[] = new int[1];
  private char ca[] = new char[30];
  private Dummy d = new Dummy();
  private boolean b;
  private int index;
 
  public boolean foo(int x, int y) {
    return x > y;
  }

  public int foo(int x) {
    return x;
  }

  public boolean bar(int x) {
    return x > 5;
  }

  public void bar(char x) {
    System.gc();
  }

  /*
  ** The "int_" functions will never be compiled.
  */

  public boolean int_test_1(boolean x) {
    b = !x;
    return b;
  }

  public String int_test_2(int x) {
    return (x > 10 ? "" : string.substring(0, x));
  }

  public static Boolean int_test_3(String s) {
    return new Boolean(s != null && s.length() != 2);
  }

  public static Boolean int_test_4(String s) {
    return new Boolean(s != null && s.length() != 2 && s.length() != 3);
  }

  public static Boolean int_test_5(String s) {
    return new Boolean(s != null && s.length() != 2 && s.length() != 3 && s.length() != 4);
  }

  public int int_test_6(int x) {
    d.invokevirtual(x == 5);
    return x;
  }

  public int int_test_7(int x) {
    int state = 0;

    if (state < 10) {
      state = state + 1;
    }
  
    return state;
  }

  public int int_test_8(int x) {
    ia[0] += 1;
    return 1;
  }

  public int int_test_9(int x) {
    x = 1;
    
    if (x < 5) {
      x += 1;
    }
    
    return x;
  }

  public int int_test_10(int x) {
    int a = 1;
    int b = a * 2;

    for (int i = 0; i < a; i++) {
      // empty loop
    }

    return a;
  }

  public int int_test_11(int x) {
    int[] i = new int[30];
    i[x] = 1;

    if (i[x] == 1) {
      i[x] = 2; 
    }

    return i[x];
  }
  
  public String int_test_12(int x) {
    String[] s = new String[30];
    s[x] = "abc";

    if (s[x].equals("abc")) {
      s[x] = "def"; 
    }

    return s[x];
  }

  public int int_test_13(int x) {
    int count = 0;
    if (x < 10 & (x != 7 | x == 15)) {
      count++;
    }
    return count;
  }
 
  public int int_test_14(int x) {
    int state = index;
    return state++;
  }

  public char int_test_15(int x) {
    int i = x;

    ca[i++] = 'x';
    
    return ca[i];
  }

  public int int_test_16(int x) {
    int array[] = new int[30];
    int k = x;

    for (int l = 0; l < 30; l++) {
      array[l] += k;
    }

    return array[x];
  }

  public int int_test_17(int x) {
    int array[][] = new int[30][30];
    int k = x;
 
    for (int l = 0; l < 30; l++) {
      array[l][k] = l + k;
    }

    return array[x][x];
  }

  public int int_test_18(int x) {
    int state = 0;

    if (x < 10) {
      state = 1;
    
      if (x > 30) {
        throw new RuntimeException();  // this should never trigger
      }
    }
    else if (x < 15) {
      state = 2;
      if (x > 30) {
        throw new RuntimeException();  // this should never trigger
      }
    }
    else if (x < 20) {
      state = 3;
      if (x > 30) {
        throw new RuntimeException();  // this should never trigger
      }
    }
  
    return state;
  }
 
  public int int_test_19(String s) {
    int result = 0;
    String remainder = s;
    
    while (remainder != null) {
      char a;

      if (remainder.length() > 0) {
        a = remainder.charAt(0);
        remainder = remainder.substring(1);
      }
      else {
        a = '0';
        remainder = null;
      }

      if (a == 'a') {
        result |= 1;
      }
      else if (a == 'b') {
        result |= 2;
      }
      else if (a == 'c') {
        result |= 4;
      }
      else if (a == 'd') {
        result |= 8;
      }
    }

    return result;
  }

  public boolean int_test_21(int x) {
    int a = 5;
    return (x > a && foo(x, a));
  }
 
  public int int_test_22(int x) {
    int state = 0;
    return foo(state = state + x);
  }

  public int int_test_23(int x) {
    try {
      char array[] = new char[x];
    }
    catch (NegativeArraySizeException e) {
      return x;
    }
    return -x;
  }

  public int int_test_24(int x) {
    return index + (bar(x) ? index : 0);
  }

  public int int_test_20(String s) {

    if (s == null) {
      return 1;
    }

    int i = 0;
    char c[] = s.toCharArray();

    do {
      while (i < c.length && c[i] == 'x')  {
        i++;
      }
      i++;
    } 
    while (i < c.length);

    return i;
  }


  /*
  ** The "com_" functions will always be compiled.
  */

  public boolean com_test_1(boolean x) {
    /*
    ** HISTORY: to trigger the bug, we had to store 'b' in a class field.  
    **          Problem with the construction of the IR's DAG.
    **
    ** [Don't touch, change or optimize this function.]
    */

    b = !x;
    return b;
  }

  public String com_test_2(int x) {
    /*
    ** HISTORY: used to misplace (invalid order) an assignement instruction
    **          in the IR's DAG which caused a segfault the first time the
    **          generated code got called.
    **
    ** [Don't touch, change or optimize this function.]
    */

    return (x > 10 ? "" : string.substring(0, x));
  }

  public static Boolean com_test_3(String s) {
    /*
    ** HISTORY: problem with the construction of the IR's DAG.
    **
    ** [Don't touch, change or optimize this function.]
    */

    return new Boolean(s != null && s.length() != 2);
  }

  public static Boolean com_test_4(String s) {
    /*
    ** HISTORY: problem with the construction of the IR's DAG.
    **
    ** [Don't touch, change or optimize this function.]
    */

    return new Boolean(s != null && s.length() != 2 && s.length() != 3);
  }

  public static Boolean com_test_5(String s) {
    /*
    ** HISTORY: problem with the construction of the IR's DAG.
    **
    ** [Don't touch, change or optimize this function.]
    */

    return new Boolean(s != null && s.length() != 2 && s.length() != 3 && s.length() != 4);
  }

  public int com_test_6(int x) {
    /*
    ** HISTORY: because of the particular order in which the corresponding 
    **          bytecodes ('getfield' -> comparison -> 'invokevirtual') get 
    **          executed, the translation to the IR messed up and corrupted
    **          the value of 'd'.
    **
    ** [Don't touch, change or optimize this function.]
    */

    d.invokevirtual(x == 5);
    return x;
  }

  public int com_test_7(int x) {
    /*
    ** HISTORY: caused to confuse the register allocator and/or the code 
    **          generator.  Note that we don't use 'x' at all.
    **
    ** [Don't touch, change or optimize this function.]
    */

    int state = 0;

    if (state < 10) {
      state = state + 1;
    }
    
    return state;
  }

  public int com_test_8(int x) {
    /*
    ** HISTORY: caused either an ArrayIndexOutOfBoundException to be thrown
    **          or Wonka to segfault due to faulty register allocation.
    **
    **          Remark that this method's bytecode, compiled using Jikes 
    **          1.12, includes a "dup2" instruction.
    **
    ** [Don't touch, change or optimize this function.]
    */

    ia[0] += 1;
    return 1;
  }

  public int com_test_9(int x) {
    /*
    ** HISTORY: the variable "x" is both used as a function argument and 
    **          as a local variable.  The final return value was invalid
    **          because "x" got incorrectly spilled to different stack 
    **          locations; to the parameter list and to the local variable
    **          area.  The latter is not correct. 
    **
    ** [Don't touch, change or optimize this function.]
    */
    
    x = 1;
    
    if (x < 5) {
      x += 1;
    }
    
    return x;
  }

  public int com_test_10(int x) {
    /*
    ** HISTORY: the variable "a" used to be /corrupted/ after the loop
    **          due to register allocation issues related to phi-nodes.
    **
    ** [Don't touch, change or optimize this function.]
    */
    
    int a = 1;
    int b = a * 2;

    for (int i = 0; i < a; i++) {
      // empty loop
    }

    return a;
  }

  public int com_test_11(int x) {
    /*
    ** HISTORY: caused either an ArrayIndexOutOfBoundException to be thrown
    **          or Wonka to segfault due to wrong phi-node placement as the
    **          result of invalid contexts.
    **
    ** [Don't touch, change or optimize this function.]
    */
 
    int[] i = new int[30];
    i[x] = 1;

    if (i[x] == 1) {
      i[x] = 2; 
    }

    return i[x];
  }

  public String com_test_12(int x) {
    /*
    ** HISTORY: caused either an ArrayIndexOutOfBoundException to be thrown
    **          or Wonka to segfault due to wrong phi-node placement as the
    **          result of invalid contexts.
    **
    ** [Don't touch, change or optimize this function.]
    */
 
    String[] s = new String[30];
    s[x] = "abc";

    if (s[x].equals("abc")) {
      s[x] = "def"; 
    }

    return s[x];
  }

  public int com_test_13(int x) {
    /*
    ** HISTORY: the variable "count" was never being incremented (while
    **          it should) because of a bug in the compiler backend.
    **
    ** [Don't touch, change or optimize this function.]
    */
 
    int count = 0;
    if (x < 10 & (x != 7 | x == 15)) {
      count++;
    }
    return count;
  }

  int arr[] = { 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 };
 
  public int com_test_14(int x) {
    /*
    ** HISTORY: caused wonka to segfault because of an off-by-one error
    **          in the translation process.
    **
    ** [Don't touch, change or optimize this function.]
    */

    int state = index;
    return state++;
  }
 
  public char com_test_15(int x) {
    /*
    ** HISTORY: the incremented value of "i" was used to retrieve the
    **          array element (1) because live analysis was a bit too
    **          conservative and (2) because stack slots are shared.
    **
    **          Compiled using jikes 1.12, the relevant (simplified) 
    **          bytecode looks as follows:
    **
    **           1. load_2        -- load local 2 on the operand stack
    **                            -- spill local 2 to stack location x
    **           2. iinc 2 1      -- increment local 2, the version on
    **                               stack remains unchanged
    **                            -- spill local 2 to stack location x
    **           3. "consume_2"   -- consume the local's original value
    **                            -- load local 2 from satck --> oops!
    **
    ** [Don't touch, change or optimize this function.]
    */

    int i = x;

    ca[i++] = 'x';
    
    return ca[i];
  }
 
  public int com_test_16(int x) {
    /*
    ** HISTORY: triggered a bug in the "j_native_call"-entry of the ARM
    **          machine description language.
    **
    ** [Don't touch, change or optimize this function.]
    */

    int array[] = new int[30];
    int k = x;

    for (int l = 0; l < 30; l++) {
      array[l] += x;
    }

    return array[x];
  }

  public int com_test_17(int x) {
    /*
    ** HISTORY: triggered a bug in the "j_native_call"-entry of the ARM
    **          machine description language.
    **
    ** [Don't touch, change or optimize this function.]
    */

    int array[][] = new int[30][30];
    int k = x;
 
    for (int l = 0; l < 30; l++) {
      array[l][k] = l + k;
    }

    return array[x][x];
  }

 public int com_test_18(int x) {
    /*
    ** HISTORY: problem with the construction of the IR's DAG.
    **
    ** [Don't touch, change or optimize this function.]
    */

    int state = 0;

    if (x < 10) {
      state = 1;
    
      if (x > 30) {
        throw new RuntimeException();  // this should never trigger
      }
    }
    else if (x < 15) {
      state = 2;
      if (x > 30) {
        throw new RuntimeException();  // this should never trigger
      }
    }
    else if (x < 20) {
      state = 3;
      if (x > 30) {
        throw new RuntimeException();  // this should never trigger
      }
    }
  
    return state;
  }

  public int com_test_19(String s) {

    /*
    ** HISTORY: problem with the construction of the IR's DAG; an
    **          overflow of the incoming/outgoing edge arrays.
    **
    ** [Don't touch, change or optimize this function.]
    */
 
    int result = 0;
    String remainder = s;
    
    while (remainder != null) {
      char a;

      if (remainder.length() > 0) {
        a = remainder.charAt(0);
        remainder = remainder.substring(1);
      }
      else {
        a = '0';
        remainder = null;
      }

      if (a == 'a') {
        result |= 1;
      }
      else if (a == 'b') {
        result |= 2;
      }
      else if (a == 'c') {
        result |= 4;
      }
      else if (a == 'd') {
        result |= 8;
      }
    }

    return result;
  }

  public int com_test_20(String s) {

    /*
    ** HISTORY: problem with the construction of the IR's DAG.
    **
    ** [Don't touch, change or optimize this function.]
    */
 
    if (s == null) {
      return 1;
    }

    int i = 0;
    char c[] = s.toCharArray();

    do {
      while (i < c.length && c[i] == 'x')  {
        i++;
      }
      i++;
    } 
    while (i < c.length);

    return i;
  }

  public boolean com_test_21(int x) {
    /*
    ** HISTORY: problem with "iseq" and "isne" idioms; the "iseq" and
    **          "isne" bytecode sequences were being replaced despite 
    **          the fact it was reachable from elsewhere (double join
    **          point).
    **
    ** [Don't touch, change or optimize this function.]
    */
    int a = 5;
    return (x > a && foo(x, a));
  }

  public int com_test_22(int x) {
    /*
    ** HISTORY: problem with liveness analysis, triggered ICE because
    **          of an invalid use counter. 
    **
    ** [Don't touch, change or optimize this function.]
    */
 
    int state = 0;
    return foo(state = state + x);   // this statement is rather odd
  }

  public int com_test_23(int x) {
    try {
      char array[] = new char[x];
    }
    catch (NegativeArraySizeException e) {
      return x;
    }
    return -x;
  }

  public int com_test_24(int x) {
    /*
    ** HISTORY: problem with the construction of the IR's DAG.
    **
    ** [Don't touch, change or optimize this function.]
    */
 
    return index + (bar(x) ? index : 0);
  }

  public int int_test_25(String s) {
    if (s == null) {
      return -1;
    }
    else {
      char string[] = s.toCharArray(); 
      int length = string.length;
      int value = 0;
      for (int i = 0; i < length; i++) {
        char c = string[i];
        bar(c);
        value += (int)c;
      }
      return value;
    }
  }

  public int com_test_25(String s) {
    if (s == null) {
      return -1;
    }
    else {
      char string[] = s.toCharArray(); 
      int length = string.length;
      int value = 0;
      for (int i = 0; i < length; i++) {
        char c = string[i];
        bar(c);
        value += (int)c;
      }
      return value;
    }
  }

  public void run(JTest jt) {
    int i[] = { 5, 3, 7, 0, 9, 20, 8, 15, 6, 10 }; 
    boolean b[] = { true, false, true, false, true, false, true, false, true, false };
    String s[] = { "abcd", "abc", "ab", "a", "", null, "abcd", "a", "", null };
     // NOTE: don't change any array elements or you'll render some tests unusable!

    for (int j = 0; j < 10; j++) {
      jt.check(int_test_1(b[j]), com_test_1(b[j]), "ProblemTest.com_test_1("+ b[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_2(i[j]), com_test_2(i[j]), "ProblemTest.com_test_2("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_3(s[j]), com_test_3(s[j]), "ProblemTest.com_test_3("+ s[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_4(s[j]), com_test_4(s[j]), "ProblemTest.com_test_4("+ s[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_5(s[j]), com_test_5(s[j]), "ProblemTest.com_test_5("+ s[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_6(i[j]), com_test_6(i[j]), "ProblemTest.com_test_6("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_7(i[j]), com_test_7(i[j]), "ProblemTest.com_test_7("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_8(i[j]), com_test_8(i[j]), "ProblemTest.com_test_8("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_9(i[j]), com_test_9(i[j]), "ProblemTest.com_test_9("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_10(i[j]), com_test_10(i[j]), "ProblemTest.com_test_10("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_11(i[j]), com_test_11(i[j]), "ProblemTest.com_test_11("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_12(i[j]), com_test_12(i[j]), "ProblemTest.com_test_12("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_13(i[j]), com_test_13(i[j]), "ProblemTest.com_test_13("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_14(i[j]), com_test_14(i[j]), "ProblemTest.com_test_14("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_15(i[j]), com_test_15(i[j]), "ProblemTest.com_test_15("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_16(i[j]), com_test_16(i[j]), "ProblemTest.com_test_16("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_17(i[j]), com_test_17(i[j]), "ProblemTest.com_test_17("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_18(i[j]), com_test_18(i[j]), "ProblemTest.com_test_18("+ i[j] +")");
    } 
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_19(s[j]), com_test_19(s[j]), "ProblemTest.com_test_19("+ s[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_20(s[j]), com_test_20(s[j]), "ProblemTest.com_test_20("+ s[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_21(i[j]), com_test_21(i[j]), "ProblemTest.com_test_21("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_22(i[j]), com_test_22(i[j]), "ProblemTest.com_test_22("+ i[j] +")");
    }
    for (int j = -5; j < 5; j++) {  // should be negative as well
      jt.check(int_test_23(j), com_test_23(j), "ProblemTest.com_test_23("+ j +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_24(i[j]), com_test_24(i[j]), "ProblemTest.com_test_24("+ i[j] +")");
    }
    for (int j = 0; j < 10; j++) {
      jt.check(int_test_25(s[j]), com_test_25(s[j]), "ProblemTest.com_test_25("+ s[j] +")");
    }
 
  }
}
