/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

package com.acunia.wonka.test.jspot;

public class StackTest  {
 
  public int com_iconst_m1() {
    return -1;
  }

  public int com_iconst_0() {
    return 0;
  }

  public int com_iconst_1() {
    return 1;
  }

  public int com_iconst_2() {
    return 2;
  }

  public int com_iconst_3() {
    return 3;
  }

  public int com_iconst_4() {
    return 4;
  }

  public int com_iconst_5() {
    return 5;
  }

  public int com_bipush_1() {
    return 100;
  }

  public int com_bipush_2() {
    return -100;             // check sign
  }

  public int com_bipush_3() {
    /*
    ** "255" marks an interesting test case as on some architectures
    ** (such as on ARM) it is the maximum value that can be direclty 
    ** loaded into a register without using the constant pool.
    */

    return 255;
  }
  
  public int com_bipush_4() {
    /*
    ** "-254" marks an interesting test case as on some architectures
    ** (such as on ARM) it is the minimum value that can be direclty 
    ** loaded into a register without using the constant pool.
    */

    return -254;            // check sign
  }

  public int com_sipush_1() {
    return 400;
  }

  public int com_sipush_2() {
    return -400;             // check sign
  }

  public int com_sipush_3() {
    return -255;             // check sign
  }
  
  public int com_ldc_1() {
    return 100000;
  }

  public int com_ldc_2() {
    return -100000;          // check sign
  }

  public int com_ldc_3() {
    return 2147483647;       // maximum value
  }

  public int com_ldc_4() {
    return -2147483648;      // check sign, minimum value
  }
  
  public float com_fconst_0() {
    return 0;
  }  
 
  public float com_fconst_1() {
    return 1;
  }

  public float com_fconst_2() {
    return 2;
  }

  public Object com_aconst_null() {
    return null;
  }

  public int com_iloadstore_1() {
    int i1 = 1;              // istore_1
    return i1;               // iload_1
  }

  public int com_iloadstore_2() {
    int i1 = 1;              // istore_1
    int i2 = 2;              // istore_2
    return i1;               // iload_1
  }

  public int com_iloadstore_3() {
    int i1 = 1;              // istore_1
    int i2 = 2;              // istore_2
    int i3 = 3;              // istore_3
    return i1;               // iload_1
  }

  public int com_iloadstore_4() {
    int i1 = 1;              // istore_1
    int i2 = 2;              // istore_2
    int i3 = 3;              // istore_3
    int i4 = 4;              // istore <4>
    return i2;               // iload_1
  }

  public int com_iloadstore_5() {
    int i1 = 1;              // istore_1
    int i2 = 2;              // istore_2
    int i3 = 3;              // istore_3
    int i4 = 4;              // istore <4>
    int i5 = 5;              // istore <5>
    return i2;               // iload_1
  }
  
  public int com_iloadstore_6() {
    /*
    ** This test case is particularly interesting on architectures (such
    ** as ARM) that use a constant pool.
    */

    int i1 = 1000;           // sipush + istore_1
    return i1;               // iload_1
  }

  public int com_iloadstore_7() {
    /*
    ** This test case is particularly interesting on architectures (such
    ** as ARM) that use a constant pool.
    */

    int i1 = 1000;           // sipush + istore_1
    int i2 = 2000;           // sipush + istore_2
    return i1;               // iload_2
  }

  public int com_iloadstore_8() {
    /*
    ** This test case is particularly interesting on architectures (such
    ** as ARM) that use a constant pool.
    */

    int i1 = 1000;           // sipush + istore_1
    int i2 = 2000;           // sipush + istore_2
    int i3 = 3000;           // sipush + istore_3
    return i1;               // iload_3
  }

  public int com_iloadstore_9() {
    /*
    ** This test case is particularly interesting on architectures (such
    ** as ARM) that use a constant pool.
    */

    int i1 = 1000;           // sipush + istore_1
    int i2 = 2000;           // sipush + istore_2
    int i3 = 3000;           // sipush + istore_3
    int i4 = 4000;           // sipush + istore <4>
    return i2;               // iload <4>
  }

  public int com_iloadstore_10() {
    /*
    ** This test case is particularly interesting on architectures (such
    ** as ARM) that use a constant pool.
    */

    int i1 = 1000;           // sipush + istore_1
    int i2 = 2000;           // sipush + istore_2
    int i3 = 3000;           // sipush + istore_3
    int i4 = 4000;           // sipush + istore <4>
    int i5 = 5000;           // sipush + istore <5>
    return i2;               // iload <5>
  }

  public float com_floadstore_1() {
    float f1 = 1;            // fstore_1
    return f1;               // fload_1
  }

  public float com_floadstore_2() {
    float f1 = 1;            // fstore_1
    float f2 = 2;            // fstore_2
    return f2;               // fload_2
  }

  public float com_floadstore_3() {
    float f1 = 1;            // fstore_1
    float f2 = 2;            // fstore_2
    float f3 = 3;            // fstore_3
    return f3;               // fload_3
  }

  public float com_floadstore_4() {
    float f1 = 1;            // fstore_1
    float f2 = 2;            // fstore_2
    float f3 = 3;            // fstore_3
    float f4 = 4.2f;         // fstore <4>
    return f4;               // fload <4>
  }

  public float com_floadstore_5() {
    float f1 = 1;            // fstore_1
    float f2 = 2;            // fstore_2
    float f3 = 3;            // fstore_3
    float f4 = 4.2f;         // fstore <4>
    float f5 = 5.3f;         // fstore <5>
    return f5;               // fload <5>
  }

  public void run(JTest jt) {

    /*
    ** Test the instructions that push constants onto the operand 
    ** stack.
    */

    // Integers:
    jt.check(com_iconst_m1(), com_iconst_m1(), "StackTest.com_iconst_m1()");
    jt.check(com_iconst_0(), com_iconst_0(), "StackTest.com_iconst_0()");
    jt.check(com_iconst_1(), com_iconst_1(), "StackTest.com_iconst_1()");
    jt.check(com_iconst_2(), com_iconst_2(), "StackTest.com_iconst_2()");
    jt.check(com_iconst_3(), com_iconst_3(), "StackTest.com_iconst_3()");
    jt.check(com_iconst_4(), com_iconst_4(), "StackTest.com_iconst_4()");
    jt.check(com_iconst_5(), com_iconst_5(), "StackTest.com_iconst_5()");
    jt.check(com_bipush_1(), com_bipush_1(), "StackTest.com_bipush_1()");
    jt.check(com_bipush_2(), com_bipush_2(), "StackTest.com_bipush_2()");
    jt.check(com_bipush_3(), com_bipush_3(), "StackTest.com_bipush_3()");
    jt.check(com_bipush_4(), com_bipush_4(), "StackTest.com_bipush_4()");
    jt.check(com_sipush_1(), com_sipush_1(), "StackTest.com_sipush_1()");
    jt.check(com_sipush_2(), com_sipush_2(), "StackTest.com_sipush_2()");
    jt.check(com_sipush_3(), com_sipush_3(), "StackTest.com_sipush_3()");
    jt.check(com_ldc_1(), com_ldc_1(), "StackTest.com_ldc_1()");
    jt.check(com_ldc_2(), com_ldc_2(), "StackTest.com_ldc_2()");
    jt.check(com_ldc_3(), com_ldc_3(), "StackTest.com_ldc_3()");
    jt.check(com_ldc_4(), com_ldc_4(), "StackTest.com_ldc_4()");
    
    // Object references:
    jt.check(com_aconst_null(), com_aconst_null(), "StackTest.com_aconst_null()");

    // Float:
    jt.check(com_fconst_0(), com_fconst_0(), "StackTest.com_fconst_0()");
    jt.check(com_fconst_1(), com_fconst_1(), "StackTest.com_fconst_1()");
    jt.check(com_fconst_2(), com_fconst_2(), "StackTest.com_fconst_2()");

    // Longs:
      // TODO

    // Doubles:
      // TODO

    /*
    ** Test the instructions that load and store local variables.
    */

    jt.check(com_iloadstore_1(), com_iloadstore_1(), "StackTest.com_iloadstore_1()");
    jt.check(com_iloadstore_2(), com_iloadstore_2(), "StackTest.com_iloadstore_2()");
    jt.check(com_iloadstore_3(), com_iloadstore_3(), "StackTest.com_iloadstore_3()");
    jt.check(com_iloadstore_4(), com_iloadstore_4(), "StackTest.com_iloadstore_4()");
    jt.check(com_iloadstore_5(), com_iloadstore_5(), "StackTest.com_iloadstore_5()");
    jt.check(com_iloadstore_6(), com_iloadstore_6(), "StackTest.com_iloadstore_6()");
    jt.check(com_iloadstore_7(), com_iloadstore_7(), "StackTest.com_iloadstore_7()");
    jt.check(com_iloadstore_8(), com_iloadstore_8(), "StackTest.com_iloadstore_8()");
    jt.check(com_iloadstore_9(), com_iloadstore_9(), "StackTest.com_iloadstore_9()");
    jt.check(com_iloadstore_10(), com_iloadstore_10(), "StackTest.com_iloadstore_10()");
    
    jt.check(com_floadstore_1(), com_floadstore_1(), "StackTest.com_floadstore_1()");
    jt.check(com_floadstore_2(), com_floadstore_2(), "StackTest.com_floadstore_2()");
    jt.check(com_floadstore_3(), com_floadstore_3(), "StackTest.com_floadstore_3()");
    jt.check(com_floadstore_4(), com_floadstore_4(), "StackTest.com_floadstore_4()");
    jt.check(com_floadstore_5(), com_floadstore_5(), "StackTest.com_floadstore_5()");
  }
}

