/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: arena.c 3863 2003-04-25 09:23:25Z dbuytaert $
*/

#include "oswald.h"
#include "j-spot.h"
#include "arena.h"

/*
** TODO: at the momemt this arena implementation is rather simple 
**       though it will be substituted by something slightly more
**       efficient; eg. we can allocate larger chunks at once and
**       eliminate most of the memory locking/allocation overhead.
*/

static j_block arena = NULL;
static int size = 0;

void * arena_allocate(unsigned int bytes) {

  j_block block = x_mem_calloc(sizeof(j_Block) + bytes);
 
  if (block) {
    block->next = arena;
    arena = block;
    size += bytes;
    return &block->begin; 
  }
  else {
    jfail("no more memory available\n");
    return NULL;
  }
}

void arena_release(void) {

  j_block next = arena;
  j_block curr;

  while (next) {
    curr = next;
    next = next->next;
    x_mem_free(curr); 
  }

  arena = NULL;
  size = 0;
}

int arena_size(void) {
  return size;
}

