/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: check-elimination.c 3975 2003-05-28 14:07:45Z dbuytaert $
*/

#include "j-spot.h"
#include "method.h"
#include "node.h"
#include "ir.h"
#include "mimic-stack.h"

void ce_update(j_node node, j_node branch, j_node target) {

  j_node temp;
  int i;

  /*
  ** Check if the node is available in the post state of the branch.
  */

  for (i = 0; i < jm->slots; i++) {
    temp = ms_node_state(branch->pc, j_post_execution, i);
    if (temp == node) {
      w_dump("\n\nHIT: %q has duplicate!\n\n", node);
    }
  }

}

void ce_walk_ir(j_node node) {

  int i;

  if (node->visited != 3) { 

     // mark the node as visited:
     node->visited = 3;

    if (ir_is_split(node) && !ir_is_join(node)) {

      if (node->node1->operator == j_constant) {
        ce_update(node->node2, node, node->outgoing[1]);
      }    
 
      if (node->node2->operator == j_constant) {
        ce_update(node->node1, node, node->outgoing[1]);
      }    
    }

    for (i = 0; i < j_max_edges; i++) {
      if (node->outgoing[i]) {
        ce_walk_ir(node->outgoing[i]);
      }
    }
  }
}

void check_elimination(void) {

  // ce_walk_ir(jm->start);
}

