/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: liveness.c 3863 2003-04-25 09:23:25Z dbuytaert $
*/

#include "j-spot.h"
#include "ir.h"

/*
** Check if the given node is live at the current position.  If the
** node is live, return an indication of its time to live.  The
** higher the value, the longer it will be live.  If the node is 
** dead, return zero.
*/
int la_is_live(j_node node) {

  #ifdef DEBUG
    if (node->use < 0) {
      jabort("use counter has incorrect value: %d\n", node->use);
    }
  #endif
    
  /*
  ** Because we collect parameters lazily during IR construction,
  ** the current context might not be 100% accurate with regard to
  ** parameters passed in registers; on ARM for example, parameters
  ** 1 to 4 are passed in registers and might be "live" dispite the
  ** fact they are not listed in the current context.
  */
  
  if (node_is_parameter(node)) {
    return 1;
  }

  return node->use;
}

/*
** Compute liveness information.
*/
void liveness(void) {
}
