#ifndef _J_BURG_H
#define _J_BURG_H

/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: burg.h 3863 2003-04-25 09:23:25Z dbuytaert $ 
*/

#include <stdio.h>

typedef struct j_Nonterminal * j_nonterminal;
typedef struct j_Terminal * j_terminal;
typedef struct j_Tree * j_tree;
typedef struct j_Rule * j_rule;
typedef struct j_List * j_list;

typedef struct j_Terminal {
  char *name;
  int number;
  int arity;
  j_list rules;               // rules that have this terminal on the right-hand side
  j_terminal next;
} j_Terminal;

typedef struct j_Nonterminal {
  char *name;
  int number;
  int arity;
  j_list rules;               // rules that have this non-terminal on the left-hand side
  j_list chain;               // rules that have this non-terminal on the right-hand side
  j_nonterminal next;
} j_Nonterminal;

typedef struct j_Tree {
  char *name;
  j_terminal terminal;
  j_nonterminal nonterminal;
  j_tree ltree;
  j_tree rtree;
} j_Tree;

typedef struct j_Rule {
  char *name;
  char *code;
  char *cost;
  int number;
  j_nonterminal nonterminal;
  j_tree tree;
  j_rule next;
} j_Rule;

typedef struct j_List {
  j_rule rule;
  j_list next;
} j_List;

void header_create(char * header);
void footer_create(char * header);
j_terminal terminal_create(char * name);
j_nonterminal nonterminal_create(char * name);
j_tree tree_create(char * name, j_tree ltree, j_tree rtree);
j_rule rule_create(char * name, j_tree tree, char * code, char * cost);

#endif /* _J_BURG_H */
