
header {
  #include "ir.h"
}

terminal j_add, j_neg, j_sub, j_literal;


statement: register;

register: j_add(constant, constant);

register: j_sub(register, register);

register: j_neg(j_neg(register))
  code {
    fprintf(stderr, "\n\nneg - neg\n\n");
  } 
  cost {
    return 3;
  }

register: j_neg(register)
  code {
    fprintf(stderr, "\n\nneg\n\n");
  }
  cost {
    return 3;
  }

constant: j_literal
  code {
    fprintf(stderr, "\n\nconvert literal to constant\n\n");
  }

register: j_literal;

footer {
  j_node node_create(j_operator operator, j_node l, j_node r) {

    j_node node = (j_node)calloc(1, sizeof(j_Node));
    node->operator = operator;
    node->node1 = l;
    node->node2 = r;

    return node;
  }

  void walk(j_node node, int goal, int depth) {

    j_node kids[3];
    short *nts;
    int rule;
   
    rule = burg_rule(node->state, goal);
    nts = burg_nts[rule];

    if (rule && nts) {
      burg_kids(node, rule, kids);
 
      fprintf(stderr, "%snode %d (%p), goal %d, rule '%s' (%d), nts %p, kids[0] = %d, kids[1] = %d\n", burg_spaces(depth), node->operator, node, goal, burg_rule_name[rule], rule, nts, (kids[0] ? kids[0]->operator : 0), (kids[1] ? kids[1]->operator : 0));

      burg_code(rule, NULL, node);

      if (kids[0]) {
        walk(kids[0], nts[0], depth + 1);
      }
  
      if (kids[1]) {
        walk(kids[1], nts[1], depth + 1);
      }
    }
    else {
      fprintf(stderr, "%snode %d, goal %d, rule '%s' (%d), nts %p\n", burg_spaces(depth), node->operator, goal, burg_rule_name[rule], rule, nts);
    }
  }

  int main(int argc, char * argv[]) {

    j_state state;
    j_node tree;

    // tree = literal + literal;
    tree = node_create(j_add, node_create(j_literal, NULL, NULL), node_create(j_literal, NULL, NULL));

    // tree = tree - literal;
    tree = node_create(j_sub, tree, node_create(j_literal, NULL, NULL));

    // tree = neg(neg(tree));
    tree = node_create(j_neg, node_create(j_neg, tree, NULL), NULL);

    tree = node_create(j_neg, node_create(j_neg, tree, NULL), NULL);

    state = burg_label(tree); 
      
    if (state) {
      fprintf(stderr, "\n-- the subject tree has been labeled (matched)\n\n");
    }
    else {
      fprintf(stderr, "\n-- the subject tree is unmatchted: the tree may be corrupt or inconistent with the grammar\n\n");
      abort();
    }
  
    walk(tree, 1, 0);   
       
    fprintf(stderr, "\n-- the subject tree has been reduced (walked)\n\n");

    burg_dump_tree(tree, 0);

    return 0;
  }
}
