/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

%{

#include <string.h>
#include "parser.h"

extern int yylval;
int line = 1;

%}

%%
\/\/.*                  {
                          // ignore comments
                        }
"#".*                   {
                          // ignore comments
                        }
[ \t]                   { 
                          // ignore whitespaces
                        }
\n                      { 
                          line++; 
                        }
"{"                     { 
                          static char buffer[1024 * 50];
                          char c = 1;  // the current input character
                          int o = 1;   // the number of open brackets
                          int i = 0;   // the current buffer location

                          while (o && c) {
                            c = input(); 
                            buffer[i] = c;

                            if (c == '{') {
                              o++;
                            }  

                            if (c == '}') {
                              o--;
                            }
                            
                            if (c == '\n') {
                              line++;
                            }

                            i++;
                          }
                          buffer[i - 1] = '\0'; 
                          yylval = (int)strdup(buffer);
                          return BLOCK;
                        }
terminal                {
                          return TERMINAL;
                        }
cost                    {
                          return COST;
                        }
code                    {
                          return CODE;
                        }
header                  {
                          return HEADER;
                        }
footer                  {
                          return FOOTER;
                        }
[a-zA-Z_][a-zA-Z_0-9]*  {
                          yylval = (int)strdup(yytext); 
                          return WORD; 
                        }
.                       {
                          return yytext[0]; 
                        }

%%
