/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

%{

#include <stdio.h>
#include <stdarg.h>
#include "burg.h"

%}

%token BLOCK CODE COST HEADER FOOTER TERMINAL WORD

%%

statement: terminal statement
         | header statement
         | footer statement
         | rule statement
         | /* empty */
         ;

header: HEADER BLOCK                                 { header_create((char *)$2); }
      ;

footer: FOOTER BLOCK                                 { footer_create((char *)$2); }
      ;

terminal: TERMINAL terminals ';'

terminals: WORD ',' terminals                        { terminal_create((char *)$1); }
         | WORD                                      { terminal_create((char *)$1); }
         ;

rule: nonterminal ':' tree ';'                       { rule_create((char *)$1, (j_tree)$3, "", "return 1;"); }
    | nonterminal ':' tree COST BLOCK                { rule_create((char *)$1, (j_tree)$3, "", (char *)$5); }
    | nonterminal ':' tree CODE BLOCK                { rule_create((char *)$1, (j_tree)$3, (char *)$5, "return 1;"); }
    | nonterminal ':' tree COST BLOCK CODE BLOCK     { rule_create((char *)$1, (j_tree)$3, (char *)$7, (char *)$5); }
    | nonterminal ':' tree CODE BLOCK COST BLOCK     { rule_create((char *)$1, (j_tree)$3, (char *)$5, (char *)$7); }
    ;

nonterminal: WORD                                    { nonterminal_create((char *)$1); }

tree: WORD                                           { (j_tree)$$ = tree_create((char *)$1, NULL, NULL); }
    | WORD '(' tree ')'                              { (j_tree)$$ = tree_create((char *)$1, (j_tree)$3, NULL); }
    | WORD '(' tree ',' tree ')'                     { (j_tree)$$ = tree_create((char *)$1, (j_tree)$3, (j_tree)$5); }
    ;

%% 

extern int line;

int yywrap(void) {

  /*
  ** The function 'yywrap()' is called when EOF is reached on the 
  ** current input.  Return true if processing is finished, or do
  ** something to fix the EOF condition and return 0 to indicate
  ** more input is available.
  */

  return 1;
}

int yyerror(char * fmt, ...) {
  va_list ap;

  va_start(ap, fmt);
  fprintf(stderr, "error on line %d: ", line);
  vfprintf(stderr, fmt, ap);
  fprintf(stderr, "\n");  // YACC nor LEX do add an EOL character
  va_end(ap);

  exit(-1);
}

