/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


package javax.crypto;

import java.security.Key;
import java.security.InvalidKeyException;
import java.security.InvalidAlgorithmParameterException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.spec.AlgorithmParameterSpec;

public abstract class KeyAgreementSpi {

  public KeyAgreementSpi(){}

  protected abstract void engineInit(Key key, SecureRandom srandom) throws InvalidKeyException;

  protected abstract void engineInit(Key key, AlgorithmParameterSpec params, SecureRandom srandom)
    throws InvalidKeyException, InvalidAlgorithmParameterException;

  protected abstract Key engineDoPhase(Key key, boolean last)
    throws InvalidKeyException, IllegalStateException;

  protected abstract byte[] engineGenerateSecret() throws IllegalStateException;

  protected abstract int engineGenerateSecret(byte[] bytes, int offset)
    throws IllegalStateException, ShortBufferException;

  protected abstract SecretKey engineGenerateSecret(String algorithm)
    throws IllegalStateException, NoSuchAlgorithmException, InvalidKeyException;
}
