/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

#include "oswald.h"  /* x_thread_... */
#include "wonka.h"   /* the w_ types */
#include "ts-mem.h"  /* allocMem_system */
#include "realms.h"  /* allocMem_system */
#include "jdwp.h"
#include "clazz.h"       /* w_clazz struct */

/*
** Get the superclass of the given class.
*/

w_void jdwp_class_superclass(jdwp_command_packet cmd) {
  w_clazz clazz;
  w_clazz super;
  w_int   ID;

  /*
  ** Get the class from the command packet.
  */

  memcpy(&clazz, &cmd->data[0], 4);

  /*
  ** Get the superclass
  */
  
  super = clazz->superClazz;
  ID = (w_int)super;

  /*
  ** Send it to the debugger.
  */
  
  jdwp_send_reply(cmd->id, &ID, 4, jdwp_err_none);

  return;
}


/*
** The dispatcher for the 'Class type' command set.
*/ 

w_void dispatch_classtype(jdwp_command_packet cmd) {

  switch((jdwp_classtype_cmd)cmd->command) {
    case jdwp_classtype_superclass:     jdwp_class_superclass(cmd);   break;
    case jdwp_classtype_setValues:
    case jdwp_classtype_invokeMethod:
    case jdwp_classtype_newInstance:
      jdwp_send_reply(cmd->id, NULL, 0, jdwp_err_not_implemented);
    default:
  }
  
}

