/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

#include "oswald.h"  /* x_thread_... */
#include "wonka.h"   /* the w_ types */
#include "ts-mem.h"  /* allocMem_system */
#include "realms.h"  /* allocMem_system */
#include "jdwp.h"
#include "wstrings.h"

/*
** Get the value of a String instance
*/

w_void jdwp_string_value(jdwp_command_packet cmd) {
  w_instance  instance;
  w_ubyte     *reply;
  w_string    string;
  w_int       length;

  /*
  ** Get the instance from the command packet.
  */

  memcpy(&instance, &cmd->data[0], 4);

  /*
  ** Convert it to a wonka string.
  */

  string = String2string(instance);

  woempa(9, "String requested :  '%w'\n", string);

  /*
  ** Convert the wonka string to a JDWP UTF8 string.
  */

  reply = jdwp_string2UTF8(string, &length);

  /*
  ** Send this string to the debugger.
  */

  jdwp_send_reply(cmd->id, reply, length + 4, jdwp_err_none);

  /*
  ** Clean up.
  */

  x_mem_free(reply);

  return;
}


/*
** The dispatcher for the 'String reference' command set.
*/

w_void dispatch_strref(jdwp_command_packet cmd) {

  switch((jdwp_strref_cmd)cmd->command) {
    case jdwp_strref_value:   jdwp_string_value(cmd);   break;
    default:
      jdwp_send_reply(cmd->id, NULL, 0, jdwp_err_not_implemented);
  }

}

