/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

#include "oswald.h"  /* x_thread_... */
#include "wonka.h"   /* the w_ types */
#include "ts-mem.h"  /* allocMem_system */
#include "realms.h"  /* allocMem_system */
#include "jdwp.h"
#include "jdwp-debug.h"

w_ubyte *jdwp_event_kind_str(w_int eventKind) {
  static w_ubyte  *evt_str = "";

  switch(eventKind) {
    case jdwp_evt_vm_disconnected:     evt_str = "VM disconnected";     break;
    case jdwp_evt_single_step:         evt_str = "Single step";         break;
    case jdwp_evt_breakpoint:          evt_str = "Breakpoint";          break;
    case jdwp_evt_frame_pop:           evt_str = "Frame pop";           break;
    case jdwp_evt_exception:           evt_str = "Exception";           break;
    case jdwp_evt_user_defined:        evt_str = "User defined";        break;
    case jdwp_evt_thread_start:        evt_str = "Thread start";        break;
    case jdwp_evt_thread_end:          evt_str = "Thread end";          break;
    case jdwp_evt_class_prepare:       evt_str = "Class prepare";       break;
    case jdwp_evt_class_unload:        evt_str = "Class unload";        break;
    case jdwp_evt_class_load:          evt_str = "Class load";          break;
    case jdwp_evt_field_access:        evt_str = "Field access";        break;
    case jdwp_evt_field_modification:  evt_str = "Field modification";  break;
    case jdwp_evt_exception_catch:     evt_str = "Exception catch";     break;
    case jdwp_evt_method_entry:        evt_str = "Method entry";        break;
    case jdwp_evt_method_exit:         evt_str = "Method exit";         break;
    case jdwp_evt_vm_init:             evt_str = "VM init";             break;
    case jdwp_evt_vm_death:            evt_str = "VM death";            break;
    default:                           evt_str = "unknown";
  }

  return evt_str;
}

w_ubyte *jdwp_suspend_policy_str(w_int suspendPolicy) {
  static w_ubyte *suspend_str = "";

  switch(suspendPolicy) {
    case jdwp_sp_none:          suspend_str = "Suspend no threads";         break;
    case jdwp_sp_event_thread:  suspend_str = "Suspend the event thread.";  break;
    case jdwp_sp_all:           suspend_str = "Suspend all threads.";       break;
    default:                    suspend_str = "unknown";
  }

  return suspend_str;
}
  
w_ubyte *jdwp_mod_kind_str(w_int mod_kind) {
  static w_ubyte  *mod_str = "";

  switch(mod_kind) {
    case  1: mod_str = "Count";          break;
    case  2: mod_str = "Conditional";    break;
    case  3: mod_str = "ThreadOnly";     break;
    case  4: mod_str = "ClassOnly";      break;
    case  5: mod_str = "ClassMatch";     break;
    case  6: mod_str = "ClassExclude";   break;
    case  7: mod_str = "LocationOnly";   break;
    case  8: mod_str = "ExceptionOnly";  break;
    case  9: mod_str = "FieldOnly";      break;
    case 10: mod_str = "Step";           break;
    case 11: mod_str = "InstanceOnly";   break;
    default: mod_str = "unknown";
  }

  return mod_str;
}

