/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


package gnu.testlet.Junittests.io;

import java.io.*;

public class SAMPLE_SerialObject {
  private static String [] arrayString={"secondtest","secondteststring","......"};
  private static int [] arrayInt={21,22,23,24,25,26,27,28,29,20,Integer.MAX_VALUE,Integer.MIN_VALUE};


public static SAMPLE_ObjectStream_B getRootObject() {



    SAMPLE_ObjectStream_A a1=new SAMPLE_ObjectStream_A(1);
    SAMPLE_ObjectStream_B b1=new SAMPLE_ObjectStream_B(2);
    SAMPLE_ObjectStream_B b2=new SAMPLE_ObjectStream_B(3);
    SAMPLE_ObjectStream_C c1=new SAMPLE_ObjectStream_C(4);
    SAMPLE_ObjectStream_C c2=new SAMPLE_ObjectStream_C(5);
    SAMPLE_ObjectStream_D d1=new SAMPLE_ObjectStream_D("d1   d1");
    SAMPLE_ObjectStream_D d2=new SAMPLE_ObjectStream_D("d2 d2 d2");


    a1.setD(d2);
    c2.setD(d2);
    c1.setD(d1);
    b1.setD(d2);
    b2.setD(d1);

    c1.setRight(b2);
    b2.setLeft(a1);
    b2.setRight(c2);
    b1.setLeft(b2);
    b1.setRight(c1);



    return b1;
}


public static SAMPLE_ObjectStream_OuterClass getOuterClass() {
  return new SAMPLE_ObjectStream_OuterClass();
}


static int [] dataInt = {
0xac, 0xed, 0x0, 0x5, 0x73, 0x72, 0x0, 0x2f, 0x67, 0x6e, 0x75, 0x2e, 0x74, 0x65, 0x73, 0x74,
0x6c, 0x65, 0x74, 0x2e, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2e, 0x69,
0x6f, 0x2e, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53,
0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x42, 0x4c, 0xeb, 0xb1, 0x35, 0x1f, 0x68, 0xbe, 0xb7, 0x2,
0x0, 0x9, 0x5b, 0x0, 0xc, 0x61, 0x72, 0x72, 0x61, 0x79, 0x42, 0x6f, 0x6f, 0x6c, 0x65, 0x61,
0x6e, 0x74, 0x0, 0x2, 0x5b, 0x5a, 0x5b, 0x0, 0x9, 0x61, 0x72, 0x72, 0x61, 0x79, 0x42, 0x79,
0x74, 0x65, 0x74, 0x0, 0x2, 0x5b, 0x42, 0x5b, 0x0, 0x9, 0x61, 0x72, 0x72, 0x61, 0x79, 0x43,
0x68, 0x61, 0x72, 0x74, 0x0, 0x2, 0x5b, 0x43, 0x5b, 0x0, 0xb, 0x61, 0x72, 0x72, 0x61, 0x79,
0x44, 0x6f, 0x75, 0x62, 0x6c, 0x65, 0x74, 0x0, 0x2, 0x5b, 0x44, 0x5b, 0x0, 0xa, 0x61, 0x72,
0x72, 0x61, 0x79, 0x46, 0x6c, 0x6f, 0x61, 0x74, 0x74, 0x0, 0x2, 0x5b, 0x46, 0x5b, 0x0, 0x8,
0x61, 0x72, 0x72, 0x61, 0x79, 0x49, 0x6e, 0x74, 0x74, 0x0, 0x2, 0x5b, 0x49, 0x5b, 0x0, 0x9,
0x61, 0x72, 0x72, 0x61, 0x79, 0x4c, 0x6f, 0x6e, 0x67, 0x74, 0x0, 0x2, 0x5b, 0x4a, 0x5b, 0x0,
0xa, 0x61, 0x72, 0x72, 0x61, 0x79, 0x53, 0x68, 0x6f, 0x72, 0x74, 0x74, 0x0, 0x2, 0x5b, 0x53,
0x5b, 0x0, 0xb, 0x61, 0x72, 0x72, 0x61, 0x79, 0x53, 0x74, 0x72, 0x69, 0x6e, 0x67, 0x74, 0x0,
0x13, 0x5b, 0x4c, 0x6a, 0x61, 0x76, 0x61, 0x2f, 0x6c, 0x61, 0x6e, 0x67, 0x2f, 0x53, 0x74, 0x72,
0x69, 0x6e, 0x67, 0x3b, 0x78, 0x72, 0x0, 0x2f, 0x67, 0x6e, 0x75, 0x2e, 0x74, 0x65, 0x73, 0x74,
0x6c, 0x65, 0x74, 0x2e, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2e, 0x69,
0x6f, 0x2e, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53,
0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x41, 0xc6, 0xe7, 0xa4, 0xbc, 0x7a, 0xa2, 0x5b, 0x4c, 0x2,
0x0, 0xc, 0x5a, 0x0, 0xb, 0x74, 0x65, 0x73, 0x74, 0x42, 0x6f, 0x6f, 0x6c, 0x65, 0x61, 0x6e,
0x42, 0x0, 0x8, 0x74, 0x65, 0x73, 0x74, 0x42, 0x79, 0x74, 0x65, 0x43, 0x0, 0x8, 0x74, 0x65,
0x73, 0x74, 0x43, 0x68, 0x61, 0x72, 0x44, 0x0, 0xa, 0x74, 0x65, 0x73, 0x74, 0x44, 0x6f, 0x75,
0x62, 0x6c, 0x65, 0x46, 0x0, 0x9, 0x74, 0x65, 0x73, 0x74, 0x46, 0x6c, 0x6f, 0x61, 0x74, 0x49,
0x0, 0x7, 0x74, 0x65, 0x73, 0x74, 0x49, 0x6e, 0x74, 0x4a, 0x0, 0x8, 0x74, 0x65, 0x73, 0x74,
0x4c, 0x6f, 0x6e, 0x67, 0x53, 0x0, 0x9, 0x74, 0x65, 0x73, 0x74, 0x53, 0x68, 0x6f, 0x72, 0x74,
0x49, 0x0, 0xb, 0x76, 0x6f, 0x6c, 0x61, 0x74, 0x69, 0x6c, 0x65, 0x49, 0x6e, 0x74, 0x4c, 0x0,
0x1, 0x64, 0x74, 0x0, 0x31, 0x4c, 0x67, 0x6e, 0x75, 0x2f, 0x74, 0x65, 0x73, 0x74, 0x6c, 0x65,
0x74, 0x2f, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2f, 0x69, 0x6f, 0x2f,
0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53, 0x74, 0x72,
0x65, 0x61, 0x6d, 0x5f, 0x44, 0x3b, 0x4c, 0x0, 0x4, 0x6c, 0x65, 0x66, 0x74, 0x74, 0x0, 0x31,
0x4c, 0x67, 0x6e, 0x75, 0x2f, 0x74, 0x65, 0x73, 0x74, 0x6c, 0x65, 0x74, 0x2f, 0x4a, 0x75, 0x6e,
0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2f, 0x69, 0x6f, 0x2f, 0x53, 0x41, 0x4d, 0x50, 0x4c,
0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x41,
0x3b, 0x4c, 0x0, 0x5, 0x72, 0x69, 0x67, 0x68, 0x74, 0x71, 0x0, 0x7e, 0x0, 0xc, 0x78, 0x70,
0x1, 0x3, 0x0, 0x63, 0x40, 0x8, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcd, 0x40, 0x40, 0x0, 0x0,
0x0, 0x0, 0x0, 0x3, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, 0x3, 0x0, 0x0,
0x0, 0x66, 0x73, 0x72, 0x0, 0x2f, 0x67, 0x6e, 0x75, 0x2e, 0x74, 0x65, 0x73, 0x74, 0x6c, 0x65,
0x74, 0x2e, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2e, 0x69, 0x6f, 0x2e,
0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53, 0x74, 0x72,
0x65, 0x61, 0x6d, 0x5f, 0x44, 0x4f, 0x76, 0xa9, 0x5f, 0x77, 0x75, 0x7f, 0x31, 0x2, 0x0, 0x1,
0x4c, 0x0, 0x1, 0x73, 0x74, 0x0, 0x12, 0x4c, 0x6a, 0x61, 0x76, 0x61, 0x2f, 0x6c, 0x61, 0x6e,
0x67, 0x2f, 0x53, 0x74, 0x72, 0x69, 0x6e, 0x67, 0x3b, 0x78, 0x70, 0x74, 0x0, 0x8, 0x64, 0x32,
0x20, 0x64, 0x32, 0x20, 0x64, 0x32, 0x73, 0x71, 0x0, 0x7e, 0x0, 0x0, 0x0, 0x4, 0x0, 0x64,
0x40, 0x10, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x40, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4,
0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x4, 0x0, 0x4, 0x0, 0x0, 0x0, 0x67, 0x73, 0x71,
0x0, 0x7e, 0x0, 0xe, 0x74, 0x0, 0x7, 0x64, 0x31, 0x20, 0x20, 0x20, 0x64, 0x31, 0x73, 0x71,
0x0, 0x7e, 0x0, 0xa, 0x0, 0x2, 0x0, 0x62, 0x40, 0x0, 0xcc, 0xcc, 0xcc, 0xcc, 0xcc, 0xcd,
0x40, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2,
0x0, 0x2, 0x0, 0x0, 0x0, 0x65, 0x71, 0x0, 0x7e, 0x0, 0x10, 0x70, 0x70, 0x73, 0x72, 0x0,
0x2f, 0x67, 0x6e, 0x75, 0x2e, 0x74, 0x65, 0x73, 0x74, 0x6c, 0x65, 0x74, 0x2e, 0x4a, 0x75, 0x6e,
0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2e, 0x69, 0x6f, 0x2e, 0x53, 0x41, 0x4d, 0x50, 0x4c,
0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x43,
0xc3, 0x50, 0x7e, 0x26, 0xa2, 0x5f, 0xb1, 0xeb, 0x2, 0x0, 0x1, 0x4c, 0x0, 0x1, 0x64, 0x71,
0x0, 0x7e, 0x0, 0xb, 0x78, 0x71, 0x0, 0x7e, 0x0, 0xa, 0x0, 0x6, 0x0, 0x66, 0x40, 0x18,
0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x40, 0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0,
0x0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, 0x6, 0x0, 0x0, 0x0, 0x69, 0x73, 0x71, 0x0, 0x7e,
0x0, 0xe, 0x74, 0x0, 0x5, 0x64, 0x64, 0x64, 0x64, 0x35, 0x70, 0x70, 0x71, 0x0, 0x7e, 0x0,
0x10, 0x75, 0x72, 0x0, 0x2, 0x5b, 0x5a, 0x57, 0x8f, 0x20, 0x39, 0x14, 0xb8, 0x5d, 0xe2, 0x2,
0x0, 0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0x5, 0x1, 0x0, 0x1, 0x1, 0x0, 0x75, 0x72, 0x0,
0x2, 0x5b, 0x42, 0xac, 0xf3, 0x17, 0xf8, 0x6, 0x8, 0x54, 0xe0, 0x2, 0x0, 0x0, 0x78, 0x70,
0x0, 0x0, 0x0, 0x9, 0x83, 0x9, 0x5, 0xb, 0x7, 0xb, 0x82, 0x1, 0x2, 0x75, 0x72, 0x0,
0x2, 0x5b, 0x43, 0xb0, 0x26, 0x66, 0xb0, 0xe2, 0x5d, 0x84, 0xac, 0x2, 0x0, 0x0, 0x78, 0x70,
0x0, 0x0, 0x0, 0x9, 0x0, 0x56, 0x0, 0x70, 0x0, 0x64, 0x0, 0x75, 0x0, 0x77, 0x0, 0x50,
0x0, 0x72, 0x0, 0x76, 0x0, 0x65, 0x75, 0x72, 0x0, 0x2, 0x5b, 0x44, 0x3e, 0xa6, 0x8c, 0x14,
0xab, 0x63, 0x5a, 0x1e, 0x2, 0x0, 0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0x4, 0x40, 0x47, 0xd3,
0xe9, 0x63, 0xdc, 0x48, 0x6b, 0x40, 0x41, 0xb9, 0x99, 0x99, 0x99, 0x99, 0x9a, 0x40, 0x84, 0x74,
0x0, 0x0, 0x0, 0x0, 0x0, 0xc0, 0x46, 0xa6, 0x66, 0x66, 0x66, 0x66, 0x66, 0x75, 0x72, 0x0,
0x2, 0x5b, 0x46, 0xb, 0x9c, 0x81, 0x89, 0x22, 0xe0, 0xc, 0x42, 0x2, 0x0, 0x0, 0x78, 0x70,
0x0, 0x0, 0x0, 0x5, 0x41, 0x3b, 0x33, 0x33, 0x41, 0x3, 0x33, 0x33, 0x40, 0x90, 0x0, 0x0,
0x42, 0x9c, 0x99, 0x9a, 0x42, 0x3, 0xf5, 0xc3, 0x75, 0x72, 0x0, 0x2, 0x5b, 0x49, 0x4d, 0xba,
0x60, 0x26, 0x76, 0xea, 0xb2, 0xa5, 0x2, 0x0, 0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0xc, 0x0,
0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, 0x0, 0x7, 0x0,
0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x9, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0xb, 0x0,
0x0, 0x0, 0xc, 0x0, 0x0, 0x0, 0x3, 0x7f, 0xff, 0xff, 0xff, 0x80, 0x0, 0x0, 0x0, 0x75,
0x72, 0x0, 0x2, 0x5b, 0x4a, 0x78, 0x20, 0x4, 0xb5, 0x12, 0xb1, 0x75, 0x93, 0x2, 0x0, 0x0,
0x78, 0x70, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x3, 0x0, 0x0,
0x0, 0x0, 0x0, 0x1, 0x81, 0x61, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x75, 0x72, 0x0, 0x2, 0x5b, 0x53, 0xef, 0x83, 0x2e, 0x6,
0xe5, 0x5d, 0xb0, 0xfa, 0x2, 0x0, 0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0x7, 0x0, 0xc, 0x0,
0x7e, 0x0, 0x46, 0x0, 0xc, 0x12, 0x33, 0x0, 0x62, 0xfc, 0x25, 0x75, 0x72, 0x0, 0x13, 0x5b,
0x4c, 0x6a, 0x61, 0x76, 0x61, 0x2e, 0x6c, 0x61, 0x6e, 0x67, 0x2e, 0x53, 0x74, 0x72, 0x69, 0x6e,
0x67, 0x3b, 0xad, 0xd2, 0x56, 0xe7, 0xe9, 0x1d, 0x7b, 0x47, 0x2, 0x0, 0x0, 0x78, 0x70, 0x0,
0x0, 0x0, 0x3, 0x74, 0x0, 0x5, 0x74, 0x65, 0x73, 0x74, 0x33, 0x74, 0x0, 0x13, 0x61, 0x6e,
0x6f, 0x74, 0x68, 0x65, 0x72, 0x20, 0x74, 0x65, 0x73, 0x74, 0x73, 0x74, 0x72, 0x69, 0x6e, 0x67,
0x33, 0x74, 0x0, 0x7, 0x2e, 0x2e, 0x2e, 0x2e, 0x2e, 0x2e, 0x33, 0x73, 0x71, 0x0, 0x7e, 0x0,
0x16, 0x1, 0x5, 0x0, 0x65, 0x40, 0x14, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x40, 0xa0, 0x0,
0x0, 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x5, 0x0, 0x5, 0x0,
0x0, 0x0, 0x68, 0x73, 0x71, 0x0, 0x7e, 0x0, 0xe, 0x74, 0x0, 0x5, 0x64, 0x64, 0x64, 0x64,
0x34, 0x70, 0x71, 0x0, 0x7e, 0x0, 0x12, 0x71, 0x0, 0x7e, 0x0, 0x13, 0x75, 0x71, 0x0, 0x7e,
0x0, 0x1a, 0x0, 0x0, 0x0, 0x5, 0x0, 0x1, 0x0, 0x0, 0x1, 0x75, 0x71, 0x0, 0x7e, 0x0,
0x1c, 0x0, 0x0, 0x0, 0x9, 0x82, 0x8, 0x4, 0xa, 0x6, 0xa, 0x81, 0x1, 0x2, 0x75, 0x71,
0x0, 0x7e, 0x0, 0x1e, 0x0, 0x0, 0x0, 0x9, 0x0, 0x55, 0x0, 0x6f, 0x0, 0x63, 0x0, 0x74,
0x0, 0x76, 0x0, 0x4f, 0x0, 0x71, 0x0, 0x76, 0x0, 0x65, 0x75, 0x71, 0x0, 0x7e, 0x0, 0x20,
0x0, 0x0, 0x0, 0x4, 0x40, 0x47, 0x53, 0xe9, 0x63, 0xdc, 0x48, 0x6b, 0x40, 0x41, 0x39, 0x99,
0x99, 0x99, 0x99, 0x9a, 0x40, 0x84, 0x74, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc0, 0x46, 0xa6, 0x66,
0x66, 0x66, 0x66, 0x66, 0x75, 0x71, 0x0, 0x7e, 0x0, 0x22, 0x0, 0x0, 0x0, 0x5, 0x41, 0x2b,
0x33, 0x33, 0x40, 0xe6, 0x66, 0x66, 0x40, 0x60, 0x0, 0x0, 0x42, 0x9c, 0x99, 0x9a, 0x42, 0x3,
0xf5, 0xc3, 0x75, 0x71, 0x0, 0x7e, 0x0, 0x24, 0x0, 0x0, 0x0, 0xc, 0x0, 0x0, 0x0, 0x3,
0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x5, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, 0x0, 0x7,
0x0, 0x0, 0x0, 0x8, 0x0, 0x0, 0x0, 0x9, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0xb,
0x0, 0x0, 0x0, 0x2, 0x7f, 0xff, 0xff, 0xff, 0x80, 0x0, 0x0, 0x0, 0x75, 0x71, 0x0, 0x7e,
0x0, 0x26, 0x0, 0x0, 0x0, 0x4, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x2, 0x0, 0x0,
0x0, 0x0, 0x0, 0x1, 0x81, 0x60, 0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xff,
0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0x75, 0x71, 0x0, 0x7e, 0x0, 0x28, 0x0, 0x0, 0x0, 0x7,
0x0, 0xb, 0x0, 0x7d, 0x0, 0x45, 0x0, 0xb, 0x12, 0x32, 0x0, 0x62, 0xfc, 0x25, 0x75, 0x71,
0x0, 0x7e, 0x0, 0x2a, 0x0, 0x0, 0x0, 0x3, 0x74, 0x0, 0x5, 0x74, 0x65, 0x73, 0x74, 0x32,
0x74, 0x0, 0x13, 0x61, 0x6e, 0x6f, 0x74, 0x68, 0x65, 0x72, 0x20, 0x74, 0x65, 0x73, 0x74, 0x73,
0x74, 0x72, 0x69, 0x6e, 0x67, 0x32, 0x74, 0x0, 0x7, 0x2e, 0x2e, 0x2e, 0x2e, 0x2e, 0x2e, 0x32

};

static int [] optionalDataInt={0xac, 0xed, 0x0, 0x5, 0x77, 0x5, 0x1, 0x2, 0x3, 0x4, 0x5};


static int [] icDataInt={
0xac, 0xed, 0x0, 0x5, 0x73, 0x72, 0x0, 0x38, 0x67, 0x6e, 0x75, 0x2e, 0x74, 0x65, 0x73, 0x74,
0x6c, 0x65, 0x74, 0x2e, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2e, 0x69,
0x6f, 0x2e, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53,
0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x4f, 0x75, 0x74, 0x65, 0x72, 0x43, 0x6c, 0x61, 0x73, 0x73,
0x6c, 0x18, 0xa9, 0x1b, 0xa1, 0x8f, 0xe8, 0xef, 0x2, 0x0, 0x2, 0x4c, 0x0, 0x4, 0x70, 0x72,
0x69, 0x63, 0x74, 0x0, 0x4c, 0x4c, 0x67, 0x6e, 0x75, 0x2f, 0x74, 0x65, 0x73, 0x74, 0x6c, 0x65,
0x74, 0x2f, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2f, 0x69, 0x6f, 0x2f,
0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53, 0x74, 0x72,
0x65, 0x61, 0x6d, 0x5f, 0x4f, 0x75, 0x74, 0x65, 0x72, 0x43, 0x6c, 0x61, 0x73, 0x73, 0x24, 0x50,
0x72, 0x69, 0x76, 0x61, 0x74, 0x65, 0x49, 0x6e, 0x6e, 0x65, 0x72, 0x43, 0x6c, 0x61, 0x73, 0x73,
0x3b, 0x4c, 0x0, 0x4, 0x70, 0x75, 0x69, 0x63, 0x74, 0x0, 0x4b, 0x4c, 0x67, 0x6e, 0x75, 0x2f,
0x74, 0x65, 0x73, 0x74, 0x6c, 0x65, 0x74, 0x2f, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73,
0x74, 0x73, 0x2f, 0x69, 0x6f, 0x2f, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a,
0x65, 0x63, 0x74, 0x53, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x4f, 0x75, 0x74, 0x65, 0x72, 0x43,
0x6c, 0x61, 0x73, 0x73, 0x24, 0x50, 0x75, 0x62, 0x6c, 0x69, 0x63, 0x49, 0x6e, 0x6e, 0x65, 0x72,
0x43, 0x6c, 0x61, 0x73, 0x73, 0x3b, 0x78, 0x70, 0x73, 0x72, 0x0, 0x4a, 0x67, 0x6e, 0x75, 0x2e,
0x74, 0x65, 0x73, 0x74, 0x6c, 0x65, 0x74, 0x2e, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73,
0x74, 0x73, 0x2e, 0x69, 0x6f, 0x2e, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a,
0x65, 0x63, 0x74, 0x53, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x4f, 0x75, 0x74, 0x65, 0x72, 0x43,
0x6c, 0x61, 0x73, 0x73, 0x24, 0x50, 0x72, 0x69, 0x76, 0x61, 0x74, 0x65, 0x49, 0x6e, 0x6e, 0x65,
0x72, 0x43, 0x6c, 0x61, 0x73, 0x73, 0xd7, 0x87, 0x46, 0x25, 0xbe, 0x23, 0x6a, 0x4c, 0x2, 0x0,
0x1, 0x4c, 0x0, 0x6, 0x74, 0x68, 0x69, 0x73, 0x24, 0x30, 0x74, 0x0, 0x3a, 0x4c, 0x67, 0x6e,
0x75, 0x2f, 0x74, 0x65, 0x73, 0x74, 0x6c, 0x65, 0x74, 0x2f, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74,
0x65, 0x73, 0x74, 0x73, 0x2f, 0x69, 0x6f, 0x2f, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f,
0x62, 0x6a, 0x65, 0x63, 0x74, 0x53, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x4f, 0x75, 0x74, 0x65,
0x72, 0x43, 0x6c, 0x61, 0x73, 0x73, 0x3b, 0x78, 0x72, 0x0, 0x2f, 0x67, 0x6e, 0x75, 0x2e, 0x74,
0x65, 0x73, 0x74, 0x6c, 0x65, 0x74, 0x2e, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74,
0x73, 0x2e, 0x69, 0x6f, 0x2e, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65,
0x63, 0x74, 0x53, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x41, 0xc6, 0xe7, 0xa4, 0xbc, 0x7a, 0xa2,
0x5b, 0x4c, 0x2, 0x0, 0xc, 0x5a, 0x0, 0xb, 0x74, 0x65, 0x73, 0x74, 0x42, 0x6f, 0x6f, 0x6c,
0x65, 0x61, 0x6e, 0x42, 0x0, 0x8, 0x74, 0x65, 0x73, 0x74, 0x42, 0x79, 0x74, 0x65, 0x43, 0x0,
0x8, 0x74, 0x65, 0x73, 0x74, 0x43, 0x68, 0x61, 0x72, 0x44, 0x0, 0xa, 0x74, 0x65, 0x73, 0x74,
0x44, 0x6f, 0x75, 0x62, 0x6c, 0x65, 0x46, 0x0, 0x9, 0x74, 0x65, 0x73, 0x74, 0x46, 0x6c, 0x6f,
0x61, 0x74, 0x49, 0x0, 0x7, 0x74, 0x65, 0x73, 0x74, 0x49, 0x6e, 0x74, 0x4a, 0x0, 0x8, 0x74,
0x65, 0x73, 0x74, 0x4c, 0x6f, 0x6e, 0x67, 0x53, 0x0, 0x9, 0x74, 0x65, 0x73, 0x74, 0x53, 0x68,
0x6f, 0x72, 0x74, 0x49, 0x0, 0xb, 0x76, 0x6f, 0x6c, 0x61, 0x74, 0x69, 0x6c, 0x65, 0x49, 0x6e,
0x74, 0x4c, 0x0, 0x1, 0x64, 0x74, 0x0, 0x31, 0x4c, 0x67, 0x6e, 0x75, 0x2f, 0x74, 0x65, 0x73,
0x74, 0x6c, 0x65, 0x74, 0x2f, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2f,
0x69, 0x6f, 0x2f, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74,
0x53, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x44, 0x3b, 0x4c, 0x0, 0x4, 0x6c, 0x65, 0x66, 0x74,
0x74, 0x0, 0x31, 0x4c, 0x67, 0x6e, 0x75, 0x2f, 0x74, 0x65, 0x73, 0x74, 0x6c, 0x65, 0x74, 0x2f,
0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2f, 0x69, 0x6f, 0x2f, 0x53, 0x41,
0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53, 0x74, 0x72, 0x65, 0x61,
0x6d, 0x5f, 0x41, 0x3b, 0x4c, 0x0, 0x5, 0x72, 0x69, 0x67, 0x68, 0x74, 0x71, 0x0, 0x7e, 0x0,
0x8, 0x78, 0x70, 0x0, 0x6, 0x0, 0x66, 0x40, 0x18, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x40,
0xc0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0,
0x6, 0x0, 0x0, 0x0, 0x69, 0x73, 0x72, 0x0, 0x2f, 0x67, 0x6e, 0x75, 0x2e, 0x74, 0x65, 0x73,
0x74, 0x6c, 0x65, 0x74, 0x2e, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2e,
0x69, 0x6f, 0x2e, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74,
0x53, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x44, 0x4f, 0x76, 0xa9, 0x5f, 0x77, 0x75, 0x7f, 0x31,
0x2, 0x0, 0x1, 0x4c, 0x0, 0x1, 0x73, 0x74, 0x0, 0x12, 0x4c, 0x6a, 0x61, 0x76, 0x61, 0x2f,
0x6c, 0x61, 0x6e, 0x67, 0x2f, 0x53, 0x74, 0x72, 0x69, 0x6e, 0x67, 0x3b, 0x78, 0x70, 0x74, 0x0,
0x5, 0x70, 0x72, 0x69, 0x63, 0x44, 0x73, 0x72, 0x0, 0x49, 0x67, 0x6e, 0x75, 0x2e, 0x74, 0x65,
0x73, 0x74, 0x6c, 0x65, 0x74, 0x2e, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73,
0x2e, 0x69, 0x6f, 0x2e, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63,
0x74, 0x53, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x4f, 0x75, 0x74, 0x65, 0x72, 0x43, 0x6c, 0x61,
0x73, 0x73, 0x24, 0x50, 0x75, 0x62, 0x6c, 0x69, 0x63, 0x49, 0x6e, 0x6e, 0x65, 0x72, 0x43, 0x6c,
0x61, 0x73, 0x73, 0x4f, 0xbe, 0x84, 0xba, 0x33, 0x2c, 0xae, 0x2f, 0x2, 0x0, 0x2, 0x4c, 0x0,
0x7, 0x61, 0x53, 0x74, 0x72, 0x69, 0x6e, 0x67, 0x71, 0x0, 0x7e, 0x0, 0xb, 0x4c, 0x0, 0x6,
0x74, 0x68, 0x69, 0x73, 0x24, 0x30, 0x71, 0x0, 0x7e, 0x0, 0x5, 0x78, 0x72, 0x0, 0x2f, 0x67,
0x6e, 0x75, 0x2e, 0x74, 0x65, 0x73, 0x74, 0x6c, 0x65, 0x74, 0x2e, 0x4a, 0x75, 0x6e, 0x69, 0x74,
0x74, 0x65, 0x73, 0x74, 0x73, 0x2e, 0x69, 0x6f, 0x2e, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f,
0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x5f, 0x42, 0x4c, 0xeb,
0xb1, 0x35, 0x1f, 0x68, 0xbe, 0xb7, 0x2, 0x0, 0x9, 0x5b, 0x0, 0xc, 0x61, 0x72, 0x72, 0x61,
0x79, 0x42, 0x6f, 0x6f, 0x6c, 0x65, 0x61, 0x6e, 0x74, 0x0, 0x2, 0x5b, 0x5a, 0x5b, 0x0, 0x9,
0x61, 0x72, 0x72, 0x61, 0x79, 0x42, 0x79, 0x74, 0x65, 0x74, 0x0, 0x2, 0x5b, 0x42, 0x5b, 0x0,
0x9, 0x61, 0x72, 0x72, 0x61, 0x79, 0x43, 0x68, 0x61, 0x72, 0x74, 0x0, 0x2, 0x5b, 0x43, 0x5b,
0x0, 0xb, 0x61, 0x72, 0x72, 0x61, 0x79, 0x44, 0x6f, 0x75, 0x62, 0x6c, 0x65, 0x74, 0x0, 0x2,
0x5b, 0x44, 0x5b, 0x0, 0xa, 0x61, 0x72, 0x72, 0x61, 0x79, 0x46, 0x6c, 0x6f, 0x61, 0x74, 0x74,
0x0, 0x2, 0x5b, 0x46, 0x5b, 0x0, 0x8, 0x61, 0x72, 0x72, 0x61, 0x79, 0x49, 0x6e, 0x74, 0x74,
0x0, 0x2, 0x5b, 0x49, 0x5b, 0x0, 0x9, 0x61, 0x72, 0x72, 0x61, 0x79, 0x4c, 0x6f, 0x6e, 0x67,
0x74, 0x0, 0x2, 0x5b, 0x4a, 0x5b, 0x0, 0xa, 0x61, 0x72, 0x72, 0x61, 0x79, 0x53, 0x68, 0x6f,
0x72, 0x74, 0x74, 0x0, 0x2, 0x5b, 0x53, 0x5b, 0x0, 0xb, 0x61, 0x72, 0x72, 0x61, 0x79, 0x53,
0x74, 0x72, 0x69, 0x6e, 0x67, 0x74, 0x0, 0x13, 0x5b, 0x4c, 0x6a, 0x61, 0x76, 0x61, 0x2f, 0x6c,
0x61, 0x6e, 0x67, 0x2f, 0x53, 0x74, 0x72, 0x69, 0x6e, 0x67, 0x3b, 0x78, 0x71, 0x0, 0x7e, 0x0,
0x6, 0x1, 0x7, 0x0, 0x67, 0x40, 0x1c, 0x66, 0x66, 0x66, 0x66, 0x66, 0x66, 0x40, 0xe0, 0x0,
0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7, 0x0, 0x7, 0x0,
0x0, 0x0, 0x6a, 0x73, 0x72, 0x0, 0x3a, 0x67, 0x6e, 0x75, 0x2e, 0x74, 0x65, 0x73, 0x74, 0x6c,
0x65, 0x74, 0x2e, 0x4a, 0x75, 0x6e, 0x69, 0x74, 0x74, 0x65, 0x73, 0x74, 0x73, 0x2e, 0x69, 0x6f,
0x2e, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53, 0x74,
0x72, 0x65, 0x61, 0x6d, 0x5f, 0x4f, 0x75, 0x74, 0x65, 0x72, 0x43, 0x6c, 0x61, 0x73, 0x73, 0x24,
0x31, 0x3e, 0x2c, 0xae, 0x41, 0xdb, 0x51, 0xf0, 0x5b, 0x2, 0x0, 0x1, 0x4c, 0x0, 0x6, 0x74,
0x68, 0x69, 0x73, 0x24, 0x30, 0x71, 0x0, 0x7e, 0x0, 0x5, 0x78, 0x71, 0x0, 0x7e, 0x0, 0xa,
0x74, 0x0, 0xd, 0x6a, 0x75, 0x73, 0x74, 0x20, 0x61, 0x20, 0x73, 0x74, 0x72, 0x69, 0x6e, 0x67,
0x71, 0x0, 0x7e, 0x0, 0x3, 0x70, 0x71, 0x0, 0x7e, 0x0, 0x9, 0x75, 0x72, 0x0, 0x2, 0x5b,
0x5a, 0x57, 0x8f, 0x20, 0x39, 0x14, 0xb8, 0x5d, 0xe2, 0x2, 0x0, 0x0, 0x78, 0x70, 0x0, 0x0,
0x0, 0x5, 0x0, 0x1, 0x0, 0x0, 0x1, 0x75, 0x72, 0x0, 0x2, 0x5b, 0x42, 0xac, 0xf3, 0x17,
0xf8, 0x6, 0x8, 0x54, 0xe0, 0x2, 0x0, 0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0x9, 0x86, 0xc,
0x8, 0xe, 0xa, 0xe, 0x85, 0x1, 0x2, 0x75, 0x72, 0x0, 0x2, 0x5b, 0x43, 0xb0, 0x26, 0x66,
0xb0, 0xe2, 0x5d, 0x84, 0xac, 0x2, 0x0, 0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0x9, 0x0, 0x59,
0x0, 0x73, 0x0, 0x67, 0x0, 0x78, 0x0, 0x7a, 0x0, 0x53, 0x0, 0x75, 0x0, 0x76, 0x0, 0x65,
0x75, 0x72, 0x0, 0x2, 0x5b, 0x44, 0x3e, 0xa6, 0x8c, 0x14, 0xab, 0x63, 0x5a, 0x1e, 0x2, 0x0,
0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0x4, 0x40, 0x49, 0x53, 0xe9, 0x63, 0xdc, 0x48, 0x6b, 0x40,
0x43, 0x39, 0x99, 0x99, 0x99, 0x99, 0x9a, 0x40, 0x84, 0x74, 0x0, 0x0, 0x0, 0x0, 0x0, 0xc0,
0x46, 0xa6, 0x66, 0x66, 0x66, 0x66, 0x66, 0x75, 0x72, 0x0, 0x2, 0x5b, 0x46, 0xb, 0x9c, 0x81,
0x89, 0x22, 0xe0, 0xc, 0x42, 0x2, 0x0, 0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0x5, 0x41, 0x6b,
0x33, 0x33, 0x41, 0x33, 0x33, 0x33, 0x40, 0xf0, 0x0, 0x0, 0x42, 0x9c, 0x99, 0x9a, 0x42, 0x3,
0xf5, 0xc3, 0x75, 0x72, 0x0, 0x2, 0x5b, 0x49, 0x4d, 0xba, 0x60, 0x26, 0x76, 0xea, 0xb2, 0xa5,
0x2, 0x0, 0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0xc, 0x0, 0x0, 0x0, 0x7, 0x0, 0x0, 0x0,
0x8, 0x0, 0x0, 0x0, 0x9, 0x0, 0x0, 0x0, 0xa, 0x0, 0x0, 0x0, 0xb, 0x0, 0x0, 0x0,
0xc, 0x0, 0x0, 0x0, 0xd, 0x0, 0x0, 0x0, 0xe, 0x0, 0x0, 0x0, 0xf, 0x0, 0x0, 0x0,
0x6, 0x7f, 0xff, 0xff, 0xff, 0x80, 0x0, 0x0, 0x0, 0x75, 0x72, 0x0, 0x2, 0x5b, 0x4a, 0x78,
0x20, 0x4, 0xb5, 0x12, 0xb1, 0x75, 0x93, 0x2, 0x0, 0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0x4,
0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x6, 0x0, 0x0, 0x0, 0x0, 0x0, 0x1, 0x81, 0x64,
0x80, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x0, 0x7f, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
0x75, 0x72, 0x0, 0x2, 0x5b, 0x53, 0xef, 0x83, 0x2e, 0x6, 0xe5, 0x5d, 0xb0, 0xfa, 0x2, 0x0,
0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0x7, 0x0, 0xf, 0x0, 0x81, 0x0, 0x49, 0x0, 0xf, 0x12,
0x36, 0x0, 0x62, 0xfc, 0x25, 0x75, 0x72, 0x0, 0x13, 0x5b, 0x4c, 0x6a, 0x61, 0x76, 0x61, 0x2e,
0x6c, 0x61, 0x6e, 0x67, 0x2e, 0x53, 0x74, 0x72, 0x69, 0x6e, 0x67, 0x3b, 0xad, 0xd2, 0x56, 0xe7,
0xe9, 0x1d, 0x7b, 0x47, 0x2, 0x0, 0x0, 0x78, 0x70, 0x0, 0x0, 0x0, 0x3, 0x74, 0x0, 0x5,
0x74, 0x65, 0x73, 0x74, 0x36, 0x74, 0x0, 0x13, 0x61, 0x6e, 0x6f, 0x74, 0x68, 0x65, 0x72, 0x20,
0x74, 0x65, 0x73, 0x74, 0x73, 0x74, 0x72, 0x69, 0x6e, 0x67, 0x36, 0x74, 0x0, 0x7, 0x2e, 0x2e,
0x2e, 0x2e, 0x2e, 0x2e, 0x36, 0x74, 0x0, 0x17, 0x70, 0x72, 0x69, 0x76, 0x61, 0x74, 0x65, 0x69,
0x6e, 0x6e, 0x65, 0x72, 0x63, 0x6c, 0x61, 0x73, 0x73, 0x73, 0x74, 0x72, 0x69, 0x6e, 0x67, 0x71,
0x0, 0x7e, 0x0, 0x3, 0x70, 0x71, 0x0, 0x7e, 0x0, 0x3, 0x71, 0x0, 0x7e, 0x0, 0x19
};




public static int[] writeAbortedDataInt={
0xac, 0xed, 0x0, 0x5, 0x7b, 0x73, 0x72, 0x0, 0x20, 0x6a, 0x61, 0x76, 0x61, 0x2e, 0x69, 0x6f,
0x2e, 0x4e, 0x6f, 0x74, 0x53, 0x65, 0x72, 0x69, 0x61, 0x6c, 0x69, 0x7a, 0x61, 0x62, 0x6c, 0x65,
0x45, 0x78, 0x63, 0x65, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x28, 0x56, 0x78, 0x0, 0xe7, 0x86, 0x16,
0x35, 0x2, 0x0, 0x0, 0x78, 0x72, 0x0, 0x1d, 0x6a, 0x61, 0x76, 0x61, 0x2e, 0x69, 0x6f, 0x2e,
0x4f, 0x62, 0x6a, 0x65, 0x63, 0x74, 0x53, 0x74, 0x72, 0x65, 0x61, 0x6d, 0x45, 0x78, 0x63, 0x65,
0x70, 0x74, 0x69, 0x6f, 0x6e, 0x64, 0xc3, 0xe4, 0x6b, 0x8d, 0x39, 0xfb, 0xdf, 0x2, 0x0, 0x0,
0x78, 0x72, 0x0, 0x13, 0x6a, 0x61, 0x76, 0x61, 0x2e, 0x69, 0x6f, 0x2e, 0x49, 0x4f, 0x45, 0x78,
0x63, 0x65, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0x6c, 0x80, 0x73, 0x64, 0x65, 0x25, 0xf0, 0xab, 0x2,
0x0, 0x0, 0x78, 0x72, 0x0, 0x13, 0x6a, 0x61, 0x76, 0x61, 0x2e, 0x6c, 0x61, 0x6e, 0x67, 0x2e,
0x45, 0x78, 0x63, 0x65, 0x70, 0x74, 0x69, 0x6f, 0x6e, 0xd0, 0xfd, 0x1f, 0x3e, 0x1a, 0x3b, 0x1c,
0xc4, 0x2, 0x0, 0x0, 0x78, 0x72, 0x0, 0x13, 0x6a, 0x61, 0x76, 0x61, 0x2e, 0x6c, 0x61, 0x6e,
0x67, 0x2e, 0x54, 0x68, 0x72, 0x6f, 0x77, 0x61, 0x62, 0x6c, 0x65, 0xd5, 0xc6, 0x35, 0x27, 0x39,
0x77, 0xb8, 0xcb, 0x2, 0x0, 0x1, 0x4c, 0x0, 0xd, 0x64, 0x65, 0x74, 0x61, 0x69, 0x6c, 0x4d,
0x65, 0x73, 0x73, 0x61, 0x67, 0x65, 0x74, 0x0, 0x12, 0x4c, 0x6a, 0x61, 0x76, 0x61, 0x2f, 0x6c,
0x61, 0x6e, 0x67, 0x2f, 0x53, 0x74, 0x72, 0x69, 0x6e, 0x67, 0x3b, 0x78, 0x70, 0x74, 0x0, 0x31,
0x6a, 0x61, 0x76, 0x61, 0x2e, 0x69, 0x6f, 0x2e, 0x53, 0x41, 0x4d, 0x50, 0x4c, 0x45, 0x5f, 0x4f,
0x62, 0x6a, 0x65, 0x63, 0x74, 0x4f, 0x75, 0x74, 0x70, 0x75, 0x74, 0x53, 0x74, 0x72, 0x65, 0x61,
0x6d, 0x5f, 0x4e, 0x6f, 0x74, 0x53, 0x65, 0x72, 0x69, 0x61, 0x6c, 0x69, 0x7a, 0x61, 0x62, 0x6c,
0x65
};


}
