/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


package gnu.testlet.wonka.lang.ClassLoader; //complete the package name ...

import java.util.HashMap;

public class BadClassLoader extends ClassLoader {	
	
	private HashMap hm;
	
	public BadClassLoader(){
		hm = new HashMap();
		hm.put("String", new Value(string, stringclass)); //java.lang.String
		hm.put(cbaBad, new Value(cbaBad, cbaBadclass)); //class misses bytes
		hm.put(A, new Value(A, Aclass)); //ClassCircularity
		hm.put(B, new Value(B, Bclass));
		hm.put(C, new Value(C, Cclass));
		hm.put(cba, new Value(cba, cbaclass)); //wrongName
		hm.put(Bad, new Value(Bad, Badclass)); //java.lang.Bad
		hm.put(New, new Value(New, Newclass)); //updated interface
		hm.put(old, new Value(old, oldclass)); //class implementing old version of interface
		hm.put(Mis, new Value(Mis, Misclass)); //class Implements Missing Interface
		hm.put(msc, new Value(msc, mscclass)); //class extends Missing class
		hm.put(bf1, new Value(bf1, bf1class)); //BadClass Formats ...
		hm.put(bf2, new Value(bf2, bf2class));
		hm.put(bf3, new Value(bf3, bf3class)); //VerifyError
		hm.put(acc, new Value(acc, accclass)); //Incompatible ClassChangeErrors
		hm.put(acm, new Value(acmname, acmclass));
		hm.put(nsm, new Value(nsm, nsmclass));
		hm.put(nsf, new Value(nsf, nsfclass));
		hm.put(ins, new Value(ins, insclass));
		hm.put(chd, new Value(chd, chdclass));
		hm.put(init, new Value(init, initclass)); //ExceptionInInitializerError
	}
	
	protected Class findClass(String className) throws ClassNotFoundException {
		Object o = hm.get(className);
		if (o == null){ 	
	 	 	throw new ClassNotFoundException(className+" not found");		
		} 	
		Value v = (Value)o;
		System.out.println("looking for "+className+" using "+v.name);
		return defineClass(v.name, v.bytes, 0, v.bytes.length);
	}

        private class Value{
        	protected String name;
        	protected byte [] bytes;
        	
        	public Value(String n, byte [] b){
        	 	name = n;
        	 	bytes = b;
        	}
        }
// wrong class format;
private static final String cbaBad = "CreateByteArray";
private static final byte [] cbaBadclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 112, 8, 0, 59, 8, 0, 75,
8, 0, 76, 8, 0, 77, 8, 0, 78, 7, 0, 81, 7, 0, 91, 7,
0, 92, 7, 0, 93, 7, 0, 94, 7, 0, 95, 7, 0, 96, 7, 0,
97, 7, 0, 98, 7, 0, 99, 7, 0, 100, 10, 0, 7, 0, 39, 10,
0, 13, 0, 39, 10, 0, 9, 0, 40, 10, 0, 8, 0, 41, 10, 0,
15, 0, 41, 10, 0, 15, 0, 42, 10, 0, 15, 0, 43, 10, 0, 6,
0, 44, 10, 0, 14, 0, 45, 10, 0, 8, 0, 46, 10, 0, 8, 0,
47, 9, 0, 16, 0, 48, 10, 0, 10, 0, 49, 10, 0, 6, 0, 50,
10, 0, 10, 0, 51, 10, 0, 10, 0, 52, 10, 0, 9, 0, 53, 10,
0, 7, 0, 54, 10, 0, 15, 0, 55, 10, 0, 11, 0, 56, 10, 0,
14, 0, 57, 10, 0, 7, 0, 58, 12, 0, 79, 0, 61, 12, 0, 79,
0, 66, 12, 0, 79, 0, 69, 12, 0, 87, 0, 65, 12, 0, 87, 0,
68, 12, 0, 88, 0, 61, 12, 0, 89, 0, 70, 12, 0, 90, 0, 60,
12, 0, 101, 0, 63, 12, 0, 103, 0, 85, 12, 0, 104, 0, 69, 12,
0, 105, 0, 73, 12, 0, 106, 0, 61, 12, 0, 106, 0, 69, 12, 0,};


// wrong className

private static final String cba = "wrongName";
private static final byte [] cbaclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 112, 8, 0, 59, 8, 0, 75,
8, 0, 76, 8, 0, 77, 8, 0, 78, 7, 0, 81, 7, 0, 91, 7,
0, 92, 7, 0, 93, 7, 0, 94, 7, 0, 95, 7, 0, 96, 7, 0,
97, 7, 0, 98, 7, 0, 99, 7, 0, 100, 10, 0, 7, 0, 39, 10,
0, 13, 0, 39, 10, 0, 9, 0, 40, 10, 0, 8, 0, 41, 10, 0,
15, 0, 41, 10, 0, 15, 0, 42, 10, 0, 15, 0, 43, 10, 0, 6,
0, 44, 10, 0, 14, 0, 45, 10, 0, 8, 0, 46, 10, 0, 8, 0,
47, 9, 0, 16, 0, 48, 10, 0, 10, 0, 49, 10, 0, 6, 0, 50,
10, 0, 10, 0, 51, 10, 0, 10, 0, 52, 10, 0, 9, 0, 53, 10,
0, 7, 0, 54, 10, 0, 15, 0, 55, 10, 0, 11, 0, 56, 10, 0,
14, 0, 57, 10, 0, 7, 0, 58, 12, 0, 79, 0, 61, 12, 0, 79,
0, 66, 12, 0, 79, 0, 69, 12, 0, 87, 0, 65, 12, 0, 87, 0,
68, 12, 0, 88, 0, 61, 12, 0, 89, 0, 70, 12, 0, 90, 0, 60,
12, 0, 101, 0, 63, 12, 0, 103, 0, 85, 12, 0, 104, 0, 69, 12,
0, 105, 0, 73, 12, 0, 106, 0, 61, 12, 0, 106, 0, 69, 12, 0,
107, 0, 71, 12, 0, 108, 0, 62, 12, 0, 109, 0, 60, 12, 0, 109,
0, 64, 12, 0, 110, 0, 67, 12, 0, 111, 0, 72, 1, 0, 3, 10,
10, 10, 1, 0, 20, 40, 41, 76, 106, 97, 118, 97, 47, 108, 97, 110,
103, 47, 83, 116, 114, 105, 110, 103, 59, 1, 0, 3, 40, 41, 86, 1,
0, 4, 40, 41, 91, 66, 1, 0, 17, 40, 41, 91, 76, 106, 97, 118,
97, 47, 105, 111, 47, 70, 105, 108, 101, 59, 1, 0, 21, 40, 66, 41,
76, 106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 83, 116, 114, 105, 110,
103, 59, 1, 0, 27, 40, 73, 41, 76, 106, 97, 118, 97, 47, 108, 97,
110, 103, 47, 83, 116, 114, 105, 110, 103, 66, 117, 102, 102, 101, 114, 59,
1, 0, 17, 40, 76, 106, 97, 118, 97, 47, 105, 111, 47, 70, 105, 108,
101, 59, 41, 86, 1, 0, 38, 40, 76, 106, 97, 118, 97, 47, 108, 97,
110, 103, 47, 79, 98, 106, 101, 99, 116, 59, 41, 76, 106, 97, 118, 97,
47, 108, 97, 110, 103, 47, 83, 116, 114, 105, 110, 103, 59, 1, 0, 44,
40, 76, 106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 83, 116, 114, 105,
110, 103, 59, 41, 76, 106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 83,
116, 114, 105, 110, 103, 66, 117, 102, 102, 101, 114, 59, 1, 0, 21, 40,
76, 106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 83, 116, 114, 105, 110,
103, 59, 41, 86, 1, 0, 21, 40, 76, 106, 97, 118, 97, 47, 108, 97,
110, 103, 47, 83, 116, 114, 105, 110, 103, 59, 41, 90, 1, 0, 7, 40,
91, 66, 73, 73, 41, 73, 1, 0, 7, 40, 91, 66, 73, 73, 41, 86,
1, 0, 23, 40, 91, 66, 76, 106, 97, 118, 97, 47, 108, 97, 110, 103,
47, 83, 116, 114, 105, 110, 103, 59, 41, 86, 1, 0, 22, 40, 91, 76,
106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 83, 116, 114, 105, 110, 103,
59, 41, 86, 1, 0, 2, 44, 32, 1, 0, 21, 45, 45, 62, 32, 76,
101, 110, 103, 116, 104, 32, 111, 102, 32, 97, 114, 114, 97, 121, 58, 32,
1, 0, 13, 46, 46, 47, 98, 97, 100, 67, 108, 97, 115, 115, 101, 115,
1, 0, 6, 46, 99, 108, 97, 115, 115, 1, 0, 6, 60, 105, 110, 105,
116, 62, 1, 0, 4, 67, 111, 100, 101, 1, 0, 15, 67, 114, 101, 97,
116, 101, 66, 121, 116, 101, 65, 114, 114, 97, 121, 1, 0, 20, 67, 114,
101, 97, 116, 101, 66, 121, 116, 101, 65, 114, 114, 97, 121, 46, 106, 97,
118, 97, 1, 0, 10, 69, 120, 99, 101, 112, 116, 105, 111, 110, 115, 1,
0, 15, 76, 105, 110, 101, 78, 117, 109, 98, 101, 114, 84, 97, 98, 108,
101, 1, 0, 21, 76, 106, 97, 118, 97, 47, 105, 111, 47, 80, 114, 105,
110, 116, 83, 116, 114, 101, 97, 109, 59, 1, 0, 10, 83, 111, 117, 114,
99, 101, 70, 105, 108, 101, 1, 0, 6, 97, 112, 112, 101, 110, 100, 1,
0, 6, 99, 114, 101, 97, 116, 101, 1, 0, 8, 101, 110, 100, 115, 87,
105, 116, 104, 1, 0, 7, 103, 101, 116, 78, 97, 109, 101, 1, 0, 29,
106, 97, 118, 97, 47, 105, 111, 47, 66, 121, 116, 101, 65, 114, 114, 97,
121, 79, 117, 116, 112, 117, 116, 83, 116, 114, 101, 97, 109, 1, 0, 12,
106, 97, 118, 97, 47, 105, 111, 47, 70, 105, 108, 101, 1, 0, 23, 106,
97, 118, 97, 47, 105, 111, 47, 70, 105, 108, 101, 73, 110, 112, 117, 116,
83, 116, 114, 101, 97, 109, 1, 0, 19, 106, 97, 118, 97, 47, 105, 111,
47, 80, 114, 105, 110, 116, 83, 116, 114, 101, 97, 109, 1, 0, 14, 106,
97, 118, 97, 47, 108, 97, 110, 103, 47, 66, 121, 116, 101, 1, 0, 19,
106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 69, 120, 99, 101, 112, 116,
105, 111, 110, 1, 0, 16, 106, 97, 118, 97, 47, 108, 97, 110, 103, 47,
79, 98, 106, 101, 99, 116, 1, 0, 16, 106, 97, 118, 97, 47, 108, 97,
110, 103, 47, 83, 116, 114, 105, 110, 103, 1, 0, 22, 106, 97, 118, 97,
47, 108, 97, 110, 103, 47, 83, 116, 114, 105, 110, 103, 66, 117, 102, 102,
101, 114, 1, 0, 16, 106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 83,
121, 115, 116, 101, 109, 1, 0, 9, 108, 105, 115, 116, 70, 105, 108, 101,
115, 1, 0, 4, 109, 97, 105, 110, 1, 0, 3, 111, 117, 116, 1, 0,
5, 112, 114, 105, 110, 116, 1, 0, 11, 112, 114, 105, 110, 116, 83, 116,
114, 101, 97, 109, 1, 0, 7, 112, 114, 105, 110, 116, 108, 110, 1, 0,
4, 114, 101, 97, 100, 1, 0, 11, 116, 111, 66, 121, 116, 101, 65, 114,
114, 97, 121, 1, 0, 8, 116, 111, 83, 116, 114, 105, 110, 103, 1, 0,
7, 118, 97, 108, 117, 101, 79, 102, 1, 0, 5, 119, 114, 105, 116, 101,
0, 33, 0, 6, 0, 13, 0, 0, 0, 0, 0, 4, 0, 1, 0, 79,
0, 61, 0, 1, 0, 80, 0, 0, 0, 29, 0, 1, 0, 1, 0, 0,
0, 5, 42, -73, 0, 18, -79, 0, 0, 0, 1, 0, 84, 0, 0, 0,
6, 0, 1, 0, 0, 0, 4, 0, 9, 0, 88, 0, 61, 0, 2, 0,
80, 0, 0, 0, -48, 0, 4, 0, 7, 0, 0, 0, -128, -69, 0, 8,
89, 18, 4, -73, 0, 20, 75, 42, -74, 0, 27, 76, 3, 61, -89, 0,
104, 43, 28, 50, -74, 0, 26, 18, 5, -74, 0, 25, -103, 0, 87, -69,
0, 9, 89, 43, 28, 50, -73, 0, 19, 78, -69, 0, 7, 89, -73, 0,
17, 58, 4, 17, 4, 0, -68, 8, 58, 5, 45, 25, 5, 3, 17, 4,
0, -74, 0, 33, 54, 6, -89, 0, 25, 25, 4, 25, 5, 3, 21, 6,
-74, 0, 38, 45, 25, 5, 3, 17, 4, 0, -74, 0, 33, 54, 6, 21,
6, 2, -96, -1, -25, 25, 4, -74, 0, 34, 43, 28, 50, -74, 0, 26,
-72, 0, 30, -124, 2, 1, 28, 43, -66, -95, -1, -104, -79, 0, 0, 0,
1, 0, 84, 0, 0, 0, 62, 0, 15, 0, 0, 0, 22, 0, 10, 0,
23, 0, 15, 0, 24, 0, 20, 0, 25, 0, 34, 0, 26, 0, 45, 0,
27, 0, 54, 0, 28, 0, 61, 0, 29, 0, 73, 0, 30, 0, 76, 0,
31, 0, 86, 0, 32, 0, 98, 0, 30, 0, 104, 0, 34, 0, 118, 0,
24, 0, 127, 0, 21, 0, 83, 0, 0, 0, 4, 0, 1, 0, 12, 0,
9, 0, 102, 0, 74, 0, 2, 0, 80, 0, 0, 0, 32, 0, 0, 0,
1, 0, 0, 0, 4, -72, 0, 24, -79, 0, 0, 0, 1, 0, 84, 0,
0, 0, 10, 0, 2, 0, 0, 0, 42, 0, 3, 0, 41, 0, 83, 0,
0, 0, 4, 0, 1, 0, 12, 0, 9, 0, 105, 0, 73, 0, 1, 0,
80, 0, 0, 0, -106, 0, 5, 0, 3, 0, 0, 0, 98, -78, 0, 28,
-69, 0, 15, 89, 43, -72, 0, 37, -73, 0, 21, 18, 3, -74, 0, 23,
42, -66, -74, 0, 22, -74, 0, 35, -74, 0, 32, 3, 61, -89, 0, 51,
-78, 0, 28, -69, 0, 15, 89, 42, 28, 51, -72, 0, 36, -72, 0, 37,
-73, 0, 21, 18, 2, -74, 0, 23, -74, 0, 35, -74, 0, 29, 28, 4,
96, 16, 16, 112, -102, 0, 9, -78, 0, 28, -74, 0, 31, -124, 2, 1,
28, 42, -66, -95, -1, -51, -78, 0, 28, 18, 1, -74, 0, 32, -79, 0,
0, 0, 1, 0, 84, 0, 0, 0, 34, 0, 8, 0, 0, 0, 9, 0,
30, 0, 10, 0, 35, 0, 11, 0, 65, 0, 12, 0, 74, 0, 13, 0,
80, 0, 10, 0, 89, 0, 16, 0, 97, 0, 6, 0, 1, 0, 86, 0,
0, 0, 2, 0, 82, };


// ClassCircularityError	
private static final String A = "A";
private static final byte [] Aclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 13, 7, 0, 7, 7, 0, 9,
10, 0, 2, 0, 4, 12, 0, 6, 0, 5, 1, 0, 3, 40, 41, 86,
1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 1, 65, 1, 0, 6,
65, 46, 106, 97, 118, 97, 1, 0, 1, 66, 1, 0, 4, 67, 111, 100,
101, 1, 0, 15, 76, 105, 110, 101, 78, 117, 109, 98, 101, 114, 84, 97,
98, 108, 101, 1, 0, 10, 83, 111, 117, 114, 99, 101, 70, 105, 108, 101,
0, 33, 0, 1, 0, 2, 0, 0, 0, 0, 0, 1, 0, 1, 0, 6,
0, 5, 0, 1, 0, 10, 0, 0, 0, 29, 0, 1, 0, 1, 0, 0,
0, 5, 42, -73, 0, 3, -79, 0, 0, 0, 1, 0, 11, 0, 0, 0,
6, 0, 1, 0, 0, 0, 2, 0, 1, 0, 12, 0, 0, 0, 2, 0,
8,};

private static final String B = "B";
private static final byte [] Bclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 13, 7, 0, 7, 7, 0, 9,
10, 0, 2, 0, 4, 12, 0, 6, 0, 5, 1, 0, 3, 40, 41, 86,
1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 1, 66, 1, 0, 6,
66, 46, 106, 97, 118, 97, 1, 0, 1, 67, 1, 0, 4, 67, 111, 100,
101, 1, 0, 15, 76, 105, 110, 101, 78, 117, 109, 98, 101, 114, 84, 97,
98, 108, 101, 1, 0, 10, 83, 111, 117, 114, 99, 101, 70, 105, 108, 101,
0, 33, 0, 1, 0, 2, 0, 0, 0, 0, 0, 1, 0, 1, 0, 6,
0, 5, 0, 1, 0, 10, 0, 0, 0, 29, 0, 1, 0, 1, 0, 0,
0, 5, 42, -73, 0, 3, -79, 0, 0, 0, 1, 0, 11, 0, 0, 0,
6, 0, 1, 0, 0, 0, 2, 0, 1, 0, 12, 0, 0, 0, 2, 0,
8,};

private static final String C = "C";
private static final byte [] Cclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 13, 7, 0, 7, 7, 0, 8,
10, 0, 1, 0, 4, 12, 0, 6, 0, 5, 1, 0, 3, 40, 41, 86,
1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 1, 65, 1, 0, 1,
67, 1, 0, 6, 67, 46, 106, 97, 118, 97, 1, 0, 4, 67, 111, 100,
101, 1, 0, 15, 76, 105, 110, 101, 78, 117, 109, 98, 101, 114, 84, 97,
98, 108, 101, 1, 0, 10, 83, 111, 117, 114, 99, 101, 70, 105, 108, 101,
0, 33, 0, 2, 0, 1, 0, 0, 0, 0, 0, 1, 0, 1, 0, 6,
0, 5, 0, 1, 0, 10, 0, 0, 0, 29, 0, 1, 0, 1, 0, 0,
0, 5, 42, -73, 0, 3, -79, 0, 0, 0, 1, 0, 11, 0, 0, 0,
6, 0, 1, 0, 0, 0, 2, 0, 1, 0, 12, 0, 0, 0, 2, 0,
9, };


// java.* class
private static final String Bad = "java.lang.Bad";
private static final byte [] Badclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 13, 7, 0, 11, 7, 0, 12,
10, 0, 2, 0, 4, 12, 0, 6, 0, 5, 1, 0, 3, 40, 41, 86,
1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 8, 66, 97, 100, 46,
106, 97, 118, 97, 1, 0, 4, 67, 111, 100, 101, 1, 0, 15, 76, 105,
110, 101, 78, 117, 109, 98, 101, 114, 84, 97, 98, 108, 101, 1, 0, 10,
83, 111, 117, 114, 99, 101, 70, 105, 108, 101, 1, 0, 13, 106, 97, 118,
97, 47, 108, 97, 110, 103, 47, 66, 97, 100, 1, 0, 16, 106, 97, 118,
97, 47, 108, 97, 110, 103, 47, 79, 98, 106, 101, 99, 116, 0, 33, 0,
1, 0, 2, 0, 0, 0, 0, 0, 1, 0, 1, 0, 6, 0, 5, 0,
1, 0, 8, 0, 0, 0, 29, 0, 1, 0, 1, 0, 0, 0, 5, 42,
-73, 0, 3, -79, 0, 0, 0, 1, 0, 9, 0, 0, 0, 6, 0, 1,
0, 0, 0, 3, 0, 1, 0, 10, 0, 0, 0, 2, 0, 7, };


private static final String string = "java.lang.String";
private static final byte [] stringclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 13, 7, 0, 11, 7, 0, 12,
10, 0, 1, 0, 4, 12, 0, 6, 0, 5, 1, 0, 3, 40, 41, 86,
1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 4, 67, 111, 100, 101,
1, 0, 15, 76, 105, 110, 101, 78, 117, 109, 98, 101, 114, 84, 97, 98,
108, 101, 1, 0, 10, 83, 111, 117, 114, 99, 101, 70, 105, 108, 101, 1,
0, 11, 83, 116, 114, 105, 110, 103, 46, 106, 97, 118, 97, 1, 0, 16,
106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 79, 98, 106, 101, 99, 116,
1, 0, 16, 106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 83, 116, 114,
105, 110, 103, 0, 33, 0, 2, 0, 1, 0, 0, 0, 0, 0, 1, 0,
1, 0, 6, 0, 5, 0, 1, 0, 7, 0, 0, 0, 29, 0, 1, 0,
1, 0, 0, 0, 5, 42, -73, 0, 3, -79, 0, 0, 0, 1, 0, 8,
0, 0, 0, 6, 0, 1, 0, 0, 0, 3, 0, 1, 0, 9, 0, 0,
0, 2, 0, 10,};

// linking errors

private static final String old = "Old";
private static final byte [] oldclass= {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 15, 7, 0, 10, 7, 0, 11,
7, 0, 14, 10, 0, 3, 0, 5, 12, 0, 7, 0, 6, 1, 0, 3,
40, 41, 86, 1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 4, 67,
111, 100, 101, 1, 0, 15, 76, 105, 110, 101, 78, 117, 109, 98, 101, 114,
84, 97, 98, 108, 101, 1, 0, 3, 78, 101, 119, 1, 0, 3, 79, 108,
100, 1, 0, 8, 79, 108, 100, 46, 106, 97, 118, 97, 1, 0, 10, 83,
111, 117, 114, 99, 101, 70, 105, 108, 101, 1, 0, 16, 106, 97, 118, 97,
47, 108, 97, 110, 103, 47, 79, 98, 106, 101, 99, 116, 0, 33, 0, 2,
0, 3, 0, 1, 0, 1, 0, 0, 0, 1, 0, 1, 0, 7, 0, 6,
0, 1, 0, 8, 0, 0, 0, 29, 0, 1, 0, 1, 0, 0, 0, 5,
42, -73, 0, 4, -79, 0, 0, 0, 1, 0, 9, 0, 0, 0, 6, 0,
1, 0, 0, 0, 1, 0, 1, 0, 13, 0, 0, 0, 2, 0, 12, };

private static final String New = "New";
private static final byte [] Newclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 11, 7, 0, 6, 7, 0, 9,
1, 0, 3, 40, 41, 86, 1, 0, 4, 67, 111, 100, 101, 1, 0, 15,
76, 105, 110, 101, 78, 117, 109, 98, 101, 114, 84, 97, 98, 108, 101, 1,
0, 3, 78, 101, 119, 1, 0, 8, 78, 101, 119, 46, 106, 97, 118, 97,
1, 0, 10, 83, 111, 117, 114, 99, 101, 70, 105, 108, 101, 1, 0, 16,
106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 79, 98, 106, 101, 99, 116,
1, 0, 9, 110, 101, 119, 77, 101, 116, 104, 111, 100, 6, 1, 0, 1,
0, 2, 0, 0, 0, 0, 0, 1, 4, 1, 0, 10, 0, 3, 0, 0,
0, 1, 0, 8, 0, 0, 0, 2, 0, 7, };

// Missing class
private static final String msc = "MisClass";
private static final byte [] mscclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 13, 7, 0, 9, 7, 0, 11,
10, 0, 2, 0, 4, 12, 0, 6, 0, 5, 1, 0, 3, 40, 41, 86,
1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 4, 67, 111, 100, 101,
1, 0, 15, 76, 105, 110, 101, 78, 117, 109, 98, 101, 114, 84, 97, 98,
108, 101, 1, 0, 8, 77, 105, 115, 67, 108, 97, 115, 115, 1, 0, 13,
77, 105, 115, 67, 108, 97, 115, 115, 46, 106, 97, 118, 97, 1, 0, 12,
77, 105, 115, 115, 105, 110, 103, 67, 108, 97, 115, 115, 1, 0, 10, 83,
111, 117, 114, 99, 101, 70, 105, 108, 101, 0, 33, 0, 1, 0, 2, 0,
0, 0, 0, 0, 1, 0, 1, 0, 6, 0, 5, 0, 1, 0, 7, 0,
0, 0, 29, 0, 1, 0, 1, 0, 0, 0, 5, 42, -73, 0, 3, -79,
0, 0, 0, 1, 0, 8, 0, 0, 0, 6, 0, 1, 0, 0, 0, 2,
0, 1, 0, 12, 0, 0, 0, 2, 0, 10,};

// Missing interface
private static final String Mis = "Mis";
private static final byte [] Misclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 15, 7, 0, 10, 7, 0, 12,
7, 0, 14, 10, 0, 3, 0, 5, 12, 0, 7, 0, 6, 1, 0, 3,
40, 41, 86, 1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 4, 67,
111, 100, 101, 1, 0, 15, 76, 105, 110, 101, 78, 117, 109, 98, 101, 114,
84, 97, 98, 108, 101, 1, 0, 3, 77, 105, 115, 1, 0, 8, 77, 105,
115, 46, 106, 97, 118, 97, 1, 0, 7, 77, 105, 115, 115, 105, 110, 103,
1, 0, 10, 83, 111, 117, 114, 99, 101, 70, 105, 108, 101, 1, 0, 16,
106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 79, 98, 106, 101, 99, 116,
0, 33, 0, 1, 0, 3, 0, 1, 0, 2, 0, 0, 0, 1, 0, 1,
0, 7, 0, 6, 0, 1, 0, 8, 0, 0, 0, 29, 0, 1, 0, 1,
0, 0, 0, 5, 42, -73, 0, 4, -79, 0, 0, 0, 1, 0, 9, 0,
0, 0, 6, 0, 1, 0, 0, 0, 2, 0, 1, 0, 13, 0, 0, 0,
2, 0, 11,};


private static final String bf1 = "BadFormat1";
private static final byte [] bf1class = {
-54, -1, -70, -66, 0, 3, 0, 45, 0, 14, 7, 0, 7, 7, 0, 13,
10, 0, 2, 0, 4, 12, 0, 6, 0, 5, 1, 0, 3, 40, 41, 86,
1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 10, 66, 97, 100, 70,
111, 114, 109, 97, 116, 49, 1, 0, 15, 66, 97, 100, 70, 111, 114, 109,
97, 116, 49, 46, 106, 97, 118, 97, 1, 0, 4, 67, 111, 100, 101, 1,
0, 15, 76, 105, 110, 101, 78, 117, 109, 98, 101, 114, 84, 97, 98, 108,
101, 1, 0, 10, 83, 111, 117, 114, 99, 101, 70, 105, 108, 101, 1, 0,
3, 97, 100, 100, 1, 0, 16, 106, 97, 118, 97, 47, 108, 97, 110, 103,
47, 79, 98, 106, 101, 99, 116, 0, 33, 0, 1, 0, 2, 0, 0, 0,
0, 0, 2, 0, 1, 0, 6, 0, 5, 0, 1, 0, 9, 0, 0, 0,
29, 0, 1, 0, 1, 0, 0, 0, 5, 42, -73, 0, 3, -79, 0, 0,
0, 1, 0, 10, 0, 0, 0, 6, 0, 1, 0, 0, 0, 1, 0, 1,
0, 12, 0, 5, 0, 1, 0, 9, 0, 0, 0, 25, 0, 0, 0, 1,
0, 0, 0, 1, -79, 0, 0, 0, 1, 0, 10, 0, 0, 0, 6, 0,
1, 0, 0, 0, 3, 0, 1, 0, 11, 0, 0, 0, 2, 0, 8,};

private static final String bf2 = "BadFormat2";
private static final byte [] bf2class = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 14, 7, 0, 7, 7, 0, 13,
10, 0, 2, 0, 4, 12, 0, 6, 0, 5, 1, 0, 3, 40, 41, 86,
1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 10, 66, 97, 100, 70,
111, 114, 109, 97, 116, 50, 1, 0, 15, 66, 97, 100, 70, 111, 114, 109,
97, 116, 50, 46, 106, 97, 118, 97, 1, 0, 4, 67, 111, 100, 101, 1,
0, 15, 76, 105, 110, 101, 78, 117, 109, 98, 101, 114, 84, 97, 98, 108,
101, 1, 0, 10, 83, 111, 117, 114, 99, 101, 70, 105, 108, 101, 1, 0,
3, 97, 100, 100, 1, 0, 16, 106, 97, 118, 97, 47, 108, 97, 110, 103,
47, 79, 98, 106, 101, 99, 116, 0, 33, 0, 1, 0, 2, 0, 0, 0,
0, 0, 2, 0, 1, 0, 6, 0, 5, 0, 1, 0, 9, 0, 0, 0,
29, 0, 1, 0, 1, 0, 0, 0, 5, 42, -73, 0, 3, -79, 0, 0,
0, 1, 0, 10, 0, 0, 0, 6, 0, 1, 0, 0, 0, 1, 0, 1,
0, 12, 0, 5, 0, 1, 0, 9, 0, 0, 0, 25, 0, 0, 0, 1,
0, 0, 0, 1, -79, 0, 0, 0, 1, 0, 10, 0, 0, 0, 6, 0,
1, 0, 0, 0, 3, 0, 1, 0, 11, 1, 2, 3, 2, 0, 8, };



private static final String bf3 = "BadFormat3";
private static final byte [] bf3class = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 15, 7, 0, 8, 7, 0, 14,
10, 0, 2, 0, 4, 12, 0, 7, 0, 5, 1, 0, 3, 40, 41, 86,
1, 0, 4, 40, 73, 41, 73, 1, 0, 6, 60, 105, 110, 105, 116, 62,
1, 0, 10, 66, 97, 100, 70, 111, 114, 109, 97, 116, 51, 1, 0, 15,
66, 97, 100, 70, 111, 114, 109, 97, 116, 51, 46, 106, 97, 118, 97, 1,
0, 4, 67, 111, 100, 101, 1, 0, 15, 76, 105, 110, 101, 78, 117, 109,
98, 101, 114, 84, 97, 98, 108, 101, 1, 0, 10, 83, 111, 117, 114, 99,
101, 70, 105, 108, 101, 1, 0, 3, 97, 100, 100, 1, 0, 16, 106, 97,
118, 97, 47, 108, 97, 110, 103, 47, 79, 98, 106, 101, 99, 116, 0, 33,
0, 1, 0, 2, 0, 0, 0, 0, 0, 2, 0, 1, 0, 7, 0, 5,
0, 1, 0, 10, 0, 0, 0, 29, 0, 1, 0, 1, 0, 0, 0, 5,
42, -73, 0, 3, -79, 0, 0, 0, 1, 0, 11, 0, 0, 0, 6, 0,
1, 0, 0, 0, 1, 0, 1, 0, 13, 0, 6, 0, 1, 0, 10, 0,
0, 0, 75, 0, 3, 0, 4, 0, 0, 0, 27, 8, 61, 16, 7, 62,
-124, 3, -1, 29, 27, -6, -6, -124, 1, 1, 28, 29, 27, 96, 96, 61,
28, 29, 96, 27, 96, -84, 0, 0, 0, 1, 0, 11, 0, 0, 0, 30,
0, 7, 0, 0, 0, 4, 0, 2, 0, 5, 0, 5, 0, 6, 0, 8,
0, 7, 0, 12, 0, 8, 0, 15, 0, 9, 0, 21, 0, 10, 0, 1,
0, 12, 0, 0, 0, 2, 0, 9,};

private static final String nsf = "NoSuchField";
private static final byte [] nsfclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 22, 7, 0, 12, 7, 0, 16,
7, 0, 21, 10, 0, 3, 0, 7, 9, 0, 1, 0, 8, 9, 0, 2,
0, 9, 12, 0, 11, 0, 10, 12, 0, 19, 0, 14, 12, 0, 20, 0,
14, 1, 0, 3, 40, 41, 86, 1, 0, 6, 60, 105, 110, 105, 116, 62,
1, 0, 7, 67, 104, 97, 110, 103, 101, 100, 1, 0, 4, 67, 111, 100,
101, 1, 0, 1, 73, 1, 0, 15, 76, 105, 110, 101, 78, 117, 109, 98,
101, 114, 84, 97, 98, 108, 101, 1, 0, 11, 78, 111, 83, 117, 99, 104,
70, 105, 101, 108, 100, 1, 0, 16, 78, 111, 83, 117, 99, 104, 70, 105,
101, 108, 100, 46, 106, 97, 118, 97, 1, 0, 10, 83, 111, 117, 114, 99,
101, 70, 105, 108, 101, 1, 0, 7, 100, 101, 108, 101, 116, 101, 100, 1,
0, 4, 103, 111, 110, 101, 1, 0, 16, 106, 97, 118, 97, 47, 108, 97,
110, 103, 47, 79, 98, 106, 101, 99, 116, 0, 33, 0, 2, 0, 3, 0,
0, 0, 1, 0, 2, 0, 20, 0, 14, 0, 0, 0, 1, 0, 1, 0,
11, 0, 10, 0, 1, 0, 13, 0, 0, 0, 44, 0, 2, 0, 1, 0,
0, 0, 12, 42, -73, 0, 4, 42, -78, 0, 5, -75, 0, 6, -79, 0,
0, 0, 1, 0, 15, 0, 0, 0, 14, 0, 3, 0, 0, 0, 5, 0,
4, 0, 6, 0, 11, 0, 5, 0, 1, 0, 18, 0, 0, 0, 2, 0,
17,};

private static final String ins = "Instantiate";
private static final byte [] insclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 20, 7, 0, 11, 7, 0, 13,
7, 0, 19, 10, 0, 1, 0, 7, 10, 0, 3, 0, 7, 9, 0, 2,
0, 8, 12, 0, 10, 0, 9, 12, 0, 18, 0, 15, 1, 0, 3, 40,
41, 86, 1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 7, 67, 104,
97, 110, 103, 101, 100, 1, 0, 4, 67, 111, 100, 101, 1, 0, 11, 73,
110, 115, 116, 97, 110, 116, 105, 97, 116, 101, 1, 0, 16, 73, 110, 115,
116, 97, 110, 116, 105, 97, 116, 101, 46, 106, 97, 118, 97, 1, 0, 9,
76, 67, 104, 97, 110, 103, 101, 100, 59, 1, 0, 15, 76, 105, 110, 101,
78, 117, 109, 98, 101, 114, 84, 97, 98, 108, 101, 1, 0, 10, 83, 111,
117, 114, 99, 101, 70, 105, 108, 101, 1, 0, 11, 97, 98, 115, 116, 114,
97, 99, 116, 78, 111, 119, 1, 0, 16, 106, 97, 118, 97, 47, 108, 97,
110, 103, 47, 79, 98, 106, 101, 99, 116, 0, 33, 0, 2, 0, 3, 0,
0, 0, 1, 0, 2, 0, 18, 0, 15, 0, 0, 0, 1, 0, 1, 0,
10, 0, 9, 0, 1, 0, 12, 0, 0, 0, 48, 0, 3, 0, 1, 0,
0, 0, 16, 42, -73, 0, 5, 42, -69, 0, 1, 89, -73, 0, 4, -75,
0, 6, -79, 0, 0, 0, 1, 0, 16, 0, 0, 0, 14, 0, 3, 0,
0, 0, 5, 0, 4, 0, 6, 0, 15, 0, 5, 0, 1, 0, 17, 0,
0, 0, 2, 0, 14,};

private static final String chd = "Changed";
private static final byte [] chdclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 19, 7, 0, 10, 7, 0, 17,
10, 0, 2, 0, 5, 9, 0, 1, 0, 6, 12, 0, 9, 0, 8, 12,
0, 18, 0, 13, 1, 0, 3, 40, 41, 73, 1, 0, 3, 40, 41, 86,
1, 0, 6, 60, 105, 110, 105, 116, 62, 1, 0, 7, 67, 104, 97, 110,
103, 101, 100, 1, 0, 12, 67, 104, 97, 110, 103, 101, 100, 46, 106, 97,
118, 97, 1, 0, 4, 67, 111, 100, 101, 1, 0, 1, 73, 1, 0, 15,
76, 105, 110, 101, 78, 117, 109, 98, 101, 114, 84, 97, 98, 108, 101, 1,
0, 10, 83, 111, 117, 114, 99, 101, 70, 105, 108, 101, 1, 0, 8, 103,
101, 116, 86, 97, 108, 117, 101, 1, 0, 16, 106, 97, 118, 97, 47, 108,
97, 110, 103, 47, 79, 98, 106, 101, 99, 116, 1, 0, 8, 112, 117, 98,
84, 111, 80, 114, 105, 4, 33, 0, 1, 0, 2, 0, 0, 0, 1, 0,
10, 0, 18, 0, 13, 0, 0, 0, 2, 0, 1, 0, 9, 0, 8, 0,
1, 0, 12, 0, 0, 0, 29, 0, 1, 0, 1, 0, 0, 0, 5, 42,
-73, 0, 3, -79, 0, 0, 0, 1, 0, 14, 0, 0, 0, 6, 0, 1,
0, 0, 0, 2, 0, 10, 0, 16, 0, 7, 0, 1, 0, 12, 0, 0,
0, 28, 0, 1, 0, 0, 0, 0, 0, 4, -78, 0, 4, -84, 0, 0,
0, 1, 0, 14, 0, 0, 0, 6, 0, 1, 0, 0, 0, 7, 0, 1,
0, 15, 0, 0, 0, 2, 0, 11,};

private static final String nsm = "NoSuchMethod";
private static final byte [] nsmclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 18, 7, 0, 10, 7, 0, 13,
7, 0, 17, 10, 0, 3, 0, 6, 10, 0, 1, 0, 7, 12, 0, 9,
0, 8, 12, 0, 16, 0, 8, 1, 0, 3, 40, 41, 86, 1, 0, 6,
60, 105, 110, 105, 116, 62, 1, 0, 7, 67, 104, 97, 110, 103, 101, 100,
1, 0, 4, 67, 111, 100, 101, 1, 0, 15, 76, 105, 110, 101, 78, 117,
109, 98, 101, 114, 84, 97, 98, 108, 101, 1, 0, 12, 78, 111, 83, 117,
99, 104, 77, 101, 116, 104, 111, 100, 1, 0, 17, 78, 111, 83, 117, 99,
104, 77, 101, 116, 104, 111, 100, 46, 106, 97, 118, 97, 1, 0, 10, 83,
111, 117, 114, 99, 101, 70, 105, 108, 101, 1, 0, 13, 100, 101, 108, 101,
116, 101, 100, 77, 101, 116, 104, 111, 100, 1, 0, 16, 106, 97, 118, 97,
47, 108, 97, 110, 103, 47, 79, 98, 106, 101, 99, 116, 0, 33, 0, 2,
0, 3, 0, 0, 0, 0, 0, 1, 0, 1, 0, 9, 0, 8, 0, 1,
0, 11, 0, 0, 0, 40, 0, 1, 0, 1, 0, 0, 0, 8, 42, -73,
0, 4, -72, 0, 5, -79, 0, 0, 0, 1, 0, 12, 0, 0, 0, 14,
0, 3, 0, 0, 0, 3, 0, 4, 0, 4, 0, 7, 0, 3, 0, 1,
0, 15, 0, 0, 0, 2, 0, 14,};

private static final String acc = "Acces";
private static final byte [] accclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 26, 7, 0, 14, 7, 0, 15,
7, 0, 17, 7, 0, 23, 10, 0, 4, 0, 8, 9, 0, 3, 0, 9,
9, 0, 1, 0, 10, 12, 0, 12, 0, 11, 12, 0, 24, 0, 19, 12,
0, 25, 0, 19, 1, 0, 3, 40, 41, 86, 1, 0, 6, 60, 105, 110,
105, 116, 62, 1, 0, 8, 65, 99, 77, 101, 116, 104, 111, 100, 1, 0,
5, 65, 99, 99, 101, 115, 1, 0, 14, 65, 99, 99, 101, 115, 36, 65,
99, 77, 101, 116, 104, 111, 100, 1, 0, 10, 65, 99, 99, 101, 115, 46,
106, 97, 118, 97, 1, 0, 7, 67, 104, 97, 110, 103, 101, 100, 1, 0,
4, 67, 111, 100, 101, 1, 0, 1, 73, 1, 0, 12, 73, 110, 110, 101,
114, 67, 108, 97, 115, 115, 101, 115, 1, 0, 15, 76, 105, 110, 101, 78,
117, 109, 98, 101, 114, 84, 97, 98, 108, 101, 1, 0, 10, 83, 111, 117,
114, 99, 101, 70, 105, 108, 101, 1, 0, 16, 106, 97, 118, 97, 47, 108,
97, 110, 103, 47, 79, 98, 106, 101, 99, 116, 1, 0, 8, 112, 117, 98,
84, 111, 80, 114, 105, 1, 0, 5, 118, 97, 108, 117, 101, 0, 33, 0,
1, 0, 4, 0, 0, 0, 1, 0, 2, 0, 25, 0, 19, 0, 0, 0,
1, 0, 1, 0, 12, 0, 11, 0, 1, 0, 18, 0, 0, 0, 44, 0,
2, 0, 1, 0, 0, 0, 12, 42, -73, 0, 5, 42, -78, 0, 6, -75,
0, 7, -79, 0, 0, 0, 1, 0, 21, 0, 0, 0, 14, 0, 3, 0,
0, 0, 5, 0, 4, 0, 6, 0, 11, 0, 5, 0, 2, 0, 22, 0,
0, 0, 2, 0, 16, 0, 20, 0, 0, 0, 10, 0, 1, 0, 2, 0,
1, 0, 13, 0, 9,};

private static final String acm = "Acces.AcMethod";
private static final String acmname = "Acces$AcMethod";
private static final byte [] acmclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 25, 7, 0, 13, 7, 0, 14,
7, 0, 16, 7, 0, 23, 10, 0, 4, 0, 7, 10, 0, 3, 0, 8,
12, 0, 11, 0, 10, 12, 0, 22, 0, 9, 1, 0, 3, 40, 41, 73,
1, 0, 3, 40, 41, 86, 1, 0, 6, 60, 105, 110, 105, 116, 62, 1,
0, 8, 65, 99, 77, 101, 116, 104, 111, 100, 1, 0, 5, 65, 99, 99,
101, 115, 1, 0, 14, 65, 99, 99, 101, 115, 36, 65, 99, 77, 101, 116,
104, 111, 100, 1, 0, 10, 65, 99, 99, 101, 115, 46, 106, 97, 118, 97,
1, 0, 7, 67, 104, 97, 110, 103, 101, 100, 1, 0, 4, 67, 111, 100,
101, 1, 0, 1, 73, 1, 0, 12, 73, 110, 110, 101, 114, 67, 108, 97,
115, 115, 101, 115, 1, 0, 15, 76, 105, 110, 101, 78, 117, 109, 98, 101,
114, 84, 97, 98, 108, 101, 1, 0, 10, 83, 111, 117, 114, 99, 101, 70,
105, 108, 101, 1, 0, 8, 103, 101, 116, 86, 97, 108, 117, 101, 1, 0,
16, 106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 79, 98, 106, 101, 99,
116, 1, 0, 1, 118, 0, 33, 0, 2, 0, 4, 0, 0, 0, 1, 0,
0, 0, 24, 0, 18, 0, 0, 0, 1, 0, 1, 0, 11, 0, 10, 0,
1, 0, 17, 0, 0, 0, 41, 0, 1, 0, 1, 0, 0, 0, 9, 42,
-73, 0, 5, -72, 0, 6, 87, -79, 0, 0, 0, 1, 0, 20, 0, 0,
0, 14, 0, 3, 0, 0, 0, 12, 0, 4, 0, 13, 0, 8, 0, 12,
0, 2, 0, 21, 0, 0, 0, 2, 0, 15, 0, 19, 0, 0, 0, 10,
0, 1, 0, 2, 0, 1, 0, 12, 0, 9,};

private static final String init = "Initializer";
private static final byte [] initclass = {
-54, -2, -70, -66, 0, 3, 0, 45, 0, 29, 7, 0, 18, 7, 0, 25,
7, 0, 26, 10, 0, 2, 0, 9, 10, 0, 3, 0, 9, 10, 0, 3,
0, 10, 9, 0, 1, 0, 11, 9, 0, 1, 0, 12, 12, 0, 16, 0,
14, 12, 0, 24, 0, 13, 12, 0, 27, 0, 22, 12, 0, 28, 0, 21,
1, 0, 20, 40, 41, 76, 106, 97, 118, 97, 47, 108, 97, 110, 103, 47,
79, 98, 106, 101, 99, 116, 59, 1, 0, 3, 40, 41, 86, 1, 0, 8,
60, 99, 108, 105, 110, 105, 116, 62, 1, 0, 6, 60, 105, 110, 105, 116,
62, 1, 0, 4, 67, 111, 100, 101, 1, 0, 11, 73, 110, 105, 116, 105,
97, 108, 105, 122, 101, 114, 1, 0, 16, 73, 110, 105, 116, 105, 97, 108,
105, 122, 101, 114, 46, 106, 97, 118, 97, 1, 0, 15, 76, 105, 110, 101,
78, 117, 109, 98, 101, 114, 84, 97, 98, 108, 101, 1, 0, 18, 76, 106,
97, 118, 97, 47, 108, 97, 110, 103, 47, 79, 98, 106, 101, 99, 116, 59,
1, 0, 22, 76, 106, 97, 118, 97, 47, 117, 116, 105, 108, 47, 76, 105,
110, 107, 101, 100, 76, 105, 115, 116, 59, 1, 0, 10, 83, 111, 117, 114,
99, 101, 70, 105, 108, 101, 1, 0, 8, 103, 101, 116, 70, 105, 114, 115,
116, 1, 0, 16, 106, 97, 118, 97, 47, 108, 97, 110, 103, 47, 79, 98,
106, 101, 99, 116, 1, 0, 20, 106, 97, 118, 97, 47, 117, 116, 105, 108,
47, 76, 105, 110, 107, 101, 100, 76, 105, 115, 116, 1, 0, 2, 108, 108,
1, 0, 1, 111, 0, 33, 0, 1, 0, 2, 0, 0, 0, 2, 0, 9,
0, 27, 0, 22, 0, 0, 0, 10, 0, 28, 0, 21, 0, 0, 0, 2,
0, 8, 0, 15, 0, 14, 0, 1, 0, 17, 0, 0, 0, 52, 0, 2,
0, 0, 0, 0, 0, 20, -69, 0, 3, 89, -73, 0, 5, -77, 0, 7,
-78, 0, 7, -74, 0, 6, -77, 0, 8, -79, 0, 0, 0, 1, 0, 20,
0, 0, 0, 14, 0, 3, 0, 0, 0, 9, 0, 10, 0, 10, 0, 19,
0, 3, 0, 1, 0, 16, 0, 14, 0, 1, 0, 17, 0, 0, 0, 29,
0, 1, 0, 1, 0, 0, 0, 5, 42, -73, 0, 4, -79, 0, 0, 0,
1, 0, 20, 0, 0, 0, 6, 0, 1, 0, 0, 0, 3, 0, 1, 0,
23, 0, 0, 0, 2, 0, 19,};

}