#ifndef _PROCESSOR_H
#define _PROCESSOR_H

/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
*                                                                         *
* Updates copyright (c) by Chris Gray, /k/ Embedded Java Solutions.       *
* Permission is hereby granted to distribute these changes under the      *
* terms of the Wonka Public Licence.                                      *
**************************************************************************/

/*
** $Id: processor.h 4227 2005-10-01 19:53:57Z chris $
** 
** The Wonka kernel is software copyright by SmartMove NV (1999).
** Please see the file Copyright for information on it's legal use.
** 
*/

/*
** Machine dependent stuff for the StrongARM Architecture
*/

#include <sys/types.h>

#ifndef __BIT_TYPES_DEFINED__
#error You have work to do here! See wonka/include/wonka.h.
#endif

/*
** A double word quantity is represented as an array of two 32 bit words. 
** LSW(l) and MSW(l) return the lower 32 bits and the upper 32 bits of a 64 bit quantity according
** to the settings of the MS_WORD and LS_WORD parameters. Our Wonka machine always uses these
** macros to get at double word values (be it floating point doubles or long integers).
**
*/

#ifdef BIG_ENDIAN
#undef BIG_ENDIAN
#endif

#ifndef LITTLE_ENDIAN
#define LITTLE_ENDIAN 1234
#endif

#define LITTLE_ENDIAN_PROCESSOR
#define LSW_PART(l)                  (w_word)(l)
#define MSW_PART(l)                  (w_word)((l)>>32)
#define DWORD_TO_WORDS(c, cm, cl)    (cm) = MSW_PART(c); (cl) = LSW_PART(c)
#define SIGN_EXTEND(b)               ((w_word)b)
#define WORDS2LONG(m, l)             (w_long)(((w_long)(m) << 32) | (l))
#define WORDS2DOUBLE(m, l)           ((w_u64)(((w_long)(m) << 32) | (l))).d64

#endif /* _PROCESSOR_H */
