#ifndef _EXCEPTION_H
#define _EXCEPTION_H

/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: exception.h 3451 2003-02-06 14:25:34Z gray $
*/

#include "threads.h"
#include "wonka.h"

/**
  This file contains prototypes for functions which are used to throw
  exceptions from within a Java thread.
*/

/** Throw an exception: `format' is allowed to be NULL (there will then be no detailMessage).
*/

void throwException(w_thread thread, w_clazz clazz, char * format, ...);

/** Throw an OutOfMemoryError
*/
void throwOutOfMemoryError(w_thread);

void throwLocalException(w_thread sender, w_clazz exception, const char *file, const char *function, int line, const char *fmt, ...);
w_instance createExceptionInstance(w_thread thread, w_clazz clazz, w_string message);
void setLocalException(w_thread thread, w_instance Exception);
void fillInStackTrace(w_instance thisThrowable);

#ifndef __LINT__
#define ThrowLocalException(t, e, m, a...) throwLocalException((t), (e), __FILE__, __FUNCTION__, __LINE__, m, ##a)
#endif

//#define WS_EXCEPTION     WS_InternalError


inline static w_instance exceptionThrown(w_thread thread) {
  return thread->exception;
}

char * print_exception(char * buffer, int * remain, void * data, int w, int p, unsigned int f);

void throwExceptionInstance(w_thread thread, w_instance exception);
w_instance clearException(w_thread thread);

void fillThrowable(w_thread thread, w_instance Throwable);

#endif /* _EXCEPTION_H */
