/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips-site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/



package com.acunia.wonka.net.jar;

import java.io.InputStream;
import java.io.IOException;
import java.util.jar.Manifest;

/**
 *
 * @version	$Id: ImmutableManifest.java 2532 2002-08-14 11:09:08Z vandeneede $
 *
 * A Manifest which cannot be changed, because we override the methods 
 * which would change it.
 */
public class ImmutableManifest extends Manifest {

  public ImmutableManifest(Manifest m) {
    super(m);
  }

  public void clear() {
    throw new UnsupportedOperationException();
  }

  public void read(InputStream in) throws IOException {
    throw new UnsupportedOperationException();
  }

}

