/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/*
** $Id: Chris.java 3815 2003-04-10 14:42:14Z dumon $
*/
package com.acunia.wonka.test;

class Chris implements Runnable {

  public void run() {
    System.out.println("Farewell world");
  }

  public static void main(String[] args) {

    System.out.println("java.vm.version = "+System.getProperty("java.vm.version"));
    System.out.println("java.vm.vendor = "+System.getProperty("java.vm.vendor"));
    System.out.println("java.vm.name = "+System.getProperty("java.vm.name"));
    System.out.println("java.class.version = "+System.getProperty("java.class.version"));
    System.out.println("java.class.path = "+System.getProperty("java.class.path"));
    System.out.println("java.ext.dirs.path = "+System.getProperty("java.ext.dirs"));
    System.out.println("os.name = "+System.getProperty("os.name"));
    System.out.println("os.arch = "+System.getProperty("os.arch"));
    System.out.println("os.version = "+System.getProperty("os.version"));
    System.out.println("os.name = "+System.getProperty("user.name"));
    System.out.println("user.home = "+System.getProperty("user.home"));
    System.out.println("user.dir = "+System.getProperty("user.dir"));
    Runtime rt = Runtime.getRuntime();

    int j = 0;
    long t0 = System.currentTimeMillis();
    for (int i = 0; i < 1000000; ++i) {
      synchronized(rt) {
        ++j;
      }
    }
    long t1 = System.currentTimeMillis();
    System.out.println("Performed "+j+" synchronized blocks in "+(t1-t0)+" milliseconds");

    try {
      Thread.sleep(1000000);
    }
    catch (InterruptedException ie) {}

    for (int i = 0; i < 10; ++i) {
    byte[][] blob = new byte[10][1000000];
    System.out.println("Memory available: "+rt.freeMemory());
    long t2 = System.currentTimeMillis();
    blob = null;
    rt.gc();
    long t3 = System.currentTimeMillis();
    System.out.println("gc() took "+(t3-t2)+" milliseconds");
    System.out.println("Memory available: "+rt.freeMemory());
    }

/*
    if (args.length > 0) {
      StringBuffer sentence = new StringBuffer();
      for (int i = 0; i < args.length - 1; ++i) {
        sentence.append(args[i]);
        sentence.append(' ');
      }
      sentence.append(args[args.length - 1]);
      Carillon.getInstance(sentence.toString()).setDaemon(true);
    }
    else {
      Carillon.getInstance("Multithreaded programming is difficult and error prone. It is easy to make a mistake in synchronization that produces a data race, yet it can be extremely hard to locate this mistake during debugging.").setDaemon(true);
    }
*/
    Runtime.getRuntime().addShutdownHook(new Thread(new Chris()));

  }

}

