/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: FilterWriter.java 2532 2002-08-14 11:09:08Z vandeneede $
*/

package java.io;

public abstract class FilterWriter extends Writer {

  protected Writer out;
  
  protected FilterWriter(Writer out) {
    super(out);
    this.out = out;
  }

  public void close() throws IOException {
    synchronized(lock){
      out.close();
    }
  }

  public void flush() throws IOException {
    synchronized(lock){
      out.flush();
    }
  }

  public void write(int oneChar) throws IOException {
    synchronized(lock){
      out.write(oneChar);
    }
  }
  
  public void write(char[] buf, int offset, int count) throws IOException {
    synchronized(lock){
      out.write(buf, offset, count);
    }
  }
  
  public void write(String str, int offset, int count) throws IOException{
    synchronized(lock){
      out.write(str, offset, count);
    }
  }
}
