/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: 
*/

package java.lang;

import java.util.Enumeration;
import java.util.Vector;

/**
 ** A ThreadLocal has a different value in each Thread which refers to it.
 ** In our implementation the values are actually stored in a Hashtable in
 ** the Thread itself.
 */
public class ThreadLocal {

  Vector threads = new Vector();

  public Object get() {
    Thread current_thread = Thread.currentThread();

    if (!threads.contains(current_thread)) {
      threads.add(current_thread);
      Object val = initialValue();
      current_thread.setThreadLocal(this,val);

      return val;

    }

    return current_thread.getThreadLocal(this);
  }

  public void set(Object val) {
    Thread current_thread = Thread.currentThread();

    if (!threads.contains(current_thread)) {
      threads.add(current_thread);
    }
    current_thread.setThreadLocal(this,val);
  }

  public Object initialValue() {
    return null;
  }

  void deleteThread(Thread t) {
  // TODO: only allow if t is caller
    threads.remove(t);
  }

  protected void finalize() {
    Enumeration e = threads.elements();

    while (e.hasMoreElements()) {
      ((Thread)(e.nextElement())).deleteThreadLocal(this);
    }
  }
}
