/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/



package java.security;

/**
 *
 * $Id: SecureClassLoader.java 4257 2005-10-28 08:42:29Z chris $
 *
 */
public class SecureClassLoader extends ClassLoader {

  protected SecureClassLoader() throws SecurityException {
  }

  protected SecureClassLoader(ClassLoader parent) throws SecurityException {
    super(parent);
  }

  protected final Class defineClass( String name, byte []b, int off, int len, CodeSource cs) {
    if (cs != null) {
      return defineClass(name, b, off, len, new ProtectionDomain(cs,getPermissions(cs)));
    }
    else {
      return defineClass(name, b, off, len);
    }
  }

  protected PermissionCollection getPermissions(CodeSource cs){
    Policy policy;

    if (wonka.vm.SecurityConfiguration.USE_ACCESS_CONTROLLER) {
      GetPolicy gp = new GetPolicy();
      policy = gp.get();
    }
    else {
      policy = Policy.getPolicy();
    }

    if (policy == null) {
      // HACK HACK HACK
      // Bootstrapping, there ain't no policy yet - allow everything(???)
      PermissionCollection theAllPermission;

      theAllPermission = new com.acunia.wonka.security.DefaultPermissionCollection();
      theAllPermission.add(new AllPermission());

      return theAllPermission;
    }

    return policy.getPermissions(cs) ;
  }
}

