/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
*                                                                         *
* Modifications copyright (c) 2005 by Chris Gray, /k/ Embedded Java       *
* Solutions. All rights reserved.                                         *
*                                                                         *
**************************************************************************/

/*
** $Id: NativeProcess.java 4294 2006-05-10 11:35:19Z chris $
*/

package wonka.vm;

import java.io.OutputStream;
import java.io.InputStream;

public class NativeProcess extends Process {

  private final static int STILL_RUNNING = 10000;
  private final static int ERROR = 10001;

  private int process_id;
  private int fd_in;
  private int fd_out;
  private int fd_err;
  private int returnvalue = STILL_RUNNING; 

  public OutputStream getOutputStream() {
    return new ProcessOutputStream(process_id, fd_in);
  }
  
  public InputStream getInputStream() {
    return new ProcessInputStream(process_id, fd_out);
  }
  
  public InputStream getErrorStream() {
    return new ProcessInputStream(process_id, fd_err);
  }

  public native int waitFor0();
  public int waitFor() throws InterruptedException {
    if(returnvalue == STILL_RUNNING) {
      returnvalue = waitFor0();
    }
    
    if(returnvalue == ERROR) {
      return -1;
    }
    else {
      return returnvalue;
    }
  }
  
  public int exitValue() throws IllegalThreadStateException {
    if(returnvalue == STILL_RUNNING) {
      throw new IllegalThreadStateException("Process is still running");
    }
    
    if(returnvalue == ERROR) {
      return -1;
    }

    return returnvalue;
  }
    
  public native void destroy();
 
  public String toString() {
    return "PID: " + process_id + " returnvalue: " + returnvalue;
  }
}
