/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/*
** $Id: Wonka.java 4211 2005-03-14 07:07:23Z jbader $
*/

package wonka.vm;

import java.io.InputStream;
import java.io.IOException;
import java.util.Properties;

public final class Wonka {

  private static Properties wonkaProperties = new Properties();

  static {
  // Look up the wonka properties file name as a system property -
  // we don't really expect it to be there, but it ensures the system
  // properties are loaded first, FWIW.
    String propname = System.getProperty("com.acunia.wonka.properties", "wonka.properties");

    try {
      InputStream propstream = ClassLoader.getSystemResourceAsStream(propname);
      if (propstream != null) {
        wonkaProperties.load(propstream);
      }
    }
    catch (IOException e) {}
  }

  private static void propertiesCheck() {
/* TODO: do we need some code like this? Probably ...
    if (wonka.vm.SecurityConfiguration.USE_ACCESS_CONTROLLER) {
      java.security.AccessController.checkPermission(new PropertyPermission("*", "read,write"));
    }
    else if (wonka.vm.SecurityConfiguration.USE_SECURITY_MANAGER) {
      if (theSecurityManager != null) {
        theSecurityManager.checkPropertiesAccess();
      }
    }
*/
  }

  public static Properties getProperties() 
    throws SecurityException
  {
    propertiesCheck();
    return wonkaProperties;
  }

  public static String getProperty(String key) 
    throws SecurityException
  {
// TODO ?    propertyCheck(key);

    try {

      return wonkaProperties.getProperty(key);

    }
    catch (NullPointerException npe) {

      return null;

    }
  }

    
  public static String getProperty(String key, String defaults)
    throws SecurityException
  {
// TODO ?    propertyCheck(key);

    try {

      return wonkaProperties.getProperty(key,defaults);

    }
    catch (NullPointerException npe) {

      return defaults;

    }
  }
  
  public static int getIntProperty(String key, int defaults)
  {
      try
      {
        return Integer.parseInt(wonkaProperties.getProperty(key));
      }
      catch(NumberFormatException ex)
      {
        return defaults;
      }      
  }

  /*
  ** Calculate the SerialVersionUID of a certain Class.
  */
  
  native static public long suid(Class c);
  
}

