/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/* DO NOT EDIT THIS FILE - it is machine generated */
#include <jni.h>
#include <vfs.h>
/* Header for class RandomAccessFile */

#ifndef _Included_RandomAccessFile
#define _Included_RandomAccessFile
#ifdef __cplusplus
extern "C" {
#endif

static jclass   raf_clazz;
static jclass   filedesc_clazz;
static jclass   ioe_clazz;
static jmethodID ioe_constructor;
static jmethodID filedesc_constructor;
static jfieldID fd_field;
static jfieldID fd;
static jfieldID name;
static jfieldID filedesc_validFD;

static void RandomAccessFileInit(JNIEnv *env, jobject thisObj) {
  raf_clazz = (*env)->GetObjectClass(env, thisObj);
  filedesc_clazz = (*env)->FindClass(env, "java/io/FileDescriptor");
  ioe_clazz    = (*env)->FindClass(env, "java/io/IOException");
  ioe_constructor = (*env)->GetMethodID(env, ioe_clazz, "<init>", "()V");
  filedesc_constructor = (*env)->GetMethodID(env, filedesc_clazz, "<init>", "()V");
  fd_field = (*env)->GetFieldID(env, raf_clazz, "fd", "Ljava/io/FileDescriptor;");
  fd = (*env)->GetFieldID(env, filedesc_clazz, "fd", "I");
  name = (*env)->GetFieldID(env, filedesc_clazz, "fileName", "Ljava/lang/String;");
  filedesc_validFD = (*env)->GetFieldID(env, filedesc_clazz, "validFD", "Z");
}

static void throwIOException(JNIEnv *env) {
  jthrowable throwObj = (jthrowable)(*env)->NewObject(env, ioe_clazz, ioe_constructor);
  (*env)->Throw(env, throwObj);
}
/*
 * Class:     RandomAccessFile
 * Method:    createFromString
 * Signature: (Ljava/lang/String;Ljava/lang/String;)V
 */
JNIEXPORT int JNICALL Java_RandomAccessFile_createFromString
  (JNIEnv *env, jobject thisObj, jstring path, jstring mode) {

  const char  *pathname;
  const char  *openmode;
  jboolean    isCopy1;
  jboolean    isCopy2;
  vfs_FILE    *file;
  jobject     obj;

  if(!name) RandomAccessFileInit(env, thisObj);

  pathname = (*env)->GetStringUTFChars(env, path, &isCopy1);	  
  openmode = (*env)->GetStringUTFChars(env, mode, &isCopy2);	  
  
  file = vfs_fopen(pathname, openmode);

  if(isCopy1 == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);
  if(isCopy2 == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, mode, openmode);
 
  if(file == NULL) {

    return 1;
    
  } else {
    obj = (*env)->NewObject(env, filedesc_clazz, filedesc_constructor);
    (*env)->SetObjectField(env, thisObj, fd_field, obj);
    
    (*env)->SetIntField(env, obj, filedesc_validFD, 1);
    (*env)->SetIntField(env, obj, fd, (jint)file);
    (*env)->SetObjectField(env, obj, name, path);
  }

  return 0;

}

/*
 * Class:     RandomAccessFile
 * Method:    read
 * Signature: ()I
 */
JNIEXPORT jint JNICALL Java_RandomAccessFile_read
  (JNIEnv *env, jobject thisObj) {

  jobject     obj;
  vfs_FILE    *file;
  jint        result = -1;

  obj = (*env)->GetObjectField(env, thisObj, fd_field);
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fd));
  
  if(file == NULL) {
    throwIOException(env);
    result = 0;
  } else {
    result = vfs_fgetc(file);
    //if(!vfs_feof(file)) result = vfs_fgetc(file);
  }

  return result;
}

/*
 * Class:     RandomAccessFile
 * Method:    readIntoBuffer
 * Signature: ([BII)I
 */
JNIEXPORT jint JNICALL Java_RandomAccessFile_readIntoBuffer
  (JNIEnv *env, jobject thisObj, jbyteArray buffer, jint offset, jint length) {
  
  jobject     obj;
  vfs_FILE    *file;
  jint        result;
  jboolean    isCopy;
  jbyte       *bytes = (*env)->GetByteArrayElements(env, buffer, &isCopy);
  jbyte       *data;

  obj = (*env)->GetObjectField(env, thisObj, fd_field);
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fd));
  
  if(file == NULL) {
    throwIOException(env);
    result = 0;
  } else {
    data = bytes + offset;
    result = vfs_fread(data, 1, (w_word)length, file);
    if(result == 0) result = -1;
  }

  if(isCopy == JNI_TRUE) (*env)->ReleaseByteArrayElements(env, buffer, bytes, 0);

  return result;
}

/*
 * Class:     RandomAccessFile
 * Method:    skipBytes
 * Signature: (I)I
 */
JNIEXPORT jint JNICALL Java_RandomAccessFile_skipBytes
  (JNIEnv *env, jobject thisObj, jint n) {

  jobject     obj;
  vfs_FILE    *file;
  jlong       result = n;
  jlong       prev_pos;

  obj = (*env)->GetObjectField(env, thisObj, fd_field);
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fd));
  
  if(file == NULL) {
    throwIOException(env);
    result = 0;
  } else {
    prev_pos = vfs_ftell(file);
    result = vfs_fseek(file, (long)n, SEEK_SET);

    if(result == 0) {
      result = vfs_ftell(file) - prev_pos;
    } else {
      throwIOException(env);
      result = 0; 
    }
  }

  return result;
}

/*
 * Class:     RandomAccessFile
 * Method:    write
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_RandomAccessFile_write
  (JNIEnv *env, jobject thisObj, jint oneByte) {

  jobject     obj;
  vfs_FILE    *file;

  obj = (*env)->GetObjectField(env, thisObj, fd_field);
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fd));
  
  if(file == NULL) {
    throwIOException(env);
  } else {
    vfs_fputc(oneByte, file);
  }
}

/*
 * Class:     RandomAccessFile
 * Method:    writeFromBuffer
 * Signature: ([BII)V
 */
JNIEXPORT void JNICALL Java_RandomAccessFile_writeFromBuffer
  (JNIEnv *env, jobject thisObj, jbyteArray buffer, jint offset, jint length) {

  jobject     obj;
  vfs_FILE    *file;
  jboolean    isCopy;
  jbyte       *bytes = (*env)->GetByteArrayElements(env, buffer, &isCopy);
  jbyte       *data;

  obj = (*env)->GetObjectField(env, thisObj, fd_field);
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fd));
  
  if(file == NULL) {
    throwIOException(env);
  } else {
    data = bytes + offset;
    vfs_fwrite(data, 1, (w_word)length, file);
  }

  if(isCopy == JNI_TRUE) (*env)->ReleaseByteArrayElements(env, buffer, bytes, 0);

}

/*
 * Class:     RandomAccessFile
 * Method:    getFilePointer
 * Signature: ()J
 */
JNIEXPORT jlong JNICALL Java_RandomAccessFile_getFilePointer
  (JNIEnv *env, jobject thisObj) {

  jobject     obj;
  vfs_FILE    *file;
  jlong       result = -1;

  obj = (*env)->GetObjectField(env, thisObj, fd_field);
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fd));
  
  if(file == NULL) {
    throwIOException(env);
    result = 0;
  } else {
    result = vfs_ftell(file);
  }

  return result;
}

/*
 * Class:     RandomAccessFile
 * Method:    seek
 * Signature: (J)V
 */
JNIEXPORT void JNICALL Java_RandomAccessFile_seek
  (JNIEnv *env, jobject thisObj, jlong pos) {

  jobject     obj;
  vfs_FILE    *file;

  obj = (*env)->GetObjectField(env, thisObj, fd_field);
  file = (vfs_FILE *)((*env)->GetIntField(env, obj, fd));
  
  if(file == NULL) {
    throwIOException(env);
  } else {
    if(vfs_fseek(file, (long)pos, SEEK_SET) == -1) {
      throwIOException(env);
    }
  }
}

/*
 * Class:     RandomAccessFile
 * Method:    length
 * Signature: ()J
 */
JNIEXPORT jlong JNICALL Java_RandomAccessFile_length
  (JNIEnv *env, jobject thisObj) {

  jobject         obj;
  jboolean        isCopy;
  const char      *pathname;
  jstring         path;
  struct vfs_STAT statbuf;
  jlong           result = 0;
  
  obj = (*env)->GetObjectField(env, thisObj, fd_field);
  path = (jstring)(*env)->GetObjectField(env, obj, name);
  pathname = (*env)->GetStringUTFChars(env, path, &isCopy);	  

  if(vfs_stat((w_ubyte *)pathname, &statbuf) != -1) {
    result = statbuf.st_size;
  }
  
  if(isCopy == JNI_TRUE) (*env)->ReleaseStringUTFChars(env, path, pathname);

  return result;
}

/*
 * Class:     RandomAccessFile
 * Method:    setLength
 * Signature: (J)V
 */
JNIEXPORT void JNICALL Java_RandomAccessFile_setLength
  (JNIEnv *env, jobject thisObj, jlong len) {

}

/*
 * Class:     RandomAccessFile
 * Method:    close
 * Signature: ()V
 */
JNIEXPORT void JNICALL Java_RandomAccessFile_close
  (JNIEnv *env, jobject thisObj) {

  jobject     obj;
  vfs_FILE    *file;

  obj = (*env)->GetObjectField(env, thisObj, fd_field);

  if(obj == NULL) {
    throwIOException(env);
  } else {
    
    file = (vfs_FILE *)((*env)->GetIntField(env, obj, fd));
  
    if(file == NULL) {  
      throwIOException(env);
    } else {
      vfs_fclose(file);
      (*env)->SetIntField(env, obj, fd, (jint)NULL);
    }
    
  }
  
}

#ifdef __cplusplus
}
#endif
#endif
