/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: Double.c 4140 2004-04-05 08:18:48Z dumon $
*/

#include "clazz.h"
#include "descriptor.h"
#include "ieee754.h"

#ifdef HW_DOUBLES
typedef union doubles {
  w_double d;
  w_long l;
  w_word w[2];
} doubles;
#else 
#include "Math.h"
#endif

w_long Double_static_doubleToRawLongBits(JNIEnv *env, w_instance class, w_double d) {
#ifdef HW_DOUBLES
  doubles dd;

  dd.d = d;

#ifdef ARM
  {
    w_word t = dd.w[0];
    dd.w[0] = dd.w[1];
    dd.w[1] = t;
  }
#endif 

  return dd.l;

#else
  return (w_long) d;
#endif

}

w_double Double_static_longToDoubleBits(JNIEnv *env, w_instance class, w_long j) {
#ifdef HW_DOUBLES
  doubles dd;

  dd.l = j;

#ifdef ARM
  {
    w_word t = dd.w[0];
    dd.w[0] = dd.w[1];
    dd.w[1] = t;
  }
#endif 

  return dd.d;
  
#else
  return (w_double) j;
#endif
}

w_boolean Double_static_isNaN(JNIEnv *env, w_instance class, w_double j) {

  return float64_is_NaN(j);

}

w_boolean Double_static_isInfinite(JNIEnv *env, w_instance class, w_double j) {

  return float64_is_Infinite(j);

}


w_instance
Double_getWrappedClass(JNIEnv *env, w_instance thisClass) {

  return clazz2Class(clazz_double);
  
}
