/**************************************************************************
* Copyright  (c) 2001, 2002 by Acunia N.V. All rights reserved.           *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: Float.c 4140 2004-04-05 08:18:48Z dumon $
*/

#include "clazz.h"
#include "descriptor.h"
#ifdef HW_DOUBLES
#include "ieee754.h"
#else
#include "Math.h"
#endif

w_int Float_static_floatToRawIntBits(JNIEnv *env, w_instance class, w_float f) {
#ifdef HW_DOUBLES
  w_int* i = (w_int*)&f;
  return i[0];
#else
  return (w_int)f;
#endif
}

w_float Float_static_intToFloatBits(JNIEnv *env, w_instance class, w_int i) {
#ifdef HW_DOUBLES
  w_float* f = (w_float*)&i;
  return f[0];
#else
  return (w_float) i;
#endif
}

w_boolean Float_static_isInfinite(JNIEnv *env, w_instance class, w_float f) {
  return float32_is_Infinite(f);
}

w_boolean Float_static_isNaN(JNIEnv *env, w_instance class, w_float f) {
  return float32_is_NaN(f);
}

w_instance Float_getWrappedClass(JNIEnv *env, w_instance thisClass) {
  return clazz2Class(clazz_float);
}
