/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/


/*
** $Id: Reference.c 3451 2003-02-06 14:25:34Z gray $
*/

#include "clazz.h"
#include "core-classes.h"
#include "heap.h"

void Reference_set(JNIEnv *env, w_instance this, w_instance referent) {
  woempa(1, "Setting reference from %j to %k at %p\n", this, instance2clazz(referent), (w_instance)referent);
  setWotsitField(this, F_Reference_referent, referent);
}

w_instance Reference_get(JNIEnv *env, w_instance this) {
  w_instance referent = getWotsitField(this, F_Reference_referent);
  woempa(1, "Getting reference from %j to %j\n", this, referent);
  if (referent && isSet(instance2object(referent)->flags, O_CONDEMNED)) {
    woempa(1, "Referent %j is condemned, returning NULL\n", referent);
    referent = NULL;
  }

  return referent;
}

void Reference_clear(JNIEnv *env, w_instance this) {
  woempa(1, "User cleared reference from %j to %j\n", this, getWotsitField(this, F_Reference_referent));
  setWotsitField(this, F_Reference_referent, NULL);
}

