#include "core-classes.h"
#include "arrays.h"
#include "exception.h"
#include "fields.h"
#include "wstrings.h"
#include "loading.h"
#include "network.h"
#include <net/if.h> // for ifreq
#include <arpa/inet.h> // for inet_ntoa

w_instance NetworkInterface_getNetworkInterfacesNative(JNIEnv *env, w_instance thisNetworkInterface)
{
	w_instance Array;
	w_instance Interface;
	w_thread thread = JNIEnv2w_thread(env);
	w_clazz clazzArrayOf_NetworkInterface = getNextDimension(clazzNetworkInterface);
	w_size arrayLength;
	int s;
	int i;
	int arrayIndex = 0;
	struct in_addr in_addr_alloc;
        struct in_addr* in_addr = &in_addr_alloc;
	struct ifreq *if_req;
        struct ifconf if_conf;
	char buf[4096];
	
	s = w_socket(PF_INET, SOCK_DGRAM, IPPROTO_IP);
   
        if_conf.ifc_len = sizeof(buf);
        if_conf.ifc_buf = buf;
        ioctl(s, SIOCGIFCONF, &if_conf);
   
        if_req = if_conf.ifc_req;
	i = (if_conf.ifc_len)/sizeof(struct ifreq);
	arrayLength = i;
	
	Array = allocArrayInstance(thread, clazzArrayOf_NetworkInterface, 1, &arrayLength);
	for ( ; --i >=0; if_req++)
        {
	   ioctl(s, SIOCGIFADDR, &if_req);
	   in_addr = (&((struct sockaddr_in*)&(if_req->ifr_addr))->sin_addr);
	   Interface = allocInstance(thread, clazzNetworkInterface);
	   setReferenceField(Interface, (*env)->NewStringUTF(env, if_req->ifr_name), F_NetworkInterface_name);
	   setReferenceField(Interface, (*env)->NewStringUTF(env, inet_ntoa(*in_addr)), F_NetworkInterface_ipAddress);
	   setIntegerField(Interface, F_NetworkInterface_index, arrayIndex+1);
	   setArrayReferenceField(Array, Interface, arrayIndex++);
        }
        w_socketclose(s);
	
	return Array;
}
