/**************************************************************************
* Copyright (c) 2001, 2002, 2003 by Acunia N.V. All rights reserved.      *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Philips site 5, box 3       info@acunia.com                           *
*   3001 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: Realm.c 3451 2003-02-06 14:25:34Z gray $
*/

#include "core-classes.h"
#include "fields.h"
#include "ts-mem.h"
#include "realms.h"

void Realm_create(JNIEnv *env, w_instance thisRealm, w_instance parentRealm, w_long memory, w_int threads) {
  w_group group = getWotsitField(thisRealm, F_ThreadGroup_wotsit);
  w_realm parent;

  woempa(9,"Super is ThreadGroup %p\n",group);
  if (!isNullInstance(parentRealm)) {
   w_group parent_group = getWotsitField(parentRealm, F_ThreadGroup_wotsit);
   parent = parent_group->realm;
  }
  else {
    parent = W_Realm_system;
  }

  group->realm = newRealm(group, parent, memory, threads);
}

w_instance Realm_static_getCurrentRealm(JNIEnv *env, w_instance classRealm) {
  w_thread thread = JNIEnv2w_thread(env);
  w_realm  realm  = thread2realm(thread);

  return realm->ThreadGroup;
}

void
Realm_finalize (JNIEnv *env, w_instance thisRealm) {
  w_group group = getWotsitField(thisRealm, F_ThreadGroup_wotsit);
  w_realm realm = group->realm;

  destroyRealm(realm);
}


