/**************************************************************************
* Copyright  (c) 2001 by Acunia N.V. All rights reserved.                 *
*                                                                         *
* This software is copyrighted by and is the sole property of Acunia N.V. *
* and its licensors, if any. All rights, title, ownership, or other       *
* interests in the software remain the property of Acunia N.V. and its    *
* licensors, if any.                                                      *
*                                                                         *
* This software may only be used in accordance with the corresponding     *
* license agreement. Any unauthorized use, duplication, transmission,     *
*  distribution or disclosure of this software is expressly forbidden.    *
*                                                                         *
* This Copyright notice may not be removed or modified without prior      *
* written consent of Acunia N.V.                                          *
*                                                                         *
* Acunia N.V. reserves the right to modify this software without notice.  *
*                                                                         *
*   Acunia N.V.                                                           *
*   Vanden Tymplestraat 35      info@acunia.com                           *
*   3000 Leuven                 http://www.acunia.com                     *
*   Belgium - EUROPE                                                      *
**************************************************************************/

/*
** $Id: opcodes.c 2532 2002-08-14 11:09:08Z vandeneede $
*/

#include "opcodes.h"

opcode_i opcode_info[] = {
  { "nop",				0x00, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "aconst_null",			0x01, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iconst_m1",			0x02, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iconst_0",				0x03, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iconst_1",				0x04, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iconst_2",				0x05, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iconst_3",				0x06, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iconst_4",				0x07, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iconst_5",				0x08, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "lconst_0",				0x09, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "lconst_1",				0x0a, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "fconst_0",				0x0b, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "fconst_1",				0x0c, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "fconst_2",				0x0d, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "dconst_0",				0x0e, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "dconst_1",				0x0f, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "bipush",				0x10, 1, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "sipush",				0x11, 2, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "ldc",				0x12, 1, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "ldc_w",				0x13, 2, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "ldc2_w",				0x14, 2, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iload",				0x15, 1, 0, 1, (CF_FLAGS | CF_CAN_BE_WIDE)                                        },
  { "lload",				0x16, 1, 0, 1, (CF_FLAGS | CF_CAN_BE_WIDE)                                        },
  { "fload",				0x17, 1, 0, 1, (CF_FLAGS | CF_CAN_BE_WIDE)                                        },
  { "dload",				0x18, 1, 0, 1, (CF_FLAGS | CF_CAN_BE_WIDE)                                        },
  { "aload",				0x19, 1, 0, 1, (CF_FLAGS | CF_CAN_BE_WIDE)                                        },
  { "iload_0",				0x1a, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iload_1",				0x1b, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iload_2",				0x1c, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iload_3",				0x1d, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "lload_0",				0x1e, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "lload_1",				0x1f, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "lload_2",				0x20, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "lload_3",				0x21, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "fload_0",				0x22, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "fload_1",				0x23, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "fload_2",				0x24, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "fload_3",				0x25, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "dload_0",				0x26, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "dload_1",				0x27, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "dload_2",				0x28, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "dload_3",				0x29, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "aload_0",				0x2a, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "aload_1",				0x2b, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "aload_2",				0x2c, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "aload_3",				0x2d, 0, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "iaload",				0x2e, 0, 2, 1, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "laload",				0x2f, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "faload",				0x30, 0, 2, 1, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "daload",				0x31, 0, 2, 1, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "aaload",				0x32, 0, 2, 1, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "baload",				0x33, 0, 2, 1, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "caload",				0x34, 0, 2, 1, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "saload",				0x35, 0, 2, 1, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "istore",				0x36, 1, 1, 0, (CF_FLAGS | CF_CAN_BE_WIDE)                                        },
  { "lstore",				0x37, 1, 1, 0, (CF_FLAGS | CF_CAN_BE_WIDE)                                        },
  { "fstore",				0x38, 1, 1, 0, (CF_FLAGS | CF_CAN_BE_WIDE)                                        },
  { "dstore",				0x39, 1, 1, 0, (CF_FLAGS | CF_CAN_BE_WIDE)                                        },
  { "astore",				0x3a, 1, 1, 0, (CF_FLAGS | CF_CAN_BE_WIDE)                                        },
  { "istore_0",				0x3b, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "istore_1",				0x3c, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "istore_2",				0x3d, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "istore_3",				0x3e, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "lstore_0",				0x3f, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "lstore_1",				0x40, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "lstore_2",				0x41, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "lstore_3",				0x42, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "fstore_0",				0x43, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "fstore_1",				0x44, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "fstore_2",				0x45, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "fstore_3",				0x46, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "dstore_0",				0x47, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "dstore_1",				0x48, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "dstore_2",				0x49, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "dstore_3",				0x4a, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "astore_0",				0x4b, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "astore_1",				0x4c, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "astore_2",				0x4d, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "astore_3",				0x4e, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "iastore",				0x4f, 0, 3, 0, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "lastore",				0x50, 0, 3, 0, (CF_FLAGS), 0, 0                                                         },
  { "fastore",				0x51, 0, 3, 0, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "dastore",				0x52, 0, 3, 0, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "aastore",				0x53, 0, 3, 0, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC | CF_ASTOR_EXC)            },
  { "bastore",				0x54, 0, 3, 0, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "castore",				0x55, 0, 3, 0, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "sastore",				0x56, 0, 3, 0, (CF_FLAGS | CF_NULLP_EXC | CF_AINDX_EXC)                           },
  { "pop",				0x57, 0, 1, 0, (CF_FLAGS), 0, 0                                                         },
  { "pop2",				0x58, 0, 2, 0, (CF_FLAGS), 0, 0                                                         },
  { "dup",				0x59, 0, 1, 2, (CF_FLAGS), 0, 0                                                         },
  { "dup_x1",				0x5a, 0, 2, 3, (CF_FLAGS), 0, 0                                                         },
  { "dup_x2",				0x5b, 0, 3, 4, (CF_FLAGS), 0, 0                                                         },
  { "dup2",				0x5c, 0, 2, 4, (CF_FLAGS), 0, 0                                                         },
  { "dup2_x1",				0x5d, 0, 3, 4, (CF_FLAGS), 0, 0                                                         },
  { "dup2_x2",				0x5e, 0, 4, 6, (CF_FLAGS), 0, 0                                                         },
  { "swap",				0x5f, 0, 2, 2, (CF_FLAGS), 0, 0                                                         },
  { "iadd",				0x60, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "ladd",				0x61, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "fadd",				0x62, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "dadd",				0x63, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "isub",				0x64, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "lsub",				0x65, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "fsub",				0x66, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "dsub",				0x67, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "imul",				0x68, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "lmul",				0x69, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "fmul",				0x6a, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "dmul",				0x6b, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "idiv",				0x6c, 0, 2, 1, (CF_FLAGS | CF_ARITH_EXC)                                          },
  { "ldiv",				0x6d, 0, 2, 1, (CF_FLAGS | CF_ARITH_EXC)                                          },
  { "fdiv",				0x6e, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "ddiv",				0x6f, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "irem",				0x70, 0, 2, 1, (CF_FLAGS | CF_ARITH_EXC)                                          },
  { "lrem",				0x71, 0, 2, 1, (CF_FLAGS | CF_ARITH_EXC)                                          },
  { "frem",				0x72, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "drem",				0x73, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "ineg",				0x74, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "lneg",				0x75, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "fneg",				0x76, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "dneg",				0x77, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "ishl",				0x78, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "lshl",				0x79, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "ishr",				0x7a, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "lshr",				0x7b, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "iushr",				0x7c, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "lushr",				0x7d, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "iand",				0x7e, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "land",				0x7f, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "ior",				0x80, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "lor",				0x81, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "ixor",				0x82, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "lxor",				0x83, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "iinc",				0x84, 2, 0, 0, (CF_FLAGS | CF_CAN_BE_WIDE)                                        },
  { "i2l",				0x85, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "i2f",				0x86, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "i2d",				0x87, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "l2i",				0x88, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "l2f",				0x89, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "l2d",				0x8a, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "f2i",				0x8b, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "f2l",				0x8c, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "f2d",				0x8d, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "d2i",				0x8e, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "d2l",				0x8f, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "d2f",				0x90, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "i2b",				0x91, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "i2c",				0x92, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "i2s",				0x93, 0, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "lcmp",				0x94, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "fcmpl",				0x95, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "fcmpg",				0x96, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "dcmpl",				0x97, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "dcmpg",				0x98, 0, 2, 1, (CF_FLAGS), 0, 0                                                         },
  { "ifeq",				0x99, 2, 1, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "ifne",				0x9a, 2, 1, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "iflt",				0x9b, 2, 1, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "ifge",				0x9c, 2, 1, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "ifgt",				0x9d, 2, 1, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "ifle",				0x9e, 2, 1, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "if_icmpeq",			0x9f, 2, 2, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "if_icmpne",			0xa0, 2, 2, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "if_icmplt",			0xa1, 2, 2, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "if_icmpge",			0xa2, 2, 0, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "if_icmpgt",			0xa3, 2, 2, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "if_icmple",			0xa4, 2, 2, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "if_acmpeq",			0xa5, 2, 2, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "if_acmpne",			0xa6, 2, 2, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "goto",				0xa7, 2, 0, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "jsr",				0xa8, 2, 0, 1, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "ret",				0xa9, 1, 0, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "tableswitch",			0xaa, 0, 1, 0, (CF_FLAGS | CF_VAR_ARGUMENTS | CF_BASIC_BLOCK)                     },
  { "lookupswitch",			0xab, 0, 1, 0, (CF_FLAGS | CF_VAR_ARGUMENTS | CF_BASIC_BLOCK)                     },
  { "ireturn",				0xac, 0, 1, 0, (CF_FLAGS | CF_END | CF_ILMON_EXC)                                 },
  { "lreturn",				0xad, 0, 1, 0, (CF_FLAGS | CF_END | CF_ILMON_EXC)                                 },
  { "freturn",				0xae, 0, 1, 0, (CF_FLAGS | CF_END | CF_ILMON_EXC)                                 },
  { "dreturn",				0xaf, 0, 1, 0, (CF_FLAGS | CF_END | CF_ILMON_EXC)                                 },
  { "areturn",				0xb0, 0, 1, 0, (CF_FLAGS | CF_END | CF_ILMON_EXC)                                 },
  { "vreturn",				0xb1, 0, 0, 0, (CF_FLAGS | CF_END | CF_ILMON_EXC)                                 },
  { "getstatic",			0xb2, 2, 0, 1, (CF_FLAGS | CF_ERROR_EXC)                                          },
  { "putstatic",			0xb3, 2, 1, 0, (CF_FLAGS | CF_ERROR_EXC)                                          },
  { "getfield",				0xb4, 2, 1, 1, (CF_FLAGS | CF_NULLP_EXC)                                          },
  { "putfield",				0xb5, 2, 2, 0, (CF_FLAGS | CF_NULLP_EXC)                                          },
  { "invokevirtual",			0xb6, 2, 0, 0, (CF_FLAGS | CF_VAR_STACK | CF_INVOKE)                              },
  { "invokespecial",			0xb7, 2, 0, 0, (CF_FLAGS | CF_VAR_STACK | CF_INVOKE)                              },
  { "invokestatic",			0xb8, 2, 0, 0, (CF_FLAGS | CF_VAR_STACK | CF_INVOKE)                              },
  { "invokeinterface",			0xb9, 4, 0, 0, (CF_FLAGS | CF_VAR_STACK | CF_INVOKE)                              },
  { "no_code26",			0xba, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "new",				0xbb, 2, 0, 1, (CF_FLAGS), 0, 0                                                         },
  { "newarray",				0xbc, 1, 1, 1, (CF_FLAGS | CF_ANEGS_EXC)                                          },
  { "anewarray",			0xbd, 2, 1, 1, (CF_FLAGS | CF_ANEGS_EXC)                                          },
  { "arraylength",			0xbe, 0, 1, 1, (CF_FLAGS | CF_NULLP_EXC)                                          },
  { "athrow",				0xbf, 0, 1, 1, (CF_FLAGS | CF_NULLP_EXC)                                          },
  { "checkcast",			0xc0, 2, 1, 1, (CF_FLAGS | CF_CLCST_EXC)                                          },
  { "instanceof",			0xc1, 2, 1, 1, (CF_FLAGS), 0, 0                                                         },
  { "monitorenter",			0xc2, 0, 1, 0, (CF_FLAGS | CF_NULLP_EXC)                                          },
  { "monitorexit",			0xc3, 0, 1, 0, (CF_FLAGS | CF_NULLP_EXC | CF_ILMON_EXC)                           },
  { "wide",				0xc4, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "multianewarray",			0xc5, 3, 0, 1, (CF_FLAGS | CF_VAR_STACK | CF_AINDX_EXC)                           },
  { "ifnull",				0xc6, 2, 1, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "ifnonnull",			0xc7, 2, 1, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "goto_w",				0xc8, 4, 0, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "jsr_w",				0xc9, 4, 0, 0, (CF_FLAGS | CF_BASIC_BLOCK)                                        },
  { "breakpoint",			0xca, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "ldc_quick",			0xcb, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "ldc_w_quick",			0xcc, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "ldc2_w_quick",			0xcd, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "getfield_quick",			0xce, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "putfield_quick",			0xcf, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "getfield2_quick",			0xd0, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "putfield2_quick",			0xd1, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "getstatic_quick",			0xd2, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "putstatic_quick",			0xd3, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "getstatic2_quick",			0xd4, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "putstatic2_quick",			0xd5, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "invokevirtual_quick",		0xd6, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "invokenonvirtual_quick",		0xd7, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "invokesuper_quick",		0xd8, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "invokestatic_quick",		0xd9, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "invokeinterface_quick",		0xda, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "invokevirtualobject_quick",	0xdb, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "new_quick",			0xdd, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "anewarray_quick",			0xde, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "multianewarray_quick",		0xdf, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "checkcast_quick",			0xe0, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "instanceof_quick",			0xe1, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "invokevirtual_quick_w",		0xe2, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "getfield_quick_w",			0xe3, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "putfield_quick_w",			0xe4, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },

  { "no_code01",			0xe5, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code02",			0xe6, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code03",			0xe7, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code04",			0xe8, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code05",			0xe9, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code06",			0xea, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code07",			0xeb, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code08",			0xec, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code09",			0xed, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code10",			0xee, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code11",			0xef, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code12",			0xf0, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code13",			0xf1, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code14",			0xf2, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code15",			0xf3, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code16",			0xf4, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code17",			0xf5, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code18",			0xf6, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code19",			0xf7, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code20",			0xf8, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code21",			0xf9, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code22",			0xfa, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code23",			0xfb, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code24",			0xfc, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "no_code25",			0xfd, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
    
  { "impdep1",				0xfe, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
  { "impdep2",				0xff, 0, 0, 0, (CF_FLAGS), 0, 0                                                         },
};

